const mongoose = require("mongoose");

const TableName = "amsAttendance";

const TableSchema = mongoose.Schema({
    username: {
        type: String,
        trim: true,
        index: true
    },
    logType: {
        type: String,
        trim: true
    },
    accessType: {
        type: String,
        trim: true
    },
    geolocation: {
        type: JSON,
        trim: true
    },
    imgSrc: {
        type: String,
        trim: true
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    approvedBy: {
        type: String
    },
    client: {
        type: String
    },
    clientKind: {
        type: String
    },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
