const mongoose = require("mongoose");

const TableName = "amsUser";

const TableSchema = mongoose.Schema({
    name: {
        type: String,
        trim: true
    },
    username: {
        type: String,
        trim: true,
        required: [true, "Username is required"],
        unique: true
    },
    password: {
        type: String,
        default: 123456789,
        trim: true,
        required: [true, "Password is required"]
    },
    dob: {
        type: String,
        trim: true
    },
    email: {
        type: String,
        trim: true
    },
    mobile: {
        type: String,
        trim: true
    },
    gender: {
        type: String,
        trim: true
    },
    employee_code: {
        type: String,
        trim: true
    },
    client: {
        type: Array,
        trim: true,
        default: []
    },
    companies: {
        type: Array,
        default: []
    },
    offices: {
        type: Array,
        default: []
    },
    imei: {
        type: String,
        lowercase: true,
        trim: true
    },
    role: {
        type: String
    },
    topUser: {
        type: String
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    created_by: String,
    // created_at: {
    //     type: Date
    // },
    // updated_at: {
    //     type: Date
    // },
    updated_by: String
    },
    { timestamps: true }
);

const OldTableSchema = mongoose.Schema({
    name: {
        type: String,
        trim: true
    },
    username: {
        type: String,
        trim: true
    },
    password: {
        type: String,
        trim: true
    },
    dob: {
        type: String,
        trim: true
    },
    email: {
        type: String,
        trim: true
    },
    mobile: {
        type: String,
        trim: true
    },
    gender: {
        type: String,
        trim: true
    },
    employee_code: {
        type: String,
        trim: true
    },
    client: {
        type: String,
        trim: true
    },
    companies: {
        type: Array,
        default: []
    },
    offices: {
        type: Array,
        default: []
    },
    role: {
        type: String
    },
    isCoreRule: {
        type: Boolean,
        default: false
    },
    status: {
        type: String,
        default: "Y"
    },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();


module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
module.exports.addUser = (newUser, callback) => {
  newUser.save(callback);
};
module.exports.getUserByUsername = (username, callback) => {
  TableModel.findOne({ username: username }, callback);
};
