const mongoose = require("mongoose");

const TableName = "ErrorLog";

const TableSchema = mongoose.Schema({
    message: {
        type: String
    },
    error: {
        type: JSON
    },
    status: {
        type: String,
        default: "N"
    },
    created_at: {
        type: Date
    },
    created_by: String,
    updated_at: {
        type: Date
    },
    updated_by: String
});

const TableModel = mongoose.model(TableName, TableSchema);

const OldTableModel = mongoose.model("old" + TableName, TableSchema);

TableModel.createIndexes();
OldTableModel.createIndexes();

TableModel.ensureIndexes();
OldTableModel.ensureIndexes();

module.exports = {
    TableName,
    TableModel,
    OldTableModel
}
