const city = require("./../models/city1");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newCity = new city({
    city_id: req.body.city_id,
    city_name: req.body.city_name,
    city_slug: req.body.city_slug,
    city_state_id: req.body.city_state_id,
    city_country_id: req.body.city_country_id,
    city_order: req.body.city_order,
    city_cost1: req.body.city_cost1,
    city_cost2: req.body.city_cost2,
    city_added_by: req.body.city_added_by,
    city_is_deleted: req.body.city_is_deleted,
    city_status: req.body.city_status,
    city_state_name: req.body.city_state_name
  });
  city.addCity(newCity, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "City added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
    // Initialize all inputs
    const id= req.body._id;
  city.getCity(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      }else{
          rc.setResponse(res, {
              msg: 'No data found by this id'
          })
      }
    }
  });
};
module.exports.getByName = (req, res)=>{
  let query = req.body.query;
  city.getCitiesByName(query, (err, scity)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {

        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: scity
        });
      
    }
  })
}
module.exports.getAll=(req, res)=>{
    city.getAllCity((err, data)=>{
        if(err){
            rc.setResponse(res,{
                msg: err.message,
                data: err
            })
        }else{
            if(data){
                rc.setResponse(res, {
                    success: true,
                    msg: 'All data fetched successfully',
                    data: data
                })
            }else{
                rc.setResponse(res,{
                    msg: 'No data present'
                })
            }
        }
    })
}
module.exports.update = (req, res) => {
    const id= req.body._id;

  city.getCity(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        data.lastChanges = {};

        if (req.body.city_name) {
          isChange = true;
          data.lastChanges.city_name = data.city_name;
          data.city_name = req.body.city_name;
        }
        if (req.body.city_slug) {
          isChange = true;
          data.lastChanges.city_slug = data.city_slug;
          data.city_slug = req.body.city_slug;
        }
        if (req.body.city_state_id) {
          isChange = true;
          data.lastChanges.city_state_id = data.city_state_id;
          data.city_state_id = req.body.city_state_id;
        }
        if (req.body.city_country_id) {
          isChange = true;
          data.lastChanges.city_country_id = data.city_country_id;
          data.city_country_id = req.body.city_country_id;
        }
        if (req.body.city_order) {
          isChange = true;
          data.lastChanges.city_order = data.city_order;
          data.city_order = req.body.city_order;
        }
        if (req.body.city_cost1) {
          isChange = true;
          data.lastChanges.city_cost1 = data.city_cost1;
          data.city_cost1 = req.body.city_cost1;
        }
        if (req.body.city_cost2) {
          isChange = true;
          data.lastChanges.city_cost2 = data.city_cost2;
          data.city_cost2 = req.body.city_cost2;
        }
        if (req.body.city_added_by) {
          isChange = true;
          data.lastChanges.city_added_by = data.city_added_by;
          data.city_added_by = req.body.city_added_by;
        }
        if (req.body.city_is_deleted) {
          isChange = true;
          data.lastChanges.city_is_deleted = data.city_is_deleted;
          data.city_is_deleted = req.body.city_is_deleted;
        }
        if (req.body.city_status) {
          isChange = true;
          data.lastChanges.city_status = data.city_status;
          data.city_status = req.body.city_status;
        }
        if (req.body.city_state_name) {
          isChange = true;
          data.lastChanges.city_state_name = data.city_state_name;
          data.city_state_name = req.body.city_state_name;
        }
        if (isChange) {
          city.addCity(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
    const id= req.body._id;
  city.deleteCity(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
