const Ad = require("./../models/ad");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newAd = new Ad({
    title: req.body.title,
    description: req.body.description,
    image: req.body.image,
    size: req.body.size,
    providedBy: req.body.providedBy
  });
  Ad.addAd(newAd, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      })
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Ad added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.params.id;
  Ad.getAd(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  Ad.getAllAds((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  Ad.getAd(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        if (req.body.title) {
          isChange = true;
          data.title = req.body.title
        }
        if (req.body.description) {
          isChange = true;
          data.description = req.body.description
        }
        if (req.body.image) {
          isChange = true;
          data.image = req.body.image
        }
        if (req.body.size) {
          isChange = true;
          data.size = req.body.size
        }
        if (req.body.providedBy) {
          isChange = true;
          data.providedBy = req.body.providedBy
        }
        if (isChange) {
          Ad.addAd(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  Ad.deleteAd(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
