const country = require("./../models/country1.js");
const rc = require("./../controllers/responseController");

module.exports.add = (req, res) => {
  let newCountry = new country({
    country_id: req.body.country_id,
    country_name: req.body.country_name,
    country_currency_code: req.body.country_currency_code,
    country_isd_code: req.body.country_isd_code,
    country_flag: req.body.country_flag,
    country_order: req.body.country_order,
    country_added_by: req.body.country_added_by,
    country_is_deleted: req.body.country_is_deleted,
    country_created_on: req.body.country_created_on,
    country_status: req.body.country_status
  });
  country.addCountry(newCountry, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  country.getCountry(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  country.getAllCountry((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res) => {
  const id = req.body._id;
  country.getCountry(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        isChange = false;
        data.lastChanges = {};
        if (req.body.country_name) {
          isChange = true;
          data.lastChanges.country_name = data.country_name;
          data.country_name = req.body.country_name;
        }
        if (req.body.country_currency_code) {
          isChange = true;
          data.lastChanges.country_currency_code = data.country_currency_code;
          data.country_currency_code = req.body.country_currency_code;
        }
        if (req.body.country_isd_code) {
          isChange = true;
          data.lastChanges.country_isd_code = data.country_isd_code;
          data.country_isd_code = req.body.country_isd_code;
        }
        if (req.body.country_flag) {
          isChange = true;
          data.lastChanges.country_flag = data.country_flag;
          data.country_flag = req.body.country_flag;
        }
        if (req.body.country_order) {
          isChange = true;
          data.lastChanges.country_order = data.country_order;
          data.country_order = req.body.country_order;
        }
        if (req.body.country_is_deleted) {
          isChange = true;
          data.lastChanges.country_is_deleted = data.country_is_deleted;
          data.country_is_deleted = req.body.country_is_deleted;
        }
        if (req.body.country_status) {
          isChange = true;
          data.lastChanges.country_status = data.country_status;
          data.country_status = req.body.country_status;
        }

        if (isChange) {
          data.country_updated_on = Date.now();
          data.country_updated_by = req.body.username;
          country.addCountry(data, (err, updatedData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Data updated successfully",
                data: updatedData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No changes provided"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.body._id;
  country.deleteCountry(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
