const gotra = require("./../models/gotra");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newGotra = new gotra({
    gotra_id: req.body.gotra_id,
    gotra_name: req.body.gotra_name,
    gotra_slug: req.body.gotra_slug,
    gotra_religion_name: req.body.gotra_religion_name,
    gotra_caste_name: req.body.gotra_caste_name,
    gotra_sub_caste_name: req.body.gotra_sub_caste_name,
    gotra_added_by: req.body.gotra_added_by,
    gotra_updated_by: req.body.gotra_updated_by,
    gotra_created_on: req.body.gotra_created_on,
    gotra_is_deleted: req.body.gotra_is_deleted,
    gotra_updated_on: req.body.gotra_updated_on,
    gotra_order: req.body.gotra_order,
    gotra_status: req.body.gotra_status
  });
  gotra.addGotra(newGotra, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Gotra added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  gotra.getGotra(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByName = (req, res) => {
  let query = req.body.query;
  gotra.getCitiesByName(query, (err, sgotra) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "data fetched successfully",
        data: sgotra
      });
    }
  });
};
module.exports.getAll = (req, res) => {
  gotra.getAllGotra((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  gotra.getGotra(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        data.lastChanges = {};

        if (req.body.gotra_name) {
          isChange = true;
          data.lastChanges.gotra_name = data.gotra_name;
          data.gotra_name = req.body.gotra_name;
        }

        if (req.body.gotra_slug) {
          isChange = true;
          data.lastChanges.gotra_slug = data.gotra_slug;
          data.gotra_slug = req.body.gotra_slug;
        }
        if (req.body.gotra_religion_name) {
          isChange = true;
          data.lastChanges.gotra_religion_name = data.gotra_religion_name;
          data.gotra_religion_name = req.body.gotra_religion_name;
        }
        if (req.body.gotra_caste_name) {
          isChange = true;
          data.lastChanges.gotra_caste_name = data.gotra_caste_name;
          data.gotra_caste_name = req.body.gotra_caste_name;
        }
        if (req.body.gotra_sub_caste_name) {
          isChange = true;
          data.lastChanges.gotra_sub_caste_name = data.gotra_sub_caste_name;
          data.gotra_sub_caste_name = req.body.gotra_sub_caste_name;
        }

        if (req.body.gotra_is_deleted) {
          isChange = true;
          data.lastChanges.gotra_is_deleted = data.gotra_is_deleted;
          data.gotra_is_deleted = req.body.gotra_is_deleted;
        }

        if (req.body.gotra_order) {
          isChange = true;
          data.lastChanges.gotra_order = data.gotra_order;
          data.gotra_order = req.body.gotra_order;
        }
        if (req.body.gotra_status) {
          isChange = true;
          data.lastChanges.gotra_status = data.gotra_status;
          data.gotra_status = req.body.gotra_status;
        }
        if (isChange) {
            data.gotra_updated_on = Date.now();
          gotra.addGotra(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  gotra.deleteGotra(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
