const MemberMaster = require("../models/member-master");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newMemberMaster = new MemberMaster({
   master_name: req.body.master_name,
   values: req.body.values,
   member_field: req.body.member_field,
   input_type: req.body.input_type
  });
  MemberMaster.add(newMemberMaster, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Master added successfully",
        data: data
      });
    }
  });
};



module.exports.get = (req, res) => {
    const id = req.params._id;
  MemberMaster.get(id,(err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  MemberMaster.getAll((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  MemberMaster.get(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        if(req.body.master_name){
            isChange = true,
            data.master_name = req.body.master_name
        }
        if(req.body.values){
            isChange = true,
            data.values = req.body.values
        }
        if(req.body.member_field){
            isChange = true,
            data.member_field = req.body.member_field
        }
        if(req.body.input_type){
            isChange = true,
            data.input_type = req.body.input_type
        }
    
        if (isChange) {
          MemberMaster.add(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  MemberMaster.delete(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
