const newMember = require("./../models/new_member");
const oldMember = require("./../models/member1");
const rc = require("./responseController");
const bcrypt = require("bcryptjs");
const ssMembers = require("./../models/shaadiSammelanMembers");

const Counter = require("./../models/counter");

const Lead = require("./../models/lead");


module.exports.addNewestMember = (req, res) => {
  res.json({ msg: "started" });
  console.log("started...");
  console.log("getting members with projection...");
  oldMember.getMembersWithProj((err, data) => {
    console.log("members fetched with projection...");
    if (err) throw err;
    else {
      console.log("data recieved...");
      if (data.length) {
        newMember.insertMany(data, (err, data1) => {
          if (err) throw err;
          else {
            console.log("added");
          }
        });
      }
    }
  });
};
module.exports.getMember = (req, res) => {
  const id = req.params._id;
  newMember.getMember(id, (err, member) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in fetching member",
        data: err
      });
    } else {
      if (member) {
        rc.setResponse(res, {
          success: true,
          msg: "Member fetched successfully",
          data: member
        });
      } else {
        rc.setResponse(res, {
          msg: "No member found by this id"
        });
      }
    }
  });
};

module.exports.getAllMembers = (req, res) => {
  const skip = parseInt(req.params.page * 20) - 20;
  const sort = req.params.sort;
  newMember.getAllMembers(sort, skip, (err, members) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Erron in retrieving new members",
        data: members
      });
    } else {
      if (members) {
        newMember.getAllMembersCount((err, count) => {
          if (err) {
            rc.setResponse(res, {
              msg: "Erron in new member count",
              data: members
            });
          } else {
            rc.setResponse(res, {
              success: true,
              msg: "All new members fetched successfully",
              data: {
                data: members,
                count: count
              }
            });
          }
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found"
        });
      }
    }
  });
};
module.exports.getLessPlanMembers = (req, res) => {
  newMember.getLessPlanMembers((err, members) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in getting less plan members"
      });
    } else {
      if (members.length) {
        ssMembers.insertMany(members, (err, data) => {
          if (err) throw err;
          else {
            rc.setResponse(res, {
              success: true,
              msg: "Member with less plan fetched and inserted successfully",
              data: data
            });
          }
        });
      } else {
        rc.setResponse(res, {
          msg: " No members found with less plan"
        });
      }
    }
  });
};
module.exports.getLessPlanMemberIdsFunc = (req, res) => {
  newMember.getLessPlanMemberIds((err, ids) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in fetching ids",
        data: err
      });
    } else {
      if (ids) {
        newMember.getLessPlanMemberIdsCount((err, count) => {
          if (err) {
            rc.setResponse(res, {
              msg: "Error in counting documents",
              data: err
            });
          } else {
            rc.setResponse(res, {
              success: true,
              msg: "All data fetched successfully with counting",
              data: {
                data: ids,
                count: count
              }
            });
          }
        });
      }
    }
  });
};

module.exports.searchNewMember = (req, res) => {
  const skip = parseInt(req.params.page * 50) - 50;

  const keywords = req.params.keyword.split(" ");
  const keywordsRegex = [];
  for (let i = 0; i < keywords.length; i++) {
    const elem = keywords[i];
    const tempregex = new RegExp(elem, "gi");
    keywordsRegex.push(tempregex);
  }
  newMember.searchNewMembers(skip, keywordsRegex, (err, results) => {
    if (err) {
      rc.setResponse(res, {
        msg: "erron in fetching members",
        data: err
      });
    } else {
      newMember.searchNewMembersCount(keywordsRegex, (err, count) => {
        if (err) {
          rc.setResponse(res, {
            msg: "erron in counting",
            data: err
          });
        } else {
          rc.setResponse(res, {
            success: true,
            msg: "successful",
            data: {
              data: results,
              count: count
            }
          });
        }
      });
    }
  });
};
module.exports.getAllFilters = (req, res) => {
  religion.getAllReligionNames((err, religions) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      caste.getAllCasteNames((err, castes) => {
        if (err) {
          rc.setResponse(res, {
            msg: err.message,
            data: err
          });
        } else {
          education.getEducationDetailNames((err, eduDetails) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              motherTongue.getAllMother_tongueNames((err, motherTongues) => {
                if (err) {
                  rc.setResponse(res, {
                    msg: err.message,
                    data: err
                  });
                } else {
                  familyAnnualIncome.getFamilyIncomeNames(
                    (err, familyIncomes) => {
                      if (err) {
                        rc.setResponse(res, {
                          msg: err.message,
                          data: err
                        });
                      } else {
                        state.getAllStateNames((err, states) => {
                          if (err) {
                            rc.setResponse(res, {
                              msg: err.message,
                              data: err
                            });
                          } else {
                            city.getAllCityNames((err, cities) => {
                              if (err) {
                                rc.setResponse(res, {
                                  msg: err.message,
                                  data: err
                                });
                              } else {
                                rc.setResponse(res, {
                                  success: true,
                                  msg: "All data fetched successfully",
                                  data: {
                                    religions: religions,
                                    castes: castes,
                                    education: eduDetails,
                                    motherTongues: motherTongues,
                                    familyAnnualIncome: familyIncomes,
                                    states: states,
                                    cities: cities
                                  }
                                });
                              }
                            });
                          }
                        });
                      }
                    }
                  );
                }
              });
            }
          });
        }
      });
    }
  });
};

module.exports.getFilteredMembers = (req, res) => {
  let filter = {};
  let choosenfilter = {};
  const skip = parseInt(req.params.page) * 50 - 50;
  const sort = req.params.sort;
  filter.genders = req.body.choosenFilter.genders;
  filter.religions = req.body.choosenFilter.religions;
  filter.castes = req.body.choosenFilter.castes;
  filter.educations = req.body.choosenFilter.educations;
  filter.motherTongues = req.body.choosenFilter.motherTongues;
  filter.familyIncomes = req.body.choosenFilter.familyIncomes;
  filter.states = req.body.choosenFilter.states;
  filter.cities = req.body.choosenFilter.cities;

  filter.genders.length
    ? (choosenfilter.genders = filter.genders)
    : (choosenfilter.genders = []);
  filter.religions.length
    ? (choosenfilter.religions = filter.religions)
    : (choosenfilter.religions = []);
  filter.castes.length
    ? (choosenfilter.castes = filter.castes)
    : (choosenfilter.castes = []);
  filter.educations.length
    ? (choosenfilter.educations = filter.educations)
    : (choosenfilter.educations = []);
  filter.motherTongues.length
    ? (choosenfilter.motherTongues = filter.motherTongues)
    : (choosenfilter.motherTongues = []);
  filter.familyIncomes.length
    ? (choosenfilter.familyIncomes = filter.familyIncomes)
    : (choosenfilter.familyIncomes = []);
  filter.states.length
    ? (choosenfilter.states = filter.states)
    : (choosenfilter.states = []);
  filter.cities.length
    ? (choosenfilter.cities = filter.cities)
    : (choosenfilter.cities = []);
  newMember.getFilteredMembers(
    skip,
    sort,
    choosenfilter,
    (err, filtMembers) => {
      if (err) {
        rc.setResponse(res, {
          msg: "Error in filtering",
          data: err
        });
      } else {
        if (filtMembers) {
          newMember.getFilteredCounts(choosenfilter, (err, count) => {
            if (err) {
              rc.setResponse(res, {
                msg: "Error in counting",
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Filtered fetched successfully",
                data: {
                  data: filtMembers,
                  count: count
                }
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data found"
          });
        }
      }
    }
  );
};
module.exports.getMemberByMemberId = (req, res) => {
  const id = req.params.id;

  newMember.searchByMemberId(id, (err, member) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in fetching member",
        data: err
      });
    } else {
      if (member) {
        rc.setResponse(res, {
          success: true,
          msg: "Member found",
          data: member
        });
      } else {
        rc.setResponse(res, {
          msg: " No member found by this id"
        });
      }
    }
  });
};
module.exports.updateMember = (req, res) => {
  const id = req.body._id;
  newMember.getMember(id, (err, member) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in fetching member",
        data: member
      });
    } else {
      if (member) {
        isChange = false;
      if(req.body.member_id){
        isChange = true;
        member.member_id=req.body.member_id

      }
      if(req.body.member_profile_created_for){
        isChange = true;
        member.member_profile_created_for=req.body.member_profile_created_for

      }
      if(req.body.member_first_name){
        isChange = true;
        member.member_first_name=req.body.member_first_name

      }
      if(req.body.member_middle_name){
        isChange = true;
        member.member_middle_name=req.body.member_middle_name

      }
      if(req.body.member_last_name){
        isChange = true;
        member.member_last_name=req.body.member_last_name

      }
      if(req.body.member_name){
        isChange = true;
        member.member_name=req.body.member_name

      }
      if(req.body.member_is_updated){
        isChange = true;
        member.member_is_updated=req.body.member_is_updated

      }
      if(req.body.member_slug){
        isChange = true;
        member.member_slug=req.body.member_slug

      }
      if(req.body.member_mobile){
        isChange = true;
        member.member_mobile=req.body.member_mobile

      }
      if(req.body.member_email){
        isChange = true;
        member.member_email=req.body.member_email

      }
      if(req.body.member_religion_name){
        isChange = true;
        member.member_religion_name=req.body.member_religion_name

      }
      if(req.body.member_caste_name){
        isChange = true;
        member.member_caste_name=req.body.member_caste_name

      }
      if(req.body.member_sub_caste_name){
        isChange = true;
        member.member_sub_caste_name=req.body.member_sub_caste_name

      }
      if(req.body.member_gender){
        isChange = true;
        member.member_gender=req.body.member_gender

      }
      if(req.body.member_dob){
      isChange = true;
    member.member_dob=req.body.member_dob
  }
      if(req.body.member_weight){
      isChange = true;
    member.member_weight=req.body.member_weight
  }
      if(req.body.member_height){
      isChange = true;
    member.member_height=req.body.member_height
  }
      if(req.body.member_complextion){
      isChange = true;
    member.member_complextion=req.body.member_complextion
  }
      if(req.body.member_meritial_status){
      isChange = true;
    member.member_meritial_status=req.body.member_meritial_status
  }
      if(req.body.member_children_status){
      isChange = true;
    member.member_children_status=req.body.member_children_status
  }
      if(req.body.member_total_children){
      isChange = true;
    member.member_total_children=req.body.member_total_children
  }
      if(req.body.member_age_eldest_children){
      isChange = true;
    member.member_age_eldest_children=req.body.member_age_eldest_children
  }
      if(req.body.member_eating_habits){
      isChange = true;
    member.member_eating_habits=req.body.member_eating_habits
  }
      if(req.body.member_drinking_habits){
      isChange = true;
    member.member_drinking_habits=req.body.member_drinking_habits
  }
      if(req.body.member_smoking_habits){
      isChange = true;
    member.member_smoking_habits=req.body.member_smoking_habits
  }
      if(req.body.member_hobby){
      isChange = true;
    member.member_hobby=req.body.member_hobby
  }
      if(req.body.member_body_type){
      isChange = true;
    member.member_body_type=req.body.member_body_type
  }
      if(req.body.member_special_case){
      isChange = true;
    member.member_special_case=req.body.member_special_case
  }
      if(req.body.member_special_case_details){
      isChange = true;
    member.member_special_case_details=req.body.member_special_case_details
  }
      if(req.body.member_residencial_status){
      isChange = true;
    member.member_residencial_status=req.body.member_residencial_status
  }
      if(req.body.member_mother_tongue){
      isChange = true;
    member.member_mother_tongue=req.body.member_mother_tongue
  }
      if(req.body.member_own_house_status){
      isChange = true;
    member.member_own_house_status=req.body.member_own_house_status
  }
      if(req.body.member_annual_income){
      isChange = true;
    member.member_annual_income=req.body.member_annual_income
  }
      if(req.body.member_education_details){
      isChange = true;
    member.member_education_details=req.body.member_education_details
  }
      if(req.body.member_collage_passout){
      isChange = true;
    member.member_collage_passout=req.body.member_collage_passout
  }
      if(req.body.member_professional_status){
      isChange = true;
    member.member_professional_status=req.body.member_professional_status
  }
      if(req.body.member_professional_details){
      isChange = true;
    member.member_professional_details=req.body.member_professional_details
  }
      if(req.body.member_working_location){
      isChange = true;
    member.member_working_location=req.body.member_working_location
  }
      if(req.body.member_visa_status){
      isChange = true;
    member.member_visa_status=req.body.member_visa_status
  }
      if(req.body.member_father_name){
      isChange = true;
    member.member_father_name=req.body.member_father_name
  }
      if(req.body.member_father_occupation){
      isChange = true;
    member.member_father_occupation=req.body.member_father_occupation
  }
      if(req.body.member_father_occupation_details){
      isChange = true;
    member.member_father_occupation_details=req.body.member_father_occupation_details
  }
      if(req.body.member_mother_name){
      isChange = true;
    member.member_mother_name=req.body.member_mother_name
  }
      if(req.body.member_mother_occupation){
      isChange = true;
    member.member_mother_occupation=req.body.member_mother_occupation
  }
      if(req.body.member_mother_occupation_details){
      isChange = true;
    member.member_mother_occupation_details=req.body.member_mother_occupation_details
  }
      if(req.body.member_family_status){
      isChange = true;
    member.member_family_status=req.body.member_family_status
  }
      if(req.body.member_family_income){
      isChange = true;
    member.member_family_income=req.body.member_family_income
  }
      if(req.body.member_family_type){
      isChange = true;
    member.member_family_type=req.body.member_family_type
  }
      if(req.body.member_family_values){
      isChange = true;
    member.member_family_values=req.body.member_family_values
  }
      if(req.body.member_relatives_details){
      isChange = true;
    member.member_relatives_details=req.body.member_relatives_details
  }
      if(req.body.member_gotra){
      isChange = true;
    member.member_gotra=req.body.member_gotra
  }
      if(req.body.member_mama_gotra){
      isChange = true;
    member.member_mama_gotra=req.body.member_mama_gotra
  }
      if(req.body.member_rashi){
      isChange = true;
    member.member_rashi=req.body.member_rashi
  }
      if(req.body.member_tob){
      isChange = true;
    member.member_tob=req.body.member_tob
  }
      if(req.body.member_place_of_birth){
      isChange = true;
    member.member_place_of_birth=req.body.member_place_of_birth
  }
      if(req.body.member_manglik){
      isChange = true;
    member.member_manglik=req.body.member_manglik
  }
      if(req.body.member_horoscope_match){
      isChange = true;
    member.member_horoscope_match=req.body.member_horoscope_match
  }
      if(req.body.member_horoscope_file){
      isChange = true;
    member.member_horoscope_file=req.body.member_horoscope_file
  }
      if(req.body.member_namaj_offered){
      isChange = true;
    member.member_namaj_offered=req.body.member_namaj_offered
  }
      if(req.body.member_have_bread){
      isChange = true;
    member.member_have_bread=req.body.member_have_bread
  }
      if(req.body.member_face_covering_girl){
      isChange = true;
    member.member_face_covering_girl=req.body.member_face_covering_girl
  }
      if(req.body.member_jain_day_routine){
      isChange = true;
    member.member_jain_day_routine=req.body.member_jain_day_routine
  }
      if(req.body.member_jain_religion_studies){
      isChange = true;
    member.member_jain_religion_studies=req.body.member_jain_religion_studies
  }
      if(req.body.member_jatadhari_amritdhari_pagdi_sardar){
      isChange = true;
    member.member_jatadhari_amritdhari_pagdi_sardar=req.body.member_jatadhari_amritdhari_pagdi_sardar
  }
      if(req.body.member_sahajdhari_sardar){
      isChange = true;
    member.member_sahajdhari_sardar=req.body.member_sahajdhari_sardar
  }
      if(req.body.member_kripan_dhari){
      isChange = true;
    member.member_kripan_dhari=req.body.member_kripan_dhari
  }
      if(req.body.member_image){
      isChange = true;
    member.member_image=req.body.member_image
  }
      if(req.body.member_family_photo){
      isChange = true;
    member.member_family_photo=req.body.member_family_photo
  }
      if(req.body.member_image_with_aadhar){
      isChange = true;
    member.member_image_with_aadhar=req.body.member_image_with_aadhar
  }
      if(req.body.member_id_card_image){
      isChange = true;
    member.member_id_card_image=req.body.member_id_card_image
  }
      if(req.body.member_password){
      isChange = true;
    member.member_password=req.body.member_password
  }
      if(req.body.member_country_id){
      isChange = true;
    member.member_country_id=req.body.member_country_id
  }
      if(req.body.member_state_id){
      isChange = true;
    member.member_state_id=req.body.member_state_id
  }
      if(req.body.member_city_id){
      isChange = true;
    member.member_city_id=req.body.member_city_id
  }
      if(req.body.member_pincode){
      isChange = true;
    member.member_pincode=req.body.member_pincode
  }
      if(req.body.member_address){
      isChange = true;
    member.member_address=req.body.member_address
  }
      if(req.body.member_p_country_id){
      isChange = true;
    member.member_p_country_id=req.body.member_p_country_id
  }
      if(req.body.member_p_state_id){
      isChange = true;
    member.member_p_state_id=req.body.member_p_state_id
  }
      if(req.body.member_p_city_id){
      isChange = true;
    member.member_p_city_id=req.body.member_p_city_id
  }
      if(req.body.member_p_pincode){
      isChange = true;
    member.member_p_pincode=req.body.member_p_pincode
  }
      if(req.body.member_p_address){
      isChange = true;
    member.member_p_address=req.body.member_p_address
  }
      if(req.body.member_order){
      isChange = true;
    member.member_order=req.body.member_order
  }
      if(req.body.member_added_by){
      isChange = true;
    member.member_added_by=req.body.member_added_by
  }
      if(req.body.member_updated_by){
      isChange = true;
    member.member_updated_by=req.body.member_updated_by
  }
      if(req.body.meber_deleted_by){
      isChange = true;
    member.meber_deleted_by=req.body.meber_deleted_by
  }
      if(req.body.member_is_deleted){
      isChange = true;
    member.member_is_deleted=req.body.member_is_deleted
  }
      if(req.body.member_plan_id){
      isChange = true;
    member.member_plan_id=req.body.member_plan_id
  }
      if(req.body.member_created_on){
      isChange = true;
    member.member_created_on=req.body.member_created_on
  }
      if(req.body.member_updated_on){
      isChange = true;
    member.member_updated_on=req.body.member_updated_on
  }
      if(req.body.member_mobile_verify){
      isChange = true;
    member.member_mobile_verify=req.body.member_mobile_verify
  }
      if(req.body.member_is_verified){
      isChange = true;
    member.member_is_verified=req.body.member_is_verified
  }
      if(req.body.member_photo_verified){
      isChange = true;
    member.member_photo_verified=req.body.member_photo_verified
  }
      if(req.body.member_is_premium){
      isChange = true;
    member.member_is_premium=req.body.member_is_premium
  }
      if(req.body.member_is_online){
      isChange = true;
    member.member_is_online=req.body.member_is_online
  }
      if(req.body.member_step_completed){
      isChange = true;
    member.member_step_completed=req.body.member_step_completed
  }
      if(req.body.member_franchise_access){
      isChange = true;
    member.member_franchise_access=req.body.member_franchise_access
  }
      if(req.body.member_have_bpl){
      isChange = true;
    member.member_have_bpl=req.body.member_have_bpl
  }
      if(req.body.member_is_paid){
      isChange = true;
    member.member_is_paid=req.body.member_is_paid
  }
      if(req.body.member_is_trusted){
      isChange = true;
    member.member_is_trusted=req.body.member_is_trusted
  }
      if(req.body.member_profile_visibility){
      isChange = true;
    member.member_profile_visibility=req.body.member_profile_visibility
  }
      if(req.body.member_profile_access_by){
      isChange = true;
    member.member_profile_access_by=req.body.member_profile_access_by
  }
      if(req.body.member_is_investigated){
      isChange = true;
    member.member_is_investigated=req.body.member_is_investigated
  }
      if(req.body.member_about){
      isChange = true;
    member.member_about=req.body.member_about
  }
      if(req.body.member_staff){
      isChange = true;
    member.member_staff=req.body.member_staff
  }
      if(req.body.member_status){
      isChange = true;
    member.member_status=req.body.member_status
  }
      if(req.body.member_last_login){
      isChange = true;
    member.member_last_login=req.body.member_last_login
  }
      if(req.body.member_view_member_limit){
      isChange = true;
    member.member_view_member_limit=req.body.member_view_member_limit
  }
      if(req.body.member_is_visible){
      isChange = true;
    member.member_is_visible=req.body.member_is_visible
  }
      if(req.body.member_reports){
      isChange = true;
    member.member_reports=req.body.member_reports
  }
  if(isChange){
    newMember.addNewMember(member,(err,data)=>{
      if(err){
        rc.setResponse(res,{
          msg: 'Error in updating',
          data: err
        })
      }else{
        rc.setResponse(res,{
          success: true,
          msg: 'Data updated successfully',
          data: data
        })
      }
    })
  }
      }
    }
  });
};
module.exports.updateMemberPlan = (req, res) =>{
  console.log('request recieved');
  const id= req.body._id;

 
  console.log(req.body);
  console.log(id);
  newMember.getMember(id,(err,member)=>{
    console.log(err, member);
    if(err){
      rc.setResponse(res,{
        msg: 'Error in fetching member',
        data: err
      })
    }else{
      if(member){
        member.member_plan_id = req.body.member_plan_id;
        newMember.addNewMember(member, (err, data)=>{
          if(err){
            rc.setResponse(res,{
              msg: 'Error in updating member',
              data: err
            })
          }else{
            rc.setResponse(res,{
              success: true,
              msg: 'plan added successfully',
              data: data
            })
          }
        })
      }else{
        rc.setResponse(res,{
          msg: 'No member found by this id'
        })
      }
     
     
    }
  })
}
module.exports.deleteMember = (req, res)=>{
  const id = req.params._id;
  newMember.deleteMember(id,(err,data)=>{
    if(err){
      rc.setResponse(res,{
        msg: 'Member deleted successfully',
        data: err
      })
    }else{
      if(data){
        rc.setResponse(res,{
          success: true,
          msg: 'Member deleted successfully',
          data: data
        })
      }else{
        rc.setResponse(res,{
          msg: 'No member found by this id'
        })
      }
    }
  })
}

module.exports.generatePass =(req, res)=>{
  const ids= req.body.memberForPass;
  console.log(ids);
  
  for (const id of ids){
    newMember.getMember(id,(err, member)=>{
      if(err){
        rc.setResponse(res,{
          msg: 'error in fetching member ',
          data: err
        })
      }else{
        if(member){
          let randomstring = Math.random().toString(36).slice(-8);
          bcrypt.hash(randomstring, 10, (err, hash)=>{
            if(err){
              rc.setResponse(res,{
                msg: 'Error in hashing password',
                data: err
              })
            }else{
              member.member_password = randomstring;
              member.member_hash_password = hash;
              newMember.addNewMember(member, (err,memberWithPass)=>{
                if(err){
                  rc.setResponse(res,{
                    msg: 'error in saving member with password',
                    data: err
                  })
                }else{
                  console.log(memberWithPass.member_hash_password);
                }
              })

            }
          })
        }else{
          rc.setResponse(res,{
            msg: 'No member found by this id'
          })
        }
      }
    })
  } 

 rc.setResponse(res,{
   success: true,
   msg: 'passwords generated successfully'
 })
    
  
}

// module.exports.addNewMember = (req, res) => {
//     let randomstring = Math.random().toString(36).slice(-8);
//     bcrypt.hash(randomstring, 10, (err, hash)=>{
//         if(err){
//             rc.setResponse(res,{
//                 msg: 'Error in hashing password',
//                 data: err
//             })
//         }else{

//             if(req.body.member_city_id){
//                 city=req.body.member_city_id[0];

//             }else{
//                city="";
//             }

//             if(req.body.member_religion_name){
//                religion_name=req.body.member_religion_name[0];
//             }else{
//                religion_name="";
//             }
//             if(req.body.member_caste_name){
//                caste_name=req.body.member_caste_name[0];
//             }else{
//                 caste_name="";
//             }
//             if(req.body.member_mother_tongue){
//                 mother_tongue=req.body.member_mother_tongue[0];
//             }else{
//                 mother_tongue="";
//             }
//             if(req.body.member_education_details){
//                 education_details=req.body.member_education_details[0];
//             }else{
//                 education_details="";
//             }
//             if(req.body.member_collage_passout){
//                 collage_passout=req.body.member_collage_passout[0];
//             }else{
//                 collage_passout="";
//             }
//             if(req.body.member_professional_status){
//                professional_status=req.body.member_professional_status[0];
//             }else{
//                 professional_status="";
//             }
//             if(req.body.member_family_status){
//                 family_status=req.body.member_family_status[0];
//             }else{
//                 family_status="";
//             }
//             if(req.body.member_family_income){
//                 family_income=req.body.member_family_income[0];
//             }else{
//                 family_income="";
//             }
//             if(req.body.member_family_values){
//                 family_values=req.body.member_family_values[0];
//             }else{
//                 family_values="";
//             }
//             if(req.body.member_gotra){
//                gotra=req.body.member_gotra[0];
//             }else{
//                 gotra="";
//             }
//             if(req.body.member_mama_gotra){
//                 mama_gotra=req.body.member_mama_gotra[0];
//             }else{
//                 mama_gotra="";
//             }
//             if(req.body.member_image){
//                 image=req.body.member_image[0];
//             }else{
//                 image="";
//             }
//             if(req.body.member_horoscope_file){
//                 horoscope_file=req.body.member_horoscope_file[0];
//             }else{
//                 horoscope_file="";
//             }
//             if(req.body.member_family_photo){
//                 family_photo=req.body.member_family_photo[0];
//             }else{
//                 family_photo="";
//             }
//             if(req.body.member_image_with_aadhar){
//                 image_with_aadhar=req.body.member_image_with_aadhar[0];
//             }else{
//                 image_with_aadhar="";
//             }
//             if(req.body.member_id_card_image){
//                 id_card_image=req.body.member_id_card_image[0];
//             }else{
//                 id_card_image="";
//             }
//             if(req.body.member_country_id){
//                country_id=req.body.member_country_id[0];
//             }else{
//                 country_id="";
//             }
//             if(req.body.member_state_id){
//                 state_id=req.body.member_state_id[0];
//             }else{
//                 state_id="";
//             }
//             if(req.body.member_p_country_id){
//                 p_country_id=req.body.member_p_country_id[0];
//             }else{
//                 p_country_id="";
//             }
//             if(req.body.member_p_state_id){
//                 p_state_id=req.body.member_p_state_id[0];
//             }else{
//                 p_state_id="";
//             }
//             if(req.body.member_p_city_id){
//                 p_city_id=req.body.member_p_city_id[0];
//             }else{
//                 p_city_id="";
//             }
//             if(req.body.member_father_occupation){
//                 father_occupation=req.body.member_father_occupation[0];
//             }else{
//                 father_occupation="";
//             }
//             if(req.body.member_mother_occupation){
//                 mother_occupation=req.body.member_mother_occupation[0];
//             }else{
//                 mother_occupation="";
//             }
//             if(req.body.member_rashi){
//                 rashi=req.body.member_rashi[0];
//             }else{
//                 rashi="";
//             }
//             if(req.body.member_namaj_offered){
//                 namaj_offered=req.body.member_namaj_offered[0];
//             }else{
//                 namaj_offered="";
//             }
//             if(req.body.member_have_bread){
//                 have_bread=req.body.member_have_bread[0];
//             }else{
//                have_bread="";
//             }
//             if(req.body.member_face_covering_girl){
//                 face_covering_girl=req.body.member_face_covering_girl[0];
//             }else{
//                 face_covering_girl="";
//             }

//             let freshMember = {
//                 member_id:req.body.member_id,
//                 member_profile_created_for:req.body.member_profile_created_for,
//                 member_first_name:req.body.member_first_name,
//                 member_middle_name:req.body.member_middle_name,
//                 member_last_name:req.body.member_last_name,
//                 member_name:req.body.member_name,
//                 member_is_updated:req.body.member_is_updated,
//                 member_slug:req.body.member_slug,
//                 member_mobile:req.body.member_mobile,
//                 member_email:req.body.member_email,
//                 member_religion:religion_name,
//                 member_caste:caste_name,
//                 member_sub_caste_name:req.body.member_sub_caste_name,
//                 member_gender:req.body.member_gender,
//                 member_dob:req.body.member_dob,
//                 member_weight:req.body.member_weight,
//                 member_height:req.body.member_height,
//                 member_complextion:req.body.member_complextion,
//                 member_meritial_status:req.body.member_meritial_status,
//                 member_children_status:req.body.member_children_status,
//                 member_total_children:req.body.member_total_children,
//                 member_age_eldest_children:req.body.member_age_eldest_children,
//                 member_eating_habits:req.body.member_eating_habits,
//                 member_drinking_habits:req.body.member_drinking_habits,
//                 member_smoking_habits:req.body.member_smoking_habits,
//                 member_hobby:req.body.member_hobby,
//                 member_body_type:req.body.member_body_type,
//                 member_special_case:req.body.member_special_case,
//                 member_special_case_details:req.body.member_special_case_details,
//                 member_residencial_status:req.body.member_residencial_status,
//                 member_mother_tongue: mother_tongue,
//                 member_own_house_status:req.body.member_own_house_status,
//                 member_annual_income:req.body.member_annual_income,
//                 member_education_details:education_details,
//                 member_collage_passout:collage_passout,
//                 member_professional_status:professional_status,
//                 member_professional_details:req.body.member_professional_details,
//                 member_working_location:req.body.member_working_location,
//                 member_visa_status:req.body.member_visa_status,
//                 member_father_name:req.body.member_father_name,
//                 member_father_occupation:father_occupation,
//                 member_father_occupation_details:req.body.member_father_occupation_details,
//                 member_mother_name:req.body.member_mother_name,
//                 member_mother_occupation:mother_occupation,
//                 member_mother_occupation_details:req.body.member_mother_occupation_details,
//                 member_family_status:family_status,
//                 member_family_income:family_income,
//                 member_family_type:req.body.member_family_type,
//                 member_family_values:family_values,
//                 member_relatives_details:req.body.member_relatives_details,
//                 member_gotra:gotra,
//                 member_mama_gotra:mama_gotra,
//                 member_rashi:rashi,
//                 member_tob:req.body.member_tob,
//                 member_place_of_birth:req.body.member_place_of_birth,
//                 member_manglik:req.body.member_manglik,
//                 member_horoscope_match:req.body.member_horoscope_match,
//                 member_horoscope_file:horoscope_file,
//                 member_namaj_offered:namaj_offered,
//                 member_have_bread:have_bread,
//                 member_face_covering_girl:face_covering_girl,
//                 member_jain_day_routine:req.body.member_jain_day_routine,
//                 member_jain_religion_studies:req.body.member_jain_religion_studies,
//                 member_jatadhari_amritdhari_pagdi_sardar:req.body.member_jatadhari_amritdhari_pagdi_sardar,
//                 member_sahajdhari_sardar:req.body.member_sahajdhari_sardar,
//                 member_kripan_dhari:req.body.member_kripan_dhari,
//                 member_image:image,
//                 member_family_photo:family_photo,
//                 member_image_with_aadhar:image_with_aadhar,
//                 member_id_card_image:id_card_image,
//                 member_password:randomstring,
//                 member_hash_password: hash,
//                 member_country:country_id,
//                 member_state:state_id,
//                 member_city: city,
//                 member_pincode:req.body.member_pincode,
//                 member_address:req.body.member_address,
//                 member_p_country:p_country_id,
//                 member_p_state:p_state_id,
//                 member_p_city:p_city_id,
//                 member_p_pincode:req.body.member_p_pincode,
//                 member_p_address:req.body.member_p_address,
//                 member_order:req.body.member_order,
//                 member_added_by:req.body.member_added_by,
//                 member_updated_by:req.body.member_updated_by,
//                 meber_deleted_by:req.body.meber_deleted_by,
//                 member_is_deleted:req.body.member_is_deleted,
//                 member_plan_id:req.body.member_plan_id,
//                 member_created_on:req.body.member_created_on,
//                 member_updated_on:req.body.member_updated_on,
//                 member_mobile_verify:req.body.member_mobile_verify,
//                 member_is_verified:req.body.member_is_verified,
//                 member_photo_verified:req.body.member_photo_verified,
//                 member_is_premium:req.body.member_is_premium,
//                 member_is_online:req.body.member_is_online,
//                 member_step_completed:req.body.member_step_completed,
//                 member_franchise_access:req.body.member_franchise_access,
//                 member_have_bpl:req.body.member_have_bpl,
//                 member_is_paid:req.body.member_is_paid,
//                 member_is_trusted:req.body.member_is_trusted,
//                 member_profile_visibility:req.body.member_profile_visibility,
//                 member_profile_access_by:req.body.member_profile_access_by,
//                 member_is_investigated:req.body.member_is_investigated,
//                 member_about:req.body.member_about,
//                 member_staff:req.body.member_staff,
//                 member_status:req.body.member_status,
//                 member_last_login:req.body.member_last_login,
//                 member_view_member_limit:req.body.member_view_member_limit,
//                 member_is_visible:req.body.member_is_visible,
//                 member_reports:req.body.member_reports,
//                 };
//             newMember.addNewMember(freshMember,(err,newMembers)=>{
//                 if(err){
//                     rc.setResponse(res,{
//                         msg: 'Error in making new members',
//                         data: err
//                     })
//                 }else{
//                     rc.setResponse(res,{
//                         success: true,
//                         msg: 'New member saved successfully',
//                         data: newMembers

//                     })
//                 }
//             })
//         }
//     })
//     // Counter.getNextSequenceValue("memberid", (err, counter) => {
//     //     if (err) {
//     //       rc.setResponse(res, {
//     //         msg: "Error in generating Counter",
//     //         data: err
//     //       });
//     //     } else {
//     //         console.log(counter.sequence_value);
//     //         oldMember.getMemberByMemberId(counter.sequence_value,(err,dupMember)=>{
//     //             if(err){
//     //                 rc.setResponse(res,{
//     //                     msg: 'Error in fetching member by id',
//     //                     data: err
//     //                 })
//     //             }else{
//     //                 if(dupMember){
//     //                     console.log(dupMember.member_id);
//     //                     rc.setResponse(res,{
//     //                         msg: 'This member id already exists'
//     //                     })
//     //                 }else{

//     //                 }
//     //             }
//     //         })

//     //     }
//     //   });
//     // oldMember.getAllMemberToTransfer((err, oldMembers) => {
//     //     if (err) {
//     //       rc.setResponse(res, {
//     //         msg: "Failed to fetch old members",
//     //         data: err
//     //       });
//     //     } else {

//     //       for (const member of oldMembers) {

//     //       }
//     //     }
//     //   });

// };

// module.exports.addNewestMember_old = (req, res) => {
//     oldMember.getAllMemberId((err, data) => {
//         if (err) throw err;
//         else {
//             res.json({success: true, msg: "started"});
//             console.log(data.length);
//             //Get all ids in global array
//             let idArray= data;
//            //Sending index of array in recursive function
//             recursiveTransferFunction(0, idArray);
//             // for (let i = 0; i < 10; i++) {
//             //     let h = 0;
//             //     while(h<100000000){
//             //         h++;
//             //     }

//             //     const element = data[i];

//             //     oldMember.getMemberWithProj(element._id, (err, data2) => {
//             //         console.log(data2);
//             //         if (err) throw err;
//             //         else {
//             //             let randomstring = Math.random().toString(36).slice(-8);
//             //             bcrypt.hash(randomstring, 10, (err, hash)=>{
//             //                 if(err){
//             //                     rc.setResponse(res,{
//             //                         msg: 'Error in hashing password',
//             //                         data: err
//             //                     })
//             //                 }else{

//             //                     let data1=data2[0];

//             //                     if(data1.member_city_id){
//             //                         city=data1.member_city_id[0];

//             //                     }else{
//             //                        city="";
//             //                     }

//             //                     if(data1.member_religion_name){
//             //                        religion_name=data1.member_religion_name[0];
//             //                     }else{
//             //                        religion_name="";
//             //                     }
//             //                     if(data1.member_caste_name){
//             //                        caste_name=data1.member_caste_name[0];
//             //                     }else{
//             //                         caste_name="";
//             //                     }
//             //                     if(data1.member_mother_tongue){
//             //                         mother_tongue=data1.member_mother_tongue[0];
//             //                     }else{
//             //                         mother_tongue="";
//             //                     }
//             //                     if(data1.member_education_details){
//             //                         education_details=data1.member_education_details[0];
//             //                     }else{
//             //                         education_details="";
//             //                     }
//             //                     if(data1.member_collage_passout){
//             //                         collage_passout=data1.member_collage_passout[0];
//             //                     }else{
//             //                         collage_passout="";
//             //                     }
//             //                     if(data1.member_professional_status){
//             //                        professional_status=data1.member_professional_status[0];
//             //                     }else{
//             //                         professional_status="";
//             //                     }
//             //                     if(data1.member_family_status){
//             //                         family_status=data1.member_family_status[0];
//             //                     }else{
//             //                         family_status="";
//             //                     }
//             //                     if(data1.member_family_income){
//             //                         family_income=data1.member_family_income[0];
//             //                     }else{
//             //                         family_income="";
//             //                     }
//             //                     if(data1.member_family_values){
//             //                         family_values=data1.member_family_values[0];
//             //                     }else{
//             //                         family_values="";
//             //                     }
//             //                     if(data1.member_gotra){
//             //                        gotra=data1.member_gotra[0];
//             //                     }else{
//             //                         gotra="";
//             //                     }
//             //                     if(data1.member_mama_gotra){
//             //                         mama_gotra=data1.member_mama_gotra[0];
//             //                     }else{
//             //                         mama_gotra="";
//             //                     }
//             //                     if(data1.member_image){
//             //                         image=data1.member_image[0];
//             //                     }else{
//             //                         image="";
//             //                     }
//             //                     if(data1.member_horoscope_file){
//             //                         horoscope_file=data1.member_horoscope_file[0];
//             //                     }else{
//             //                         horoscope_file="";
//             //                     }
//             //                     if(data1.member_family_photo){
//             //                         family_photo=data1.member_family_photo[0];
//             //                     }else{
//             //                         family_photo="";
//             //                     }
//             //                     if(data1.member_image_with_aadhar){
//             //                         image_with_aadhar=data1.member_image_with_aadhar[0];
//             //                     }else{
//             //                         image_with_aadhar="";
//             //                     }
//             //                     if(data1.member_id_card_image){
//             //                         id_card_image=data1.member_id_card_image[0];
//             //                     }else{
//             //                         id_card_image="";
//             //                     }
//             //                     if(data1.member_country_id){
//             //                        country_id=data1.member_country_id[0];
//             //                     }else{
//             //                         country_id="";
//             //                     }
//             //                     if(data1.member_state_id){
//             //                         state_id=data1.member_state_id[0];
//             //                     }else{
//             //                         state_id="";
//             //                     }
//             //                     if(data1.member_p_country_id){
//             //                         p_country_id=data1.member_p_country_id[0];
//             //                     }else{
//             //                         p_country_id="";
//             //                     }
//             //                     if(data1.member_p_state_id){
//             //                         p_state_id=data1.member_p_state_id[0];
//             //                     }else{
//             //                         p_state_id="";
//             //                     }
//             //                     if(data1.member_p_city_id){
//             //                         p_city_id=data1.member_p_city_id[0];
//             //                     }else{
//             //                         p_city_id="";
//             //                     }
//             //                     if(data1.member_father_occupation){
//             //                         father_occupation=data1.member_father_occupation[0];
//             //                     }else{
//             //                         father_occupation="";
//             //                     }
//             //                     if(data1.member_mother_occupation){
//             //                         mother_occupation=data1.member_mother_occupation[0];
//             //                     }else{
//             //                         mother_occupation="";
//             //                     }
//             //                     if(data1.member_rashi){
//             //                         rashi=data1.member_rashi[0];
//             //                     }else{
//             //                         rashi="";
//             //                     }
//             //                     if(data1.member_namaj_offered){
//             //                         namaj_offered=data1.member_namaj_offered[0];
//             //                     }else{
//             //                         namaj_offered="";
//             //                     }
//             //                     // console.log(data1.member_have_bread);
//             //                     if(data1.member_have_bread){
//             //                         have_bread=data1.member_have_bread[0];
//             //                     }else{
//             //                        have_bread="";
//             //                     }
//             //                     if(data1.member_face_covering_girl){
//             //                         face_covering_girl=data1.member_face_covering_girl[0];
//             //                     }else{
//             //                         face_covering_girl="";
//             //                     }

//             //                     let freshMember = {
//             //                         member_id:data1.member_id,
//             //                         member_profile_created_for:data1.member_profile_created_for,
//             //                         member_first_name:data1.member_first_name,
//             //                         member_middle_name:data1.member_middle_name,
//             //                         member_last_name:data1.member_last_name,
//             //                         member_name:data1.member_name,
//             //                         member_is_updated:data1.member_is_updated,
//             //                         member_slug:data1.member_slug,
//             //                         member_mobile:data1.member_mobile,
//             //                         member_email:data1.member_email,
//             //                         member_religion:religion_name,
//             //                         member_caste:caste_name,
//             //                         member_sub_caste_name:data1.member_sub_caste_name,
//             //                         member_gender:data1.member_gender,
//             //                         member_dob:data1.member_dob,
//             //                         member_weight:data1.member_weight,
//             //                         member_height:data1.member_height,
//             //                         member_complextion:data1.member_complextion,
//             //                         member_meritial_status:data1.member_meritial_status,
//             //                         member_children_status:data1.member_children_status,
//             //                         member_total_children:data1.member_total_children,
//             //                         member_age_eldest_children:data1.member_age_eldest_children,
//             //                         member_eating_habits:data1.member_eating_habits,
//             //                         member_drinking_habits:data1.member_drinking_habits,
//             //                         member_smoking_habits:data1.member_smoking_habits,
//             //                         member_hobby:data1.member_hobby,
//             //                         member_body_type:data1.member_body_type,
//             //                         member_special_case:data1.member_special_case,
//             //                         member_special_case_details:data1.member_special_case_details,
//             //                         member_residencial_status:data1.member_residencial_status,
//             //                         member_mother_tongue: mother_tongue,
//             //                         member_own_house_status:data1.member_own_house_status,
//             //                         member_annual_income:data1.member_annual_income,
//             //                         member_education_details:education_details,
//             //                         member_collage_passout:collage_passout,
//             //                         member_professional_status:professional_status,
//             //                         member_professional_details:data1.member_professional_details,
//             //                         member_working_location:data1.member_working_location,
//             //                         member_visa_status:data1.member_visa_status,
//             //                         member_father_name:data1.member_father_name,
//             //                         member_father_occupation:father_occupation,
//             //                         member_father_occupation_details:data1.member_father_occupation_details,
//             //                         member_mother_name:data1.member_mother_name,
//             //                         member_mother_occupation:mother_occupation,
//             //                         member_mother_occupation_details:data1.member_mother_occupation_details,
//             //                         member_family_status:family_status,
//             //                         member_family_income:family_income,
//             //                         member_family_type:data1.member_family_type,
//             //                         member_family_values:family_values,
//             //                         member_relatives_details:data1.member_relatives_details,
//             //                         member_gotra:gotra,
//             //                         member_mama_gotra:mama_gotra,
//             //                         member_rashi:rashi,
//             //                         member_tob:data1.member_tob,
//             //                         member_place_of_birth:data1.member_place_of_birth,
//             //                         member_manglik:data1.member_manglik,
//             //                         member_horoscope_match:data1.member_horoscope_match,
//             //                         member_horoscope_file:horoscope_file,
//             //                         member_namaj_offered:namaj_offered,
//             //                         member_have_bread:have_bread,
//             //                         member_face_covering_girl:face_covering_girl,
//             //                         member_jain_day_routine:data1.member_jain_day_routine,
//             //                         member_jain_religion_studies:data1.member_jain_religion_studies,
//             //                         member_jatadhari_amritdhari_pagdi_sardar:data1.member_jatadhari_amritdhari_pagdi_sardar,
//             //                         member_sahajdhari_sardar:data1.member_sahajdhari_sardar,
//             //                         member_kripan_dhari:data1.member_kripan_dhari,
//             //                         member_image:image,
//             //                         member_family_photo:family_photo,
//             //                         member_image_with_aadhar:image_with_aadhar,
//             //                         member_id_card_image:id_card_image,
//             //                         member_password:randomstring,
//             //                         member_hash_password: hash,
//             //                         member_country:country_id,
//             //                         member_state:state_id,
//             //                         member_city: city,
//             //                         member_pincode:data1.member_pincode,
//             //                         member_address:data1.member_address,
//             //                         member_p_country:p_country_id,
//             //                         member_p_state:p_state_id,
//             //                         member_p_city:p_city_id,
//             //                         member_p_pincode:data1.member_p_pincode,
//             //                         member_p_address:data1.member_p_address,
//             //                         member_order:data1.member_order,
//             //                         member_added_by:data1.member_added_by,
//             //                         member_updated_by:data1.member_updated_by,
//             //                         meber_deleted_by:data1.meber_deleted_by,
//             //                         member_is_deleted:data1.member_is_deleted,
//             //                         member_plan_id:data1.member_plan_id,
//             //                         member_created_on:data1.member_created_on,
//             //                         member_updated_on:data1.member_updated_on,
//             //                         member_mobile_verify:data1.member_mobile_verify,
//             //                         member_is_verified:data1.member_is_verified,
//             //                         member_photo_verified:data1.member_photo_verified,
//             //                         member_is_premium:data1.member_is_premium,
//             //                         member_is_online:data1.member_is_online,
//             //                         member_step_completed:data1.member_step_completed,
//             //                         member_franchise_access:data1.member_franchise_access,
//             //                         member_have_bpl:data1.member_have_bpl,
//             //                         member_is_paid:data1.member_is_paid,
//             //                         member_is_trusted:data1.member_is_trusted,
//             //                         member_profile_visibility:data1.member_profile_visibility,
//             //                         member_profile_access_by:data1.member_profile_access_by,
//             //                         member_is_investigated:data1.member_is_investigated,
//             //                         member_about:data1.member_about,
//             //                         member_staff:data1.member_staff,
//             //                         member_status:data1.member_status,
//             //                         member_last_login:data1.member_last_login,
//             //                         member_view_member_limit:data1.member_view_member_limit,
//             //                         member_is_visible:data1.member_is_visible,
//             //                         member_reports:data1.member_reports,
//             //                         };

//             //                     newMember.addNewMember(freshMember,(err,newOrgMember)=>{
//             //                         if(err){
//             //                             // rc.setResponse(res,{
//             //                             //     msg: 'Error in making new members',
//             //                             //     data: err
//             //                             // })
//             //                             console.log("err occured");
//             //                         }else{
//             //                             // rc.setResponse(res,{
//             //                             //     success: true,
//             //                             //     msg: 'New member saved successfully',
//             //                             //     data: newMembers

//             //                             // })
//             //                             console.log(data1.member_id);
//             //                             // console.log(newOrgMember);
//             //                         }
//             //                     })
//             //                 }
//             //             })

//             //         }
//             //     });
//             // }
//         }
//     });
//     // Counter.getNextSequenceValue("memberid", (err, counter) => {
//     //     if (err) {
//     //       rc.setResponse(res, {
//     //         msg: "Error in generating Counter",
//     //         data: err
//     //       });
//     //     } else {
//     //         console.log(counter.sequence_value);
//     //         oldMember.getMemberByMemberId(counter.sequence_value,(err,dupMember)=>{
//     //             if(err){
//     //                 rc.setResponse(res,{
//     //                     msg: 'Error in fetching member by id',
//     //                     data: err
//     //                 })
//     //             }else{
//     //                 if(dupMember){
//     //                     console.log(dupMember.member_id);
//     //                     rc.setResponse(res,{
//     //                         msg: 'This member id already exists'
//     //                     })
//     //                 }else{

//     //                 }
//     //             }
//     //         })

//     //     }
//     //   });
//     // oldMember.getAllMemberToTransfer((err, oldMembers) => {
//     //     if (err) {
//     //       rc.setResponse(res, {
//     //         msg: "Failed to fetch old members",
//     //         data: err
//     //       });
//     //     } else {

//     //       for (const member of oldMembers) {

//     //       }
//     //     }
//     //   });

// };
// function recursiveTransferFunction(i, idArray){
//     console.log(i);
//     if(i > idArray.length){
//         return;
//     }

//     const element= idArray[i];
//     // console.log(element._id);
//     const id = element._id;
//     console.log(id);

//     oldMember.getMemberWithProj(id, (err, data2) => {

//         if (err) throw err;
//         else {
//             let randomstring = Math.random().toString(36).slice(-8);
//             bcrypt.hash(randomstring, 10, (err, hash)=>{
//                 if(err){
//                     rc.setResponse(res,{
//                         msg: 'Error in hashing password',
//                         data: err
//                     })
//                 }else{

//                     let data1=data2[0];

//                     if(data1.member_city_id){
//                         city=data1.member_city_id[0];

//                     }else{
//                        city="";
//                     }

//                     if(data1.member_religion_name){
//                        religion_name=data1.member_religion_name[0];
//                     }else{
//                        religion_name="";
//                     }
//                     if(data1.member_caste_name){
//                        caste_name=data1.member_caste_name[0];
//                     }else{
//                         caste_name="";
//                     }
//                     if(data1.member_mother_tongue){
//                         mother_tongue=data1.member_mother_tongue[0];
//                     }else{
//                         mother_tongue="";
//                     }
//                     if(data1.member_education_details){
//                         education_details=data1.member_education_details[0];
//                     }else{
//                         education_details="";
//                     }
//                     if(data1.member_collage_passout){
//                         collage_passout=data1.member_collage_passout[0];
//                     }else{
//                         collage_passout="";
//                     }
//                     if(data1.member_professional_status){
//                        professional_status=data1.member_professional_status[0];
//                     }else{
//                         professional_status="";
//                     }
//                     if(data1.member_family_status){
//                         family_status=data1.member_family_status[0];
//                     }else{
//                         family_status="";
//                     }
//                     if(data1.member_family_income){
//                         family_income=data1.member_family_income[0];
//                     }else{
//                         family_income="";
//                     }
//                     if(data1.member_family_values){
//                         family_values=data1.member_family_values[0];
//                     }else{
//                         family_values="";
//                     }
//                     if(data1.member_gotra){
//                        gotra=data1.member_gotra[0];
//                     }else{
//                         gotra="";
//                     }
//                     if(data1.member_mama_gotra){
//                         mama_gotra=data1.member_mama_gotra[0];
//                     }else{
//                         mama_gotra="";
//                     }
//                     if(data1.member_image){
//                         image=data1.member_image[0];
//                     }else{
//                         image="";
//                     }
//                     if(data1.member_horoscope_file){
//                         horoscope_file=data1.member_horoscope_file[0];
//                     }else{
//                         horoscope_file="";
//                     }
//                     if(data1.member_family_photo){
//                         family_photo=data1.member_family_photo[0];
//                     }else{
//                         family_photo="";
//                     }
//                     if(data1.member_image_with_aadhar){
//                         image_with_aadhar=data1.member_image_with_aadhar[0];
//                     }else{
//                         image_with_aadhar="";
//                     }
//                     if(data1.member_id_card_image){
//                         id_card_image=data1.member_id_card_image[0];
//                     }else{
//                         id_card_image="";
//                     }
//                     if(data1.member_country_id){
//                        country_id=data1.member_country_id[0];
//                     }else{
//                         country_id="";
//                     }
//                     if(data1.member_state_id){
//                         state_id=data1.member_state_id[0];
//                     }else{
//                         state_id="";
//                     }
//                     if(data1.member_p_country_id){
//                         p_country_id=data1.member_p_country_id[0];
//                     }else{
//                         p_country_id="";
//                     }
//                     if(data1.member_p_state_id){
//                         p_state_id=data1.member_p_state_id[0];
//                     }else{
//                         p_state_id="";
//                     }
//                     if(data1.member_p_city_id){
//                         p_city_id=data1.member_p_city_id[0];
//                     }else{
//                         p_city_id="";
//                     }
//                     if(data1.member_father_occupation){
//                         father_occupation=data1.member_father_occupation[0];
//                     }else{
//                         father_occupation="";
//                     }
//                     if(data1.member_mother_occupation){
//                         mother_occupation=data1.member_mother_occupation[0];
//                     }else{
//                         mother_occupation="";
//                     }
//                     if(data1.member_rashi){
//                         rashi=data1.member_rashi[0];
//                     }else{
//                         rashi="";
//                     }
//                     if(data1.member_namaj_offered){
//                         namaj_offered=data1.member_namaj_offered[0];
//                     }else{
//                         namaj_offered="";
//                     }
//                     // console.log(data1.member_have_bread);
//                     if(data1.member_have_bread){
//                         have_bread=data1.member_have_bread[0];
//                     }else{
//                        have_bread="";
//                     }
//                     if(data1.member_face_covering_girl){
//                         face_covering_girl=data1.member_face_covering_girl[0];
//                     }else{
//                         face_covering_girl="";
//                     }

//                     let freshMember = {
//                         member_id:data1.member_id,
//                         member_profile_created_for:data1.member_profile_created_for,
//                         member_first_name:data1.member_first_name,
//                         member_middle_name:data1.member_middle_name,
//                         member_last_name:data1.member_last_name,
//                         member_name:data1.member_name,
//                         member_is_updated:data1.member_is_updated,
//                         member_slug:data1.member_slug,
//                         member_mobile:data1.member_mobile,
//                         member_email:data1.member_email,
//                         member_religion:religion_name,
//                         member_caste:caste_name,
//                         member_sub_caste_name:data1.member_sub_caste_name,
//                         member_gender:data1.member_gender,
//                         member_dob:data1.member_dob,
//                         member_weight:data1.member_weight,
//                         member_height:data1.member_height,
//                         member_complextion:data1.member_complextion,
//                         member_meritial_status:data1.member_meritial_status,
//                         member_children_status:data1.member_children_status,
//                         member_total_children:data1.member_total_children,
//                         member_age_eldest_children:data1.member_age_eldest_children,
//                         member_eating_habits:data1.member_eating_habits,
//                         member_drinking_habits:data1.member_drinking_habits,
//                         member_smoking_habits:data1.member_smoking_habits,
//                         member_hobby:data1.member_hobby,
//                         member_body_type:data1.member_body_type,
//                         member_special_case:data1.member_special_case,
//                         member_special_case_details:data1.member_special_case_details,
//                         member_residencial_status:data1.member_residencial_status,
//                         member_mother_tongue: mother_tongue,
//                         member_own_house_status:data1.member_own_house_status,
//                         member_annual_income:data1.member_annual_income,
//                         member_education_details:education_details,
//                         member_collage_passout:collage_passout,
//                         member_professional_status:professional_status,
//                         member_professional_details:data1.member_professional_details,
//                         member_working_location:data1.member_working_location,
//                         member_visa_status:data1.member_visa_status,
//                         member_father_name:data1.member_father_name,
//                         member_father_occupation:father_occupation,
//                         member_father_occupation_details:data1.member_father_occupation_details,
//                         member_mother_name:data1.member_mother_name,
//                         member_mother_occupation:mother_occupation,
//                         member_mother_occupation_details:data1.member_mother_occupation_details,
//                         member_family_status:family_status,
//                         member_family_income:family_income,
//                         member_family_type:data1.member_family_type,
//                         member_family_values:family_values,
//                         member_relatives_details:data1.member_relatives_details,
//                         member_gotra:gotra,
//                         member_mama_gotra:mama_gotra,
//                         member_rashi:rashi,
//                         member_tob:data1.member_tob,
//                         member_place_of_birth:data1.member_place_of_birth,
//                         member_manglik:data1.member_manglik,
//                         member_horoscope_match:data1.member_horoscope_match,
//                         member_horoscope_file:horoscope_file,
//                         member_namaj_offered:namaj_offered,
//                         member_have_bread:have_bread,
//                         member_face_covering_girl:face_covering_girl,
//                         member_jain_day_routine:data1.member_jain_day_routine,
//                         member_jain_religion_studies:data1.member_jain_religion_studies,
//                         member_jatadhari_amritdhari_pagdi_sardar:data1.member_jatadhari_amritdhari_pagdi_sardar,
//                         member_sahajdhari_sardar:data1.member_sahajdhari_sardar,
//                         member_kripan_dhari:data1.member_kripan_dhari,
//                         member_image:image,
//                         member_family_photo:family_photo,
//                         member_image_with_aadhar:image_with_aadhar,
//                         member_id_card_image:id_card_image,
//                         member_password:randomstring,
//                         member_hash_password: hash,
//                         member_country:country_id,
//                         member_state:state_id,
//                         member_city: city,
//                         member_pincode:data1.member_pincode,
//                         member_address:data1.member_address,
//                         member_p_country:p_country_id,
//                         member_p_state:p_state_id,
//                         member_p_city:p_city_id,
//                         member_p_pincode:data1.member_p_pincode,
//                         member_p_address:data1.member_p_address,
//                         member_order:data1.member_order,
//                         member_added_by:data1.member_added_by,
//                         member_updated_by:data1.member_updated_by,
//                         meber_deleted_by:data1.meber_deleted_by,
//                         member_is_deleted:data1.member_is_deleted,
//                         member_plan_id:data1.member_plan_id,
//                         member_created_on:data1.member_created_on,
//                         member_updated_on:data1.member_updated_on,
//                         member_mobile_verify:data1.member_mobile_verify,
//                         member_is_verified:data1.member_is_verified,
//                         member_photo_verified:data1.member_photo_verified,
//                         member_is_premium:data1.member_is_premium,
//                         member_is_online:data1.member_is_online,
//                         member_step_completed:data1.member_step_completed,
//                         member_franchise_access:data1.member_franchise_access,
//                         member_have_bpl:data1.member_have_bpl,
//                         member_is_paid:data1.member_is_paid,
//                         member_is_trusted:data1.member_is_trusted,
//                         member_profile_visibility:data1.member_profile_visibility,
//                         member_profile_access_by:data1.member_profile_access_by,
//                         member_is_investigated:data1.member_is_investigated,
//                         member_about:data1.member_about,
//                         member_staff:data1.member_staff,
//                         member_status:data1.member_status,
//                         member_last_login:data1.member_last_login,
//                         member_view_member_limit:data1.member_view_member_limit,
//                         member_is_visible:data1.member_is_visible,
//                         member_reports:data1.member_reports,
//                         };

//                     newMember.addNewMember(freshMember,(err,newOrgMember)=>{
//                         if(err){
//                             // rc.setResponse(res,{
//                             //     msg: 'Error in making new members',
//                             //     data: err
//                             // })
//                             console.log("err occured");
//                         }else{
//                             const j = i+1;
//                             // if(j < idArray.length){
//                                 recursiveTransferFunction(j, idArray)
//                             // }
//                             // rc.setResponse(res,{
//                             //     success: true,
//                             //     msg: 'New member saved successfully',
//                             //     data: newMembers

//                             // })

//                             // console.log(newOrgMember);
//                         }
//                     })
//                 }
//             })

//         }
//     });

// }
