const Desired = require("../models/old_desired.js");
const country = require("./../models/country1");
const religion = require("./../models/religion");
const caste = require("./../models/caste");
const motherTongue = require("./../models/motherTongue");
const eduDetail = require("./../models/education-detail");
const occupation = require("./../models/occupation");
const familyAnnualIncome = require("./../models/family-income");
const familyStatus = require("./../models/family-status");
const familyValue = require("./../models/family-value");

const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newDesired = new desired({
    desired_id: req.body.desired_id,
    desired_member_slug: req.body.desired_member_slug,
    desired_age_from: req.body.desired_age_from,
    desired_age_to: req.body.desired_age_to,
    desired_gender: req.body.desired_gender,
    desired_body_type: req.body.desired_body_type,
    desired_height_from: req.body.desired_height_from,
    desired_height_to: req.body.desired_height_to,
    desired_weight_from: req.body.desired_weight_from,
    desired_weight_to: req.body.desired_weight_to,
    desired_maritial_status: req.body.desired_maritial_status,
    desired_country: req.body.desired_country,
    desired_religion: req.body.desired_religion,
    desired_caste: req.body.desired_caste,
    desired_mother_tongue: req.body.desired_mother_tongue,
    desired_manglik: req.body.desired_manglik,
    // desired_gotra: req.body.desired_gotra,
    // desired_mama_gotra: req.body.desired_mama_gotra,
    desired_education: req.body.desired_education,
    desired_occupation: req.body.desired_occupation,
    desired_income: req.body.desired_income,
    desired_own_house: req.body.desired_own_house,
    desired_family_status: req.body.desired_family_status,
    desired_family_income: req.body.desired_family_income,
    desired_family_type: req.body.desired_family_type,
    desired_family_value: req.body.desired_family_value,
    desired_family_residential_status: req.body.desired_family_residential_status,
    desired_eating_habit: req.body.desired_eating_habit,
    desired_drinking_habit: req.body.desired_drinking_habit,
    desired_smoking_habit: req.body.desired_smoking_habit,
    desired_complexion: req.body.desired_complexion,
    desired_abled: req.body.desired_abled,
    desired_abled_details: req.body.desired_abled_details,
    desired_about_partner: req.body.desired_about_partner,
    desired_is_deleted: req.body.desired_is_deleted,
    desired_created_on: Date.now(),
    desired_member_id: req.body.desired_member_id,
    desired_user_id: req.body.desired_user_id,
    desired_status: req.body.desired_status,
  });
  Desired.addDesired(newDesired, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  Desired.getDesired(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByMemberId = (req, res) => {
  const id = req.body._id;
  Desired.getDesiredByMember(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  Desired.getAllDesired((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          //   data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};
module.exports.getWithProj = (req, res) => {
  Desired.getDesiredWithProjection((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res) => {
  const id = req.body._id;
  const isOldOfDesired = req.body.isOld;
  // console.log(req.body);
  // rc.setResponse(res,{});
  Desired.getDesired(id, (err, desiredMem) => {
    if (err) {
      rc.setResponse(res, {
        msg: "Error in fetching member",
        data: err.message
      })
    } else {
      desiredMem.isOld = 'N',
        desiredMem.desired_id = req.body.desired_id,
        desiredMem.desired_member_slug = req.body.desired_member_slug,
        desiredMem.desired_age_from = req.body.desired_age_from,
        desiredMem.desired_age_to = req.body.desired_age_to,
        desiredMem.desired_gender = req.body.desired_gender,
        desiredMem.desired_body_type = req.body.desired_body_type,
        desiredMem.desired_height_from = req.body.desired_height_from,
        desiredMem.desired_height_to = req.body.desired_height_to,
        desiredMem.desired_weight_from = req.body.desired_weight_from,
        desiredMem.desired_weight_to = req.body.desired_weight_to,
        desiredMem.desired_maritial_status = req.body.desired_maritial_status,
        desiredMem.desired_country = req.body.desired_country,
        desiredMem.desired_religion_all = req.body.desired_religion_all,
        desiredMem.desired_religion = req.body.desired_religion,
        desiredMem.desired_caste = req.body.desired_caste,
        desiredMem.desired_mother_tongue = req.body.desired_mother_tongue,
        desiredMem.desired_manglik = req.body.desired_manglik,
        // desiredMem.desired_gotra= req.body.desired_gotra,
        // desiredMem.desired_mama_gotra= req.body.desired_mama_gotra,
        desiredMem.desired_education = req.body.desired_education,
        desiredMem.desired_occupation = req.body.desired_occupation,
        desiredMem.desired_income = req.body.desired_income,
        desiredMem.desired_own_house = req.body.desired_own_house,
        desiredMem.desired_family_status = req.body.desired_family_status,
        desiredMem.desired_family_income = req.body.desired_family_income,
        desiredMem.desired_family_type = req.body.desired_family_type,
        desiredMem.desired_family_value = req.body.desired_family_value,
        desiredMem.desired_family_residential_status = req.body.desired_family_residential_status,
        desiredMem.desired_eating_habit = req.body.desired_eating_habit,
        desiredMem.desired_drinking_habit = req.body.desired_drinking_habit,
        desiredMem.desired_smoking_habit = req.body.desired_smoking_habit,
        desiredMem.desired_complexion = req.body.desired_complexion,
        desiredMem.desired_abled = req.body.desired_abled,
        desiredMem.desired_abled_details = req.body.desired_abled_details,
        desiredMem.desired_about_partner = req.body.desired_about_partner,
        desiredMem.desired_is_deleted = req.body.desired_is_deleted,
        desiredMem.desired_member_id = req.body.desired_member_id,
        desiredMem.desired_user_id = req.body.desired_user_id,
        desiredMem.desired_status = req.body.desired_status,
        desiredMem.desired_updated_on = Date.now();
      Desired.addDesired(desiredMem, (err, updatedDesired) => {
        if (err) {
          rc.setResponse(res, {
            msg: err.message,
            data: err.message
          })
        } else {
          rc.setResponse(res, {
            success: true,
            msg: "Data updated successfully",
            data: updatedDesired
          })
        }
      })

    }
  })



};
// Desired.getDesiredByMember(id, (err, desired)=>{
//   if(err){
//     rc.setResponse(res, {
//       msg: "Error in fetching desired",
//       data: err
//     });
//   }else{
//     if(desired){

//       // if(desired.isOld == 'Y'){
//       //   country.getDesiredCountry(desired.desired_country, (err, countries)=>{
//       //     if(err){
//       //       rc.setResponse(res, {
//       //         msg: "Error in fetching countries",
//       //         data: err
//       //       });
//       //     }else{
//       //       religion.getDesiredReligion(desired.desired_religion, (err, religions)=>{
//       //         if(err){
//       //           rc.setResponse(res, {
//       //             msg: "Error in fetching religions",
//       //             data: err
//       //           });
//       //         }else{
//       //             caste.getDesiredCaste(desired.desired_caste, (err, castes)=>{
//       //               if(err){
//       //                 rc.setResponse(res, {
//       //                   msg: "Error in fetching castes",
//       //                   data: err
//       //                 });
//       //               }else{

//       //                 motherTongue.getDesiredMother_tongue(desired.desired_mother_tongue, (err, mt)=>{
//       //                   if(err){
//       //                     rc.setResponse(res, {
//       //                       msg: "Error in fetching mt",
//       //                       data: err
//       //                     });
//       //                   }else{
//       //                     eduDetail.getDesiredEducationDetail(desired.desired_education, (err, educations)=>{
//       //                       if(err){
//       //                         rc.setResponse(res, {
//       //                           msg: "Error in fetching education",
//       //                           data: err
//       //                         });
//       //                       }else{
//       //                         occupation.getDesiredOccupation(desired.desired_occupation,(err, occupations)=>{
//       //                           if(err){
//       //                             rc.setResponse(res, {
//       //                               msg: "Error in fetching occupation",
//       //                               data: err
//       //                             });
//       //                           }else{
//       //                             familyAnnualIncome.getDesiredFamilyIncome(desired.desired_income,(err, incomes)=>{
//       //                               if(err){
//       //                                 rc.setResponse(res, {
//       //                                   msg: "Error in fetching income",
//       //                                   data: err
//       //                                 });
//       //                               }else{
//       //                                 familyStatus.getDesiredFamilyStatus(desired.desired_family_status,(err, fs)=>{
//       //                                   if(err){
//       //                                     rc.setResponse(res, {
//       //                                       msg: "Error in fetching fs",
//       //                                       data: err
//       //                                     });
//       //                                   }else{
//       //                                     familyAnnualIncome.getDesiredFamilyIncome(desired.desired_family_income, (err,fi)=>{
//       //                                       if(err){
//       //                                         rc.setResponse(res, {
//       //                                           msg: "Error in fetching fi",
//       //                                           data: err
//       //                                         });
//       //                                       }else{
//       //                                         familyValue.getDesiredFamilyValue(desired.desired_family_value,(err,fv)=>{
//       //                                           if(err){
//       //                                             rc.setResponse(res, {
//       //                                               msg: "Error in fetching fi",
//       //                                               data: err
//       //                                             });
//       //                                           }else{
//       //                                             desired.desired_religion = '';
//       //                                             for (const it of religions) {
//       //                                               if (religions[0].religion_name == it.religion_name) {
//       //                                                 desired.desired_religion += it.religion_name;
//       //                                               } else {
//       //                                                 desired.desired_religion += ',' + it.religion_name;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_country = '';
//       //                                             for (const it of countries) {
//       //                                               if (countries[0].country_name == it.country_name) {
//       //                                                 desired.desired_country += it.country_name;
//       //                                               } else {
//       //                                                 desired.desired_country += ',' + it.country_name;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_caste = '';
//       //                                             for (const it of castes) {
//       //                                               if (castes[0].caste_name == it.caste_name) {
//       //                                                 desired.desired_caste += it.caste_name;
//       //                                               } else {
//       //                                                 desired.desired_caste += ',' + it.caste_name;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_mother_tongue = '';
//       //                                             for (const it of mt) {
//       //                                               if (mt[0].mother_tongue_name == it.mother_tongue_name) {
//       //                                                 desired.desired_mother_tongue += it.mother_tongue_name;
//       //                                               } else {
//       //                                                 desired.desired_mother_tongue += ',' + it.mother_tongue_name;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_education = '';
//       //                                             for (const it of educations) {
//       //                                               if (educations[0].edu_detail_title == it.edu_detail_title) {
//       //                                                 desired.desired_education += it.edu_detail_title;
//       //                                               } else {
//       //                                                 desired.desired_education += ',' + it.edu_detail_title;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_occupation = '';
//       //                                             for (const it of occupations) {
//       //                                               if (occupations[0].occupation_title == it.occupation_title) {
//       //                                                 desired.desired_occupation += it.occupation_title;
//       //                                               } else {
//       //                                                 desired.desired_occupation += ',' + it.occupation_title;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_income = '';
//       //                                             for (const it of incomes) {
//       //                                               if (incomes[0].family_income_title == it.family_income_title) {
//       //                                                 desired.desired_income += it.family_income_title;
//       //                                               } else {
//       //                                                 desired.desired_income += ',' + it.family_income_title;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_family_status = '';
//       //                                             for (const it of fs) {
//       //                                               if (fs[0].family_status_title == it.family_status_title) {
//       //                                                 desired.desired_family_status += it.family_status_title;
//       //                                               } else {
//       //                                                 desired.desired_family_status += ',' + it.family_status_title;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_family_income = '';
//       //                                             for (const it of fi) {
//       //                                               if (fi[0].family_income_title == it.family_income_title) {
//       //                                                 desired.desired_family_income += it.family_income_title;
//       //                                               } else {
//       //                                                 desired.desired_family_income += ',' + it.family_income_title;
//       //                                               }
//       //                                             }
//       //                                             desired.desired_family_value = '';
//       //                                             for (const it of fv) {
//       //                                               if (fv[0].family_value_title == it.family_value_title) {
//       //                                                 desired.desired_family_value += it.family_value_title;
//       //                                               } else {
//       //                                                 desired.desired_family_value += ',' + it.family_value_title;
//       //                                               }
//       //                                             }
//       //                                             isChange = false;


//       //                                             if(req.body.desired_member_slug){
//       //                                                 desired.desired_member_slug = req.body.desired_member_slug;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_age_from){
//       //                                                 desired.desired_age_from = req.body.desired_age_from;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_age_to){
//       //                                                 desired.desired_age_to = req.body.desired_age_to;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_gender){
//       //                                                 desired.desired_gender = req.body.desired_gender;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_body_type)){
//       //                                               desired.desired_body_type = req.body.desired_body_type.join();

//       //                                               isChange = true;

//       //                                             }
//       //                                             if(req.body.desired_height_from){
//       //                                                 desired.desired_height_from = req.body.desired_height_from;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_height_to){
//       //                                                 desired.desired_height_to = req.body.desired_height_to;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_weight_from){
//       //                                                 desired.desired_weight_from = req.body.desired_weight_from;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_weight_to){
//       //                                                 desired.desired_weight_to = req.body.desired_weight_to;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_maritial_status){
//       //                                                 desired.desired_maritial_status = req.body.desired_maritial_status;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_country)){
//       //                                                 desired.desired_country = req.body.desired_country.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_religion)){
//       //                                                 desired.desired_religion = req.body.desired_religion.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_caste)){
//       //                                                 desired.desired_caste = req.body.desired_caste.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_mother_tongue)){
//       //                                                 desired.desired_mother_tongue = req.body.desired_mother_tongue.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_manglik){
//       //                                                 desired.desired_manglik = req.body.desired_manglik;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_gotra)){
//       //                                                 desired.desired_gotra = req.body.desired_gotra.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_mama_gotra)){
//       //                                                 desired.desired_mama_gotra = req.body.desired_mama_gotra.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_education)){
//       //                                                 desired.desired_education = req.body.desired_education.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_occupation)){
//       //                                                 desired.desired_occupation = req.body.desired_occupation.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_income)){
//       //                                                 desired.desired_income = req.body.desired_income.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_own_house)){
//       //                                                 desired.desired_own_house = req.body.desired_own_house.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_family_status)){
//       //                                                 desired.desired_family_status = req.body.desired_family_status.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_family_income)){
//       //                                                 desired.desired_family_income = req.body.desired_family_income.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_family_type)){
//       //                                                 desired.desired_family_type = req.body.desired_family_type.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_family_value)){
//       //                                                 desired.desired_family_value = req.body.desired_family_value.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_family_residential_status)){
//       //                                                 desired.desired_family_residential_status = req.body.desired_family_residential_status.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_eating_habit){
//       //                                                 desired.desired_eating_habit = req.body.desired_eating_habit;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_drinking_habit){
//       //                                                 desired.desired_drinking_habit = req.body.desired_drinking_habit;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_smoking_habit){
//       //                                                 desired.desired_smoking_habit = req.body.desired_smoking_habit;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_complexion){
//       //                                                 desired.desired_complexion = req.body.desired_complexion;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(Array.isArray(req.body.desired_abled)){
//       //                                                 desired.desired_abled = req.body.desired_abled.join();
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_abled_details){
//       //                                                 desired.desired_abled_details = req.body.desired_abled_details;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_about_partner){
//       //                                                 desired.desired_about_partner = req.body.desired_about_partner;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_is_deleted){
//       //                                                 desired.desired_is_deleted = req.body.desired_is_deleted;
//       //                                                 isChange = true;
//       //                                             }

//       //                                             if(req.body.desired_member_id){
//       //                                                 desired.desired_member_id = req.body.desired_member_id;

//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_user_id){
//       //                                                 desired.desired_user_id = req.body.desired_user_id;
//       //                                                 isChange = true;
//       //                                             }
//       //                                             if(req.body.desired_status){
//       //                                                 desired.desired_status = req.body.desired_status;
//       //                                                 isChange = true;
//       //                                             }

//       //                                             if (isChange) {
//       //                                               desired.isOld = 'N';
//       //                                               console.log(desired);

//       //                                               Desired.addDesired(desired, (err, updatedData) => {
//       //                                                 if (err) {
//       //                                                   rc.setResponse(res, {
//       //                                                     msg: err.message,
//       //                                                     data: err
//       //                                                   });
//       //                                                 } else {
//       //                                                   rc.setResponse(res, {
//       //                                                     success: true,
//       //                                                     msg: "Data updated successfully",
//       //                                                     data: updatedData
//       //                                                   });
//       //                                                 }
//       //                                               });
//       //                                             } else {
//       //                                               rc.setResponse(res, {
//       //                                                 msg: "No changes provided"
//       //                                               });
//       //                                             }

//       //                                           }
//       //                                         })
//       //                                       }
//       //                                     })
//       //                                   }
//       //                                 })
//       //                               }
//       //                             })
//       //                           }
//       //                         })
//       //                       }
//       //                     })
//       //                   }
//       //                 })
//       //               }
//       //             })
//       //         }
//       //       })

//       //     }
//       //   })
//       // }else{
//       //   isChange = false;


//       //   if(req.body.desired_member_slug){
//       //       desired.desired_member_slug = req.body.desired_member_slug;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_age_from){
//       //       desired.desired_age_from = req.body.desired_age_from;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_age_to){
//       //       desired.desired_age_to = req.body.desired_age_to;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_gender){
//       //       desired.desired_gender = req.body.desired_gender;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_body_type){
//       //     desired.desired_body_type = req.body.desired_body_type;

//       //     isChange = true;

//       //   }
//       //   if(req.body.desired_height_from){
//       //       desired.desired_height_from = req.body.desired_height_from;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_height_to){
//       //       desired.desired_height_to = req.body.desired_height_to;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_weight_from){
//       //       desired.desired_weight_from = req.body.desired_weight_from;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_weight_to){
//       //       desired.desired_weight_to = req.body.desired_weight_to;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_maritial_status){
//       //       desired.desired_maritial_status = req.body.desired_maritial_status;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_country){
//       //       desired.desired_country = req.body.desired_country;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_religion){
//       //       desired.desired_religion = req.body.desired_religion;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_caste){
//       //       desired.desired_caste = req.body.desired_caste;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_mother_tongue){
//       //       desired.desired_mother_tongue = req.body.desired_mother_tongue;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_manglik){
//       //       desired.desired_manglik = req.body.desired_manglik;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_gotra){
//       //       desired.desired_gotra = req.body.desired_gotra;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_mama_gotra){
//       //       desired.desired_mama_gotra = req.body.desired_mama_gotra;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_education){
//       //       desired.desired_education = req.body.desired_education;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_occupation){
//       //       desired.desired_occupation = req.body.desired_occupation;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_income){
//       //       desired.desired_income = req.body.desired_income;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_own_house){
//       //       desired.desired_own_house = req.body.desired_own_house;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_family_status){
//       //       desired.desired_family_status = req.body.desired_family_status;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_family_income){
//       //       desired.desired_family_income = req.body.desired_family_income;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_family_type){
//       //       desired.desired_family_type = req.body.desired_family_type;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_family_value){
//       //       desired.desired_family_value = req.body.desired_family_value;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_family_residential_status){
//       //       desired.desired_family_residential_status = req.body.desired_family_residential_status;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_eating_habit){
//       //       desired.desired_eating_habit = req.body.desired_eating_habit;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_drinking_habit){
//       //       desired.desired_drinking_habit = req.body.desired_drinking_habit;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_smoking_habit){
//       //       desired.desired_smoking_habit = req.body.desired_smoking_habit;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_complexion){
//       //       desired.desired_complexion = req.body.desired_complexion;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_abled){
//       //       desired.desired_abled = req.body.desired_abled;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_abled_details){
//       //       desired.desired_abled_details = req.body.desired_abled_details;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_about_partner){
//       //       desired.desired_about_partner = req.body.desired_about_partner;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_is_deleted){
//       //       desired.desired_is_deleted = req.body.desired_is_deleted;
//       //       isChange = true;
//       //   }

//       //   if(req.body.desired_member_id){
//       //       desired.desired_member_id = req.body.desired_member_id;

//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_user_id){
//       //       desired.desired_user_id = req.body.desired_user_id;
//       //       isChange = true;
//       //   }
//       //   if(req.body.desired_status){
//       //       desired.desired_status = req.body.desired_status;
//       //       isChange = true;
//       //   }

//       //   if (isChange) {
//       //     console.log(desired);
//       //     Desired.addDesired(desired, (err, updatedData) => {
//       //       if (err) {
//       //         rc.setResponse(res, {
//       //           msg: err.message,
//       //           data: err
//       //         });
//       //       } else {
//       //         rc.setResponse(res, {
//       //           success: true,
//       //           msg: "Data updated successfully",
//       //           data: updatedData
//       //         });
//       //       }
//       //     });
//       //   } else {
//       //     rc.setResponse(res, {
//       //       msg: "No changes provided"
//       //     });
//       //   }
//       // }


//     }else{
//       rc.setResponse(res, {

//         msg: "No partner preference found"
//       });
//     }
//   }
// })




module.exports.delete = (req, res) => {
  const id = req.body._id;
  Desired.deleteDesired(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
