const Transaction = require("../models/ss-transaction");
const rc = require("./responseController");
const member = require("./../models/new_member");
const event = require("./../models/event");
const plan = require("./../models/subscription-plan");

module.exports.addTransaction = (req, res) => {
  let newTransaction = new Transaction({
    member_id: req.body.member_id,
    amount: req.body.amount,
    transaction: req.body.transaction,
    remark: req.body.remark,
    event_id: req.body.event_id,
    plan_id: req.body.plan_id
  });
  Transaction.addTransaction(newTransaction, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Transaction added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  Transaction.getTransaction(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByMemberId = (req, res) => {
  // Initialize all inputs
  const id = req.body.member_id;
  Transaction.getTransactionByMemberId(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByEventId = (req, res) => {
  // Initialize all inputs
  const id = req.body.event_id;
  Transaction.getTransactionByEventId(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByPlanId = (req, res) => {
  // Initialize all inputs
  const id = req.body.plan_id;
  Transaction.getTransactionByPlanId(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  Transaction.getTransactions((err, data) => {
    if (err) {

      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
function getNames(array, i, j, res) {
  trans = array[j];
  if (i == 0) {

    rc.setResponse(res, {
      success: true,
      msg: "Done",
      data: array
    })
  } else {
    member.getMember(trans.member_id, (err, member) => {
      if (err) {
        rc.setResponse(res, {
          msg: "Error in fetching member",
          data: err
        });
      } else {
        // if (member) {
        event.getEvent(trans.event_id, (err, event) => {
          if (err) {
            rc.setResponse(res, {
              msg: "Error in fetching event",
              data: err
            });
          } else {
            //   if (event) {
            plan.getPlan(trans.plan_id, (err, plan) => {
              if (err) {
                rc.setResponse(res, {
                  msg: "Error in fetching plan",
                  data: err
                });
              } else {
                if (member) {
                  trans.member_id = member.member_name;
                } else {
                  trans.member_id = trans.member_id + '(deleted)';
                }
                if (event) {
                  trans.event_id = event.Title;
                } else {
                  trans.event_id = trans.event_id + '(deleted)';
                }
                if (plan) {
                  trans.plan_id = plan.name;
                } else {
                  trans.plan_id = trans.plan_id + '(deleted)';
                }

                i = i - 1;
                j = j + 1;
                console.log(i);
                getNames(array, i, j, res);
              }
            });
            //   }
          }
        });
        // }
      }
    });
  }
}

module.exports.delete = (req, res) => {
  const id = req.params._id;
  Transaction.deleteTransactionById(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
// module.exports.update = (req, res) => {
//     const id = req.body._id;

//     Transaction.getTransaction(id, (err, data) => {
//       if (err) {
//         rc.setResponse(res, {
//           msg: err.message,
//           data: err
//         });
//       } else {
//         if (data) {
//           let isChange = false;
//           if(req.body.title){
//               isChange = true;
//               data.title = req.body.title
//           }
//           if(req.body.description){
//               isChange = true;
//               data.description = req.body.description
//           }
//           if(req.body.image){
//               isChange = true;
//               data.image = req.body.image
//           }
//           if(req.body.providedBy){
//               isChange = true;
//               data.providedBy = req.body.providedBy
//           }
//           if(isChange) {
//             Transaction.transactiondTransaction(data, (err, newData) => {
//               if (err) {
//                 rc.setResponse(res, {
//                   msg: err.message,
//                   data: err
//                 });
//               } else {
//                 rc.setResponse(res, {
//                   success: true,
//                   msg: "Details updated successfully",
//                   data: newData
//                 });
//               }
//             });
//           } else {
//             rc.setResponse(res, {
//               msg: "No data to update"
//             });
//           }
//         } else {
//           rc.setResponse(res, {
//             msg: "No data found by this id"
//           });
//         }
//       }
//     });
//   };
