const Plan = require("./../models/subscription-plan.js");
const rc = require("./../controllers/responseController");

module.exports.add = (req, res) => {
  let newPlan = new Plan({
    name: req.body.name,
    short_name: req.body.short_name,
    plan_price: req.body.plan_price,
    plan_mrp: req.body.plan_mrp,
    features: req.body.features,
    size: req.body.size,
    price: req.body.price,
    imageUrl: req.body.imageUrl
  });
  Plan.addPlan(newPlan, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  Plan.getPlan(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getPlansByEvent = (req, res) => {
  const id = req.params.id;
  Plan.getPlansByEvent(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  Plan.getAllPlan((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res) => {
  const id = req.body._id;
  Plan.getPlan(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        isChange = false;
        data.lastChanges = {};
        if (req.body.name) {
          (isChange = true), (data.name = req.body.name);
        }
        if (req.body.short_name) {
          (isChange = true), (data.short_name = req.body.short_name);
        }
        if (req.body.plan_price) {
          (isChange = true), (data.plan_price = req.body.plan_price);
        }
        if (req.body.plan_mrp) {
          (isChange = true), (data.plan_mrp = req.body.plan_mrp);
        }

        if (req.body.features) {
          (isChange = true), (data.features = req.body.features);
        }
        if (req.body.size) {
          (isChange = true), (data.size = req.body.size);
        }
        if (req.body.event) {
          (isChange = true), (data.event = req.body.event);
        }
        if (req.body.imageUrl) {
          (isChange = true), (data.imageUrl = req.body.imageUrl);
        }
        if (isChange) {
          Plan.addPlan(data, (err, updatedData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Data updated successfully",
                data: updatedData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No changes provided"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  Plan.deletePlan(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
