import numpy
import os
import cv2
import time
datasets = 'faces'

haar_file = 'haarcascade_frontalface_default.xml'


  
print('Training...')
    
(images, lables, names, id) = ([], [], {}, 0)
for (subdirs, dirs, files) in os.walk(datasets):
	for subdir in dirs:
		names[id] = subdir
		#print(names[id])
		subjectpath = os.path.join(datasets, subdir)  #datasets+'/'+subdir
		for filename in os.listdir(subjectpath):
			# print(filename)
			path = subjectpath + '/' + filename
			lable = id
			images.append(cv2.imread(path, 0))
			lables.append(int(lable))
		id += 1
(width, height) = (200, 200)	

(images, lables) = [numpy.array(lis) for lis in [images, lables]]

print('Creating Model')
model = cv2.face.LBPHFaceRecognizer_create()
print('Model Complete')
print('Model Training')
model.train(images, lables)
print('Training Complete')

# camera_port=0

# camera=cv2.VideoCapture(camera_port) 
while True:
	# retval, im = camera.read()
	subjectpath = './check'
	# print('checking...')
	for filename in os.listdir(subjectpath):
		path = subjectpath + '/' + filename
		im = cv2.imread(path)
		if im is None:
			continue
		face_cascade = cv2.CascadeClassifier('haarcascade_frontalface_default.xml')
		gray = cv2.cvtColor(im, cv2.COLOR_BGR2GRAY)
		faces = face_cascade.detectMultiScale(gray, 1.3, 5)
		
		for (x, y, w, h) in faces:
			cv2.rectangle(im, (x, y), (x+w, y+h), (255, 0, 0), 2)
			face = gray[y:y + h, x:x + w]
			face_resize = cv2.resize(face, (width, height))
			prediction = model.predict(face_resize)   #p[0]=1,p[1]= 56
			faceDetected = 0
			# cv2.rectangle(im, (x, y), (x + w, y + h), (0, 255, 0), 3)
			if prediction[1]<90:
				faceDetected = 1
			# 	cv2.putText(im,'%s - %.0f' % (names[prediction[0]],prediction[1]),(x-10, y-10), cv2.FONT_HERSHEY_PLAIN,1,(0, 255, 0))
			# else:	
			# 	cv2.putText(im,'Not Recognize',(x-10, y-10), cv2.FONT_HERSHEY_PLAIN,1,(0, 255, 0))
			
			
			
			x = open("attendances/" + filename + ".txt","w")
			time1 = time.ctime()
			x.write(str(time1))
			x.write("\t")
			x.write(str(names[prediction[0]]))
			x.write("\n")
			x.close()
			#cv2.waitKey(0)
		# cv2.imshow('img',im)
		if cv2.waitKey(1) & 0xFF == ord('q'):
			break
		
# camera.release()
# cv2.destroyAllWindows()	