const mongoose = require("mongoose");
const config = require("../config/database");

const faceSchema = mongoose.Schema(
  {
    bread_id: { type: String, required: true },
    bread_detail: { type: String, required: true },
    bread_is_deleted: { type: String },
    bread_added_by: { type: String },
    bread_order: { type: String },
    bread_status: { type: String },
    bread_created_on: { type: Date, default: Date.now() }
  },
  { collection: "sbw_m_beard" }
);

const Beard = (module.exports = mongoose.model(
  "sbw_m_beard",
  faceSchema
));

// Add namaj
module.exports.addFace = (face, callback) => {
  Namaj.create(namaj, callback);
};

// read namaj
module.exports.getBeard = callback => {
  Beard.find(callback);
};

//find a namaj by id
module.exports.getNamajById = (Id, callback) => {
  Namaj.findOne({ namaj_id: Id }, callback);
};

//find a namaj by title
module.exports.getNamajByDetail = (detail, callback) => {
  Namaj.findOne({ namaj_detail: detail }, callback);
};

// Update namaj
module.exports.updateNamaj = (id, namaj, options, callback) => {
  var query = { namaj_id: id };
  var update = {};

  if (namaj.namaj_detail) {
    update.namaj_detail = namaj.namaj_detail;
  }
  if (namaj.namaj_is_deleted) {
    update.namaj_is_deleted = namaj.namaj_is_deleted;
  }
  if (namaj.namaj_added_by) {
    update.namaj_added_by = namaj.namaj_added_by;
  }
  if (namaj.namaj_order) {
    update.namaj_order = namaj.namaj_order;
  }
  if (namaj.namaj_status) {
    update.namaj_status = namaj.namaj_status;
  }
  Namaj.findOneAndUpdate(query, update, options, callback);
};

// Delete Namaj
module.exports.removeNamaj = (id, callback) => {
  var query = { namaj_id: id };
  Namaj.remove(query, callback);
};
