const mongoose = require("mongoose");
const config = require("./../config/database");

const stateSchema = mongoose.Schema(
  {
    name: {
      type: String
    },
    short_name: {
      type: String
    },
    plan_mrp: {
      type: String
    },
    plan_price: {
      type: String
    },
    features: {
      type: String
    },
    size: {
      type: String,
      default: ""
    },
    event: {
      type: String,
      default: ""
    },
    imageUrl: {
      type: String,
      default: ""
    }
  },
  { collection: "book_subscription_plans" }
);

const Plan = (module.exports = mongoose.model(
  "book_subscription_plans",
  stateSchema
));

// Create and update
module.exports.addPlan = (newPlan, callback) => {
  newPlan.save(callback);
};

// Get by id
module.exports.getPlan = (id, callback) => {
  Plan.findById(id, callback);
};

// Get by event id
module.exports.getPlansByEvent = (evId, callback) => {
  Plan.find({ event: evId }, callback);
};

//Get all states
module.exports.getAllPlan = callback => {
  Plan.find(callback);
};

//Delete by id
module.exports.deletePlan = (id, callback) => {
  Plan.findByIdAndDelete(id, callback);
};
