const config = require('../config/database');
const mongoose = require('mongoose');

const citySchema = mongoose.Schema({
    city_id:{
        type: String,
        default:''
    },
    city_name:{
        type: String,
        default: ''
    },
    city_slug:{
        type: String,
        default: ''
    },
    city_state_id:{
        type: String,
        default: ''
    },
    city_country_id:{
        type: String,
        default: ''
    },
    city_order:{
        type: String,
        default: ''
    },
    city_cost1: {
        type: String,
        default: ''
    },
    city_cost2: {
        type: String,
        default: ''
    },
    city_added_by:{
        type: String,
        default: ''
    },
    city_is_deleted :{
        type:String,
        default: ''
    },
    city_created_on:{
        type: Date,
        default: Date.now()
    },
    city_status:{
        type: String,
        default: ''
    },
    city_state_name:{
        type: String,
        default:''
    },
    lastChanges:{
        type: JSON,
        default: {}
    }

},{collection:'sbw_cities'});

const city = (module.exports = mongoose.model('sbw_cities',citySchema));

// Create and update
module.exports.addCity = (newCity, callback)=>{
    newCity.save(callback);

};

// get city 
module.exports.getCity = ( id, callback)=>{
    city.findById(id, callback);
};
//get city by name
module.exports.getCitiesByName = ( scity, callback)=>{
    const q = new RegExp(scity, 'gi');
    city.find({city_name:q}, callback);
}

// get all cities
module.exports.getAllCity =(callback)=>{
    city.find(callback);
};
// get all cities name
module.exports.getAllCityNames =(callback)=>{
    city.find(null, {"city_name": true, city_id: true }, callback);
};

//delete city
module.exports.deleteCity = (id, callback)=>{
    city.findByIdAndDelete(id, callback);
};
