const mongoose = require('mongoose');
const config = require('../config/database');

const districtSchema = mongoose.Schema({
  name: { type: String, required: true },
  state: { type: String },
  country: { type: String },
});

const District = (module.exports = mongoose.model('district', districtSchema));

module.exports.addDistrict = (newDistrict, callback) => {
  newDistrict.save(callback);
};

module.exports.getDistrictByState = (stateName, callback) => {
  District.find({ state: stateName }, callback);
};

module.exports.getDistrictByName = (district, callback) => {
  District.findOne({ name: district }, callback);
};


module.exports.getDistricts = callback => {
  District.find(callback);
};
