const mongoose = require('mongoose');
const config = require('../config/database');

const educationDetailSchema = mongoose.Schema({
    edu_detail_id: { type: String, required: true },
    edu_detail_category: { type: String },
    edu_detail_title: { type: String, required: true },
    edu_detail_status: { type: String },
    edu_detail_slug: { type: String },
    edu_detail_is_deleted: { type: Boolean,  },
    edu_detail_added_by: { type: String },
    edu_detail_order: { type: String },
    edu_detail_created_on: { type: Date, default: Date.now() }
}, { collection: 'sbw_education_details'});

const EducationDetail = (module.exports = mongoose.model('sbw_education_details', educationDetailSchema));

// Add educationDetail
module.exports.addEducationDetail = (educationDetail, callback) => {
	EducationDetail.create(educationDetail, callback);
}

// read educationDetail
module.exports.getEducationDetail = (callback) => {
	EducationDetail.find(callback);
}
module.exports.getDesiredEducationDetail = (id, callback) => {
	EducationDetail.find({edu_detail_id: {$in: id}},callback);
}
// read educationDetail names
module.exports.getEducationDetailNames = (callback) => {
	EducationDetail.find(null,{"edu_detail_title": true}, callback);
}

//find a educationDetail by id
module.exports.getEducationDetailById=(Id,callback)=>{
  EducationDetail.findOne({"edu_detail_id":Id},callback);
}

//find a educationDetail by title
module.exports.getEducationDetailByTitle=(title,callback)=>{
  EducationDetail.findOne({"edu_detail_title":title},callback);
}


// Update educationDetail
module.exports.updateEducationDetail = (id, educationDetail, options, callback) => {
    var query = {edu_detail_id: id};
    var update = {};
    if(educationDetail.edu_detail_category){
        update.edu_detail_category = educationDetail.edu_detail_category;
    }
    if(educationDetail.edu_detail_title){
        update.edu_detail_title = educationDetail.edu_detail_title;
    }
    if(educationDetail.edu_detail_status){
        update.edu_detail_status = educationDetail.edu_detail_status;
    }
    if(educationDetail.edu_detail_slug){
        update.edu_detail_slug = educationDetail.edu_detail_slug;
    }
    if(educationDetail.edu_detail_category){
        update.edu_detail_order = educationDetail.edu_detail_order;
    }
	
	EducationDetail.findOneAndUpdate(query, update, options, callback);
}


// Delete EducationDetail
module.exports.removeEducationDetail = (id, callback) => {
	// var query = {edu_detail_id: id};
	EducationDetail.findByIdAndDelete(id, callback);
}


