const config = require('../config/database');
const mongoose = require('mongoose');

const EventSchema = mongoose.Schema({
    Title: {
        type: String
    },
    shortTitle: {
        type: String
    },
    description: {
        type: String
    },
    live: {
        type: Boolean
    },
    running: {
        type: Boolean
    },
    caste: {
        type: String
    },
    incomeRange: {
        type: String
    },
    limit: {
        type: String
    },
    startedAt: {
        type: Date
    },
    endedAt: {
        type: Date
    },
    createdAt: {
        type: Date,
        default: Date.now()
    },
    updatedAt: {
        type: Date
    },
},{collection:'ss_events'});

const Event = (module.exports = mongoose.model('ss_events',EventSchema));

// Create and update
module.exports.addEvent = (newEvent, callback)=>{
    newEvent.save(callback);

};

// get  
module.exports.getEvent = ( id, callback)=>{
    Event.findById(id, callback);
};


// get all 
module.exports.getAllEvents =(callback)=>{
    Event.find(callback);
};


//delete 
module.exports.deleteEvent = (id, callback)=>{
    Event.findByIdAndDelete(id, callback);
};
