const config = require("../config/database");
const mongoose = require("mongoose");

const gotraSchema = mongoose.Schema(
  {
    gotra_id: {
      type: String,
      default: ""
    },
    gotra_name: {
      type: String,
      default: ""
    },
    gotra_slug: {
      type: String,
      default: ""
    },
    gotra_religion_name: {
      type: String,
      default: ""
    },
    gotra_caste_name: {
      type: String,
      default: ""
    },
    gotra_sub_caste_name: {
      type: String,
      default: ""
    },
    gotra_added_by: {
      type: String,
      default: ""
    },
    gotra_updated_by: {
      type: String,
      default: ""
    },
    gotra_created_on: {
      type: Date,
      default: Date.now()
    },
    gotra_is_deleted: {
      type: String,
      default: ""
    },
    gotra_updated_on: {
      type: Date
    },
    gotra_order: {
      type: String,
      default: ""
    },
    gotra_status: {
      type: String,
      default: ""
    },
    lastChanges: {
      type: JSON,
      default: {}
    }
  },
  { collection: "sbw_gotras" }
);

const gotra = (module.exports = mongoose.model("sbw_gotras", gotraSchema));

// Create and update
module.exports.addGotra = (newGotra, callback) => {
  newGotra.save(callback);
};

// get gotra
module.exports.getGotra = (id, callback) => {
  gotra.findById(id, callback);
};

// get all cities
module.exports.getAllGotra = callback => {
  gotra.find(callback);
};

//delete gotra
module.exports.deleteGotra = (id, callback) => {
  gotra.findByIdAndDelete(id, callback);
};
