const mongoose = require('mongoose');
const config = require('../config/database');

const IncomeRangeSchema = mongoose.Schema({
    name: { type: String, },
    // shortName: { type: String },
    low: { type: Number },
    high: { type: Number },
});

const IncomeRange = (module.exports = mongoose.model('incomeRange', IncomeRangeSchema));

module.exports.addIncomeRange = (newRange, callback) => {
    newRange.save(callback);
};

module.exports.getIncomeRangeByName = (name, callback) => {
    IncomeRange.findOne({ name: name }, callback);
};

// module.exports.getIncomeRangeByShortName = (SN, callback) => {
//     IncomeRange.findOne({ shortName: SN }, callback);
// };

module.exports.getAllIncomeRange = callback => {
    IncomeRange.find(callback);
};

module.exports.getIncomeRangeById = (id, callback) => {
    IncomeRange.findOne({ _id: id }, callback);
};

module.exports.getIncomeRangeByLowValue = (low, callback) => {
    IncomeRange.findOne({ low: low }, callback);
};

module.exports.getIncomeRangeByHighValue = (high, callback) => {
    IncomeRange.findOne({ high: high }, callback);
};

module.exports.getIncomeRangeByLowHigh = (low, high, callback) => {
    IncomeRange.findOne({ $and: [{ low: low }, { high: high }] }, callback);
};

module.exports.getInRange = (low, high, callback) => {
    IncomeRange.find({ $and: [{ low: { $gt: low } }, { high: { $lt: high } }] }, callback);
};
