const mongoose = require('mongoose');
const config = require('../config/database');

const MemberSchema = mongoose.Schema({
    memberType: { type: String, required: true },
    packageName: { type: String, required: true },
    // 
    name: { type: String, required: true },
    mobile: { type: String, required: true },
    city: { type: String, required: true },
    state: { type: String, required: true },
    gender: { type: String, required: true },
    followup: { type: Array, default: [] },
    sendAddress: { type: Array, default: [] },
    messages: { type: Array, default: [] },
    // 
    createdBy: { type: String, required: true },
    createdAt: {
        type: Date,
        default: Date.now()
    },
    updatedAt: { type: Date }
});

const Member = (module.exports = mongoose.model("Member", MemberSchema));

module.exports.addMember = (newMember, callback) => {
    newMember.save(callback);
};

module.exports.getMemberById = (id, callback) => {
    Member.findOne({ _id: id }, callback);
}

module.exports.getMembers = (callback) => {
    Member.find(callback);
};