const mongoose = require('mongoose');
const config = require('../config/database');

const namajSchema = mongoose.Schema({
    namaj_id: { type: String, required: true },
    namaj_detail: { type: String, required: true },
    namaj_is_deleted: { type: String  },
    namaj_added_by: { type: String },
    namaj_order: { type: String },
    namaj_status: { type: String },
    namaj_created_on: { type: Date, default: Date.now() },
}, { collection: 'sbw_namaj'});

const Namaj = (module.exports = mongoose.model('sbw_namaj', namajSchema));

// Add namaj
module.exports.addNamaj = (namaj, callback) => {
	Namaj.create(namaj, callback);
}

// read namaj
module.exports.getNamaj = (callback) => {
	Namaj.find(callback);
}

//find a namaj by id
module.exports.getNamajById=(Id,callback)=>{
  Namaj.findOne({"namaj_id":Id},callback);
}

//find a namaj by title
module.exports.getNamajByDetail=(detail,callback)=>{
  Namaj.findOne({"namaj_detail":detail},callback);
}


// Update namaj
module.exports.updateNamaj = (id, namaj, options, callback) => {
    var query = {namaj_id: id};
    var update = {};
    
    if(namaj.namaj_detail){
        update.namaj_detail = namaj.namaj_detail;
    }
    if(namaj.namaj_is_deleted){
        update.namaj_is_deleted = namaj.namaj_is_deleted;
    }
    if(namaj.namaj_added_by){
        update.namaj_added_by = namaj.namaj_added_by;
    }
    if(namaj.namaj_order){
        update.namaj_order = namaj.namaj_order;
    }
    if(namaj.namaj_status){
        update.namaj_status = namaj.namaj_status;
    }
    Namaj.findOneAndUpdate(query, update, options, callback);
}


// Delete Namaj
module.exports.removeNamaj = (id, callback) => {
	var query = {namaj_id: id};
	Namaj.remove(query, callback);
}


