const mongoose = require('mongoose');
const config = require('../config/database');

const OldOfficePackSchema = mongoose.Schema({
    packageName: { type: String },
    packageAmount: { type: String },
    distributionCount: { type: String },
    createdBy: { type: String },
    createdAt: {
        type: Date,
        default: Date.now()
    },
    updatedBy: { type: String },
    updatedAt: { type: Date, default: Date.now() }
});

const OfficePackage = (module.exports = mongoose.model(
    'OldOfficePackage',
    OldOfficePackSchema
));

module.exports.addPackage = (newPackage, callback) => {
    newPackage.save(callback);
};

module.exports.getPackageById = (id, callback) => {
    OfficePackage.findOne({ _id: id }, callback);
};

module.exports.getPackageByName = (packageName, callback) => {
    OfficePackage.findOne({ packageName: packageName }, callback);
};

module.exports.getAllPackages = function (callback) {
    OfficePackage.find(callback);
};

