const mongoose = require("mongoose");
const config = require("./../config/database");

const religionSchema = mongoose.Schema(
  {
    religion_id: {
      type: String,
      default: ""
    },
    religion_name: {
      type: String,
      default: ""
    },
    religion_slug: {
      type: String,
      default: ""
    },
    religion_added_by: {
      type: String,
      default: ""
    },
    religion_is_deleted: {
      type: String,
      default: ""
    },
    religion_updated_by: {
      type: String,
      default: ""
    },
    religion_order: {
      type: String,
      default: ""
    },
    religion_created_on: {
      type: Date,
      default: Date.now()
    },
    religion_updated_on: {
      type: Date
    },
    religion_status: {
      type: String,
      default: ""
    },
    lastChanges: {
        type: JSON,
        default: {}
    }
},
  { collection: "sbw_religions" }
);

const religion = (module.exports = mongoose.model(
  "sbw_religions",
  religionSchema
));

// Create and update
module.exports.addReligion = (newReligion, callback) => {
  newReligion.save(callback);
};
// Get by id
module.exports.getReligion = (id, callback) => {
  religion.findById(id, callback);
};
//Get all religions
module.exports.getAllReligion = callback => {
  religion.find(callback);
};
module.exports.getDesiredReligion = (id,callback) => {
  religion.find({religion_id: {$in:id}},callback);
};


//Get all religions names
module.exports.getAllReligionNames = callback => {
  religion.find(null, {"religion_name": true, religion_id: true},callback);
};

//Delete by id
module.exports.deleteReligion = (id, callback) => {
  religion.findByIdAndDelete(id, callback);
};


    