const mongoose = require('mongoose');
const config = require('../config/database');

const roleSchema = mongoose.Schema({
  name: { type: String },
  remark: { type: String },
  topRole: { type: String, default: 'super-admin' },
  permissions: {
    type: JSON,
    default: {
      leadManagment: {
        view: false,
        calling: false,
        edit: false,
        messeage: false,
        email: false,
        whatsapp: false,
        createNewEnquiry: false,
        createNewLead: false,
        newLeads: false,
        oldLeads: false,
        npc: false,
        callback: false,
        interested: false,
        prospect: false,
        quotation: false,
        closed: false,
        order: false,
        approval: false,
        dispatch: false,
        billing: false,
        outstanding: false,
        return: false,
        payment: false,
      },

      master: {
        create: false,
        view: false,
        edit: false,
        delete: false,
        createCountry: false,
        createState: false,
        createDistrict: false,
        createCity: false,
        officePackage: false,
        newUser: false,
        newOffice: false,
        createPackage: false,
        followUpType: false,
        newPurpose: false,
        annualIncome: false,
        newSource: false,
        privilageCoupen: false,
        newRole: false,
        viewUsers: false,
        viewCountries: false,
        viewStates: false,
        viewDistricts: false,
        viewCities: false,
        viewLeadPacks: false,
        viewOfficePacks: false,
        viewOffices: false,
        viewAnnualIncome: false,
        viewMember: false,
        followUpTypes: false,
        viewPurpose: false,
        viewSources: false,
        viewRoles: false,
        editviewUsers: false,
        editviewCountries: false,
        editviewStates: false,
        editviewDistricts: false,
        editviewCities: false,
        editviewLeadPacks: false,
        editviewOfficePacks: false,
        editviewOffices: false,
        editviewAnnualIncome: false,
        editviewMember: false,
        editfollowUpTypes: false,
        editviewPurpose: false,
        editviewSources: false,
        editviewRoles: false,
        deleteviewUsers: false,
        deleteviewCountries: false,
        deleteviewStates: false,
        deleteviewDistricts: false,
        deleteviewCities: false,
        deleteviewLeadPacks: false,
        deleteviewOfficePacks: false,
        deleteviewOffices: false,
        deleteviewAnnualIncome: false,
        deleteviewMember: false,
        deletefollowUpTypes: false,
        deleteviewPurpose: false,
        deleteviewSources: false,
        deleteviewRoles: false,
      },

      // subOfficeManagment: {
      //   create: false,
      //   view: false,
      //   edit: false
      // },

      messagePermission: {
        enable: false
      },

      roleManagment: {
        enable: false,
      },

      leadMapping: {
        enable: false
      },

      leadsBulkUpload: {
        enable: false
      },

      viewReports: {
        enable: false,
      },

      ss: {
        enable: false,
        members: {
          create: false,
          view: false,
          edit: false,
          delete: false,
          export: false,
          enable: false
        },
        adminapprove: {
          // create: true,
          view: false,
          edit: false,
          // delete: true,
          enable: false
        },
        registeruser: {
          create: false,
          // view: true,
          // edit: true,
          // delete: true,
          enable: false
        },
        transaction: {
          // create: true,
          view: false,
          // edit: true,
          // delete: true,
          export: false,
          enable: false
        },
      }
    }
  },
  createdBy: { type: String },
  updatedBy: { type: String },
  createdAt: { type: Date, default: Date.now() },
  updatedAt: { type: Date }
});

const Role = (module.exports = mongoose.model('role', roleSchema));

module.exports.addRole = (newRole, callback) => {
  newRole.save(callback);
};

module.exports.getRoleByTopRole = (topRole, callback) => {
  Role.findOne({ topRole: topRole }, callback);
};

module.exports.getRolebyName = (role, callback) => {
  Role.findOne({ name: role }, callback);
};

module.exports.getRolePermissions = (role, callback) => {
  Role.findOne({ name: role }, { permissions: 1 }, callback);
};

module.exports.getRoleById = (id, callback) => {
  Role.findOne({ _id: id }, callback);
};

module.exports.getAllRoles = callback => {
  Role.find(callback);
};

module.exports.deleteRole = (id, callback) => {
  Role.findByIdAndDelete(id, callback);
};
