const mongoose = require('mongoose');
const config = require('../config/database');

const siteInfoSchema = mongoose.Schema({
    siteTitle: {
        type: String,
        default: ''
    },
    metaDescription: {
        type: String,
        default: ''
    },
    siteLogo: {
        type: String,
        default: ''
    },
    watermarkLogo: {
        type: String,
        default: ''
    },
    siteIcon: {
        type: String,
        default: ''
    },
    score: {
        type: JSON,
        default: {
            cb: 6,
            in: 7,
            pr: 7,
            cl: 5,
            ap: 10,
        }
    },
    contactNumber: {
        type: JSON,
        default: {
            primary: '',
            secondary: ''
        }
    },
    contactEmail: {
        type: JSON,
        default: {
            primary: '',
            secondary: ''
        }
    },
    lastChanges: {
        type: JSON,
        default: {}
    },
    createdAt: { type: Date, default: Date.now() },
    updatedAt: { type: Date },
    createdBy: {
        type: String
    },
    updatedBy: {
        type: String
    },
});

const siteInfo = (module.exports = mongoose.model('sbw_siteInfo', siteInfoSchema));

// create <==> update
module.exports.addSiteInfo = (newSiteInfo, callback) => {
    newSiteInfo.save(callback);
};

// read
module.exports.getSiteInfo = (callback) => {
    siteInfo.findOne(callback);
};

// delete
module.exports.deleteSiteInfo = (id, callback) => {
    siteInfo.findByIdAndDelete(id, callback);
};
