const mongoose = require('mongoose');
const config = require('../config/database');

const SSTransactionSchema = mongoose.Schema({
  member_id: {
      type: JSON
  },
  amount: {
      type: String
  },
  transaction: {
      type: String
  },
  remark: {
      type: String
  },
  event_id: {
      type: JSON
  },
  plan_id: {
      type: JSON
  }
  
});

const SSTransaction = (module.exports = mongoose.model(
  'SS_Transactions',
  SSTransactionSchema
));

module.exports.addTransaction = (newTransaction, callback) => {
  newTransaction.save(callback);
};

module.exports.getTransaction = (id, callback)=>{
  SSTransaction.findOne({_id: id}, callback);
}

module.exports.getTransactionByMemberId = (id, callback) =>{
    SSTransaction.find({member_id: id}, callback);
}
module.exports.getTransactionByEventId = (id, callback) =>{
    SSTransaction.find({event_id: id}, callback);
}
module.exports.getTransactionByPlanId = (id, callback) =>{
    SSTransaction.find({plan_id: id}, callback);
}

module.exports.getTransactions = callback => {
  SSTransaction.find(callback);
};
// module.exports.getTransactions = callback => {
//   SSTransaction.aggregate([
//     {
//      $lookup: {
//        from: "sbw_current_members",
//        localField: "member_id",
//        foreignField: "_id",  
//        as: "memberx"
//      }
//     },
//     {
//      $lookup: {
//        from: "ss_events",
//        localField: "event_id",
//        foreignField: "_id",
//        as: "eventx"
//      }
//     },
//     {
//      $lookup: {
//        from: "sbw_subscription_plans",
//        localField: "plan_id",
//        foreignField: "_id",
//        as: "planx"
//      }

//     },
//     {
//       $unwind: { path: "$memberx", preserveNullAndEmptyArrays: true }
//     },
//     {
//       $unwind: { path: "$eventx", preserveNullAndEmptyArrays: true }
//     },
//     {
//       $unwind: { path: "$planx", preserveNullAndEmptyArrays: true }
//     },
//     {
//       $project:{
//         _id:1,
//         member_id: "$memberx.member_name",
//         amount: 1,
//         transaction: 1,
//         remark: 1,
//         event_id: "$eventx.Title",
//         plan_id: "$planx.name"
//       }
//     }
//   ], callback);
// };
module.exports.getTransByMemEvent = (member, event, callback)=>{
  SSTransaction.findOne({member_id: member, event_id: event}, callback)
}

module.exports.deleteTransactionById = (id, callback) => {
  Transaction.deleteOne({ _id: id }, callback);
};
