const mongoose = require('mongoose');
const config = require('../config/database');

const stateSchema = mongoose.Schema({
  stateName: { type: String, required: true },
  allotedBy: { type: String },
  cities: { type: Array, default: [] },
  countryName: { type: String, required: true },
  createdAt: { type: Date, default: Date.now() }
});

const State = (module.exports = mongoose.model('state', stateSchema));

module.exports.addState = (newState, callback) => {
  newState.save(callback);
};

module.exports.getStateByStatecode = (statecode, callback) => {
  State.findOne({ stateCode: statecode }, callback);
};

module.exports.getStatebyName = (state, callback) => {
  State.findOne({ stateName: state }, callback);
};

module.exports.getStatebyCountry = (country, callback) => {
  // console.log(country)
  State.find({ countryName: country }, callback);
};

module.exports.getStateById = (id, callback) => {
  State.findOne({ _id: id }, callback);
};

module.exports.getAllStates = callback => {
  State.find(callback);
};
