const mongoose = require("mongoose");
const config = require("./../config/database");

const stateSchema = mongoose.Schema(
  {
    state_id: {
      type: String,
      default: ""
    },
    state_name: {
      type: String,
      default: ""
    },
    state_slug: {
      type: String,
      default: ""
    },
    state_code: {
      type: String,
      default: ""
    },
    state_country_id: {
      type: String,
      default: ""
    },
    state_order: {
      type: String,
      default: ""
    },
    state_is_deleted: {
      type: String,
      default: ""
    },
    state_created_on: {
      type: Date,
      default: Date.now()
    },
    state_updated_on: {
      type: Date
    },
    state_updated_by: {
      type: String
    },
    state_status: {
      type: String,
      default: ""
    },
    lastChanges: {
      type: JSON,
      default: {}
    }
  },
  { collection: "sbw_states" }
);

const state = (module.exports=mongoose.model('sbw_states', stateSchema));

// Create and update
module.exports.addState = (newState, callback) => {
  newState.save(callback);
};
// Get by id
module.exports.getState = (id, callback) => {
  state.findById(id, callback);
};
//Get all states
module.exports.getAllState = callback => {
  state.find(callback);
};
//Get all states name
module.exports.getAllStateNames = callback => {
  state.find(null,{"state_name": true, state_id: true }, callback);
};

//Delete by id
module.exports.deleteState = (id, callback) => {
  state.findByIdAndDelete(id, callback);
};

