const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const User = require('../models/user');
const State = require('../models/allstate');
const Helpers = require('../Helpers/Helpers');
const AllStates = require('../models/state.js');

router.get(
    '/get-states',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        State.getAllStates((err, states) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                res
                    .status(200)
                    .json({ success: true, msg: 'states are found', states: states });
            }
        });
    }
);

module.exports = router;