// make - request - approve;
const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const User = require('../models/user');
const Request = require('../models/request');
const ApprovedRequest = require('../models/approvedRequest');

router.post('/makeRequestApprove', passport.authenticate('jwt', { session: false }), (req, res) => {
  let requestId = req.body.requestId;
  let request = new ApprovedRequest({
    officeId: req.body.officeId,
    approvedFor: req.body.approvedFor,
    approvedAmt: req.body.approvedAmt,
    approvedBy: req.body.approvedBy,
    remark: req.body.remark,
    transactionId: req.body.transactionId
  });

  ApprovedRequest.addApprovedRequest(request, (err, respRequest) => {
    if (err) {
      res
        .status(200)
        .json({ success: false, msg: 'Error in approving request', err: err });
    } else {
      if (respRequest) {
        // User wallet update
        User.getUserByUsername(req.body.approvedFor, (err, user) => {
          if (err) {
            res
              .status(200)
              .json({ success: false, msg: 'Something went wrong', err: err });
          } else {
            if (user) {
              user.wallet =
                parseFloat(user.wallet) - parseFloat(req.body.approvedAmt);
              // console.log(user.wallet);
              User.addUser(user, (err, user) => {
                if (err) {
                  res.status(200).json({
                    success: false,
                    msg: 'something went wrong ',
                    err: err
                  });
                } else {
                  if (user) {
                    // update request isApproved flag
                    Request.getRequestById(requestId, (err, request) => {
                      if (err) {
                        res.status(200).json({
                          success: false,
                          msg: 'Error in updating request approve flag.',
                          err: err
                        });
                      } else {
                        if (request) {
                          request.isApproved = true;
                          request.approvedDate = Date.now();
                          Request.addRequest(request, (err, RespRequest) => {
                            if (err) {
                              res.status(200).json({
                                success: false,
                                msg: 'error in updating request flag'
                              });
                            } else {
                              if (RespRequest) {
                                res.status(200).json({
                                  success: true,
                                  msg: 'Request approved send successfully..'
                                });
                              } else {
                                res.status(200).json({
                                  success: true,
                                  msg: 'Request approved send successfully..'
                                });
                              }
                            }
                          });
                        } else {
                          res.status(200).json({
                            success: false,
                            msg: 'request not found for update.'
                          });
                        }
                      }
                    });
                    //   request flag update end
                  } else {
                    res.status(200).json({
                      success: false,
                      msg: 'something went wrong/ user not found '
                    });
                  }
                }
              });
            } else {
              res.status(200).json({ success: false, msg: 'Admin not found' });
            }
          }
        });
      } else {
        res.status(200).json({ success: false, msg: 'Request not approved..' });
      }
    }
  });
});

router.get('/get-all-approved-requests', passport.authenticate('jwt', { session: false }), (req, res) => {
  ApprovedRequest.getAllApprovedRequest((err, requests) => {
    if (err) {
      res.status(200).json({
        success: false,
        msg: 'Error in fetching approved request',
        err: err
      });
    } else {
      res.status(200).json({
        success: true,
        msg: 'Approved requests are found',
        requests: requests
      });
    }
  });
});

module.exports = router;
