const Beard = require('../models/beard');
const express = require('express');
const router = express.Router();



//route to create Namaj
router.post('/createNamaj', (req, res) => {
	var namaj = req.body;
	Namaj.addNamaj(namaj, (err, namaj) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, namaj:namaj});
        }
		
	});
});

//route to read Namaj
router.get('/readBeard', (req, res) => {
	Beard.getBeard((err, beard) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:beard});
        }
		
	});
});

//route to find a namaj by id
router.get('/NamajById/:namaj_id',(req,res)=>{
	
	Namaj.getNamajById(req.params.namaj_id,(err,namaj)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(namaj===null){
				res.status(200).json({success:true, msg:"no namaj found by this id"});
				}else{
					res.status(200).json({success:true, namaj:namaj});
				}
            }
	});
});

//route to find a namaj by detail
router.get('/NamajByDetail/:namaj_detail',(req,res)=>{
	
	Namaj.getNamajByDetail(req.params.namaj_detail,(err,namaj)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(namaj===null){
			res.status(200).json({success:true, msg:"no namaj found by such detail"});
			}else{
				res.status(200).json({success:true, namaj:namaj});
			}
            	
            }
	});
});

			
		

//route to update Namaj
router.put('/updateNamaj/:namaj_id', (req, res) => {
	var id = req.params.namaj_id;
    var enamaj = req.body;
    Namaj.getNamajById(id, (err, namaj) => {

        if(err){
            res.status(500).json({success:false, msg:err});
            
        }else{
            if(namaj){
                Namaj.updateNamaj(id, enamaj, {}, (err, upnamaj) => {
                    if(err){
                        res.status(500).json({success:false, msg:err});
                        
                    }else{
                        res.status(200).json({success:true, namaj:upnamaj});
                    }
                });
            } else {
                res.status(200).json({success:false, msg: 'No details found by this id'});
            }
        }
    });
});

//route to delete Namaj
router.delete('/deleteNamaj/:namaj_id', (req, res) => {
	var id = req.params.namaj_id;
	Namaj.removeNamaj(id, (err, namaj) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, namaj:namaj});
        }
	});
});



module.exports = router;


