const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const User = require('../models/user');
const State = require('../models/state');
const Country = require('../models/country');
const Helpers = require('../Helpers/Helpers');

router.get(
    '/get-countries',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        Country.getCountries((err, countries) => {
            if (err) {
                res.json({ success: false, msg: 'Error in fetching countries', err: JSON.stringify(err) });
            } else {
                res.json({ success: true, msg: 'countries are found', countries: countries });
            }
        });
    });

router.post('/create-country', passport.authenticate('jwt', { session: false }), (req, res) => {

    Country.getCountryByName(Helpers.firstUpper(req.body.countryName), (err, country) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching countries', err: JSON.stringify(err) });
        } else {
            // console.log(country);
            if (country) {
                res.json({ success: false, msg: 'Country is already created' })
            } else {
                let addingcountry = new Country({
                    name: Helpers.firstUpper(req.body.countryName),
                });
                Country.addCountry(addingcountry, (err, newcountry) => {
                    if (err) {
                        res.json({ success: false, msg: 'Error in fetching countries', err: JSON.stringify(err) });
                    } else {
                        if (newcountry) {
                            res.json({ success: true, msg: 'country created successfully', country: newcountry });
                        } else {
                            res.json({ success: false, msg: 'country not created' });
                        }
                    }
                });
            }
        }
    });
});

module.exports = router;
