const EducationDetail = require('../models/education-detail');
const express = require('express');
const router = express.Router();



//route to create EducationDetail
router.post('/create', (req, res) => {
	var educationDetail = req.body;
	EducationDetail.addEducationDetail(educationDetail, (err, educationDetail) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, educationDetail:educationDetail});
        }
		
	});
});

//route to read EducationDetail
router.get('/getAll', (req, res) => {
	EducationDetail.getEducationDetail((err, educationDetail) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:educationDetail});
        }
		
	});
});

//route to find a educationDetail by id
router.get('/EducationDetailById/:edu_detail_id',(req,res)=>{
	
	EducationDetail.getEducationDetailById(req.params.edu_detail_id,(err,educationDetail)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(educationDetail===null){
				res.status(200).json({success:true, msg:"no educationDetail found by this id"});
				}else{
					res.status(200).json({success:true, educationDetail:educationDetail});
				}
            }
	});
});

//route to find a educationDetail by title
router.get('/EducationDetailByTitle/:edu_detail_title',(req,res)=>{
	
	EducationDetail.getEducationDetailByTitle(req.params.edu_detail_title,(err,educationDetail)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(educationDetail===null){
			res.status(200).json({success:true, msg:"no educationDetail found by such title"});
			}else{
				res.status(200).json({success:true, educationDetail:educationDetail});
			}
            	
            }
	});
});

			
		

//route to update EducationDetail
router.put('/update/:edu_detail_id', (req, res) => {
	var id = req.params.edu_detail_id;
    var eeducationDetail = req.body;
    EducationDetail.getEducationDetailById(id, (err, educationDetail) => {

        if(err){
            res.status(500).json({success:false, msg:err});
            
        }else{
            if(educationDetail){
                EducationDetail.updateEducationDetail(id, eeducationDetail, {}, (err, upeducationDetail) => {
                    if(err){
                        res.status(500).json({success:false, msg:err});
                        
                    }else{
                        res.status(200).json({success:true, educationDetail:upeducationDetail});
                    }
                });
            } else {
                res.status(200).json({success:false, msg: 'No details found by this id'});
            }
        }
    });
});

//route to delete EducationDetail
router.delete('/delete/:edu_detail_id', (req, res) => {
	const id = req.params.edu_detail_id;
	EducationDetail.removeEducationDetail(id, (err, educationDetail) => {
		if(err){
            res.status(200).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, msg: 'Deleted Sucessfully', educationDetail:educationDetail});
        }
	});
});



module.exports = router;


