const express = require('express');
const router = express.Router();
const passport = require('passport');
const eventController = require('./../controllers/eventController');

router.post('/create'
    // ,passport.authenticate('jwt', { session: false })
    , eventController.add);
router.post('/suscribeMembers'
    , passport.authenticate('jwt', { session: false })
    , eventController.subscribeMembers);
router.post('/subscribeMembersWithMemberId'
    // ,passport.authenticate('jwt', { session: false })
    , eventController.subscribeMembersWithMemberId);
router.post('/subscribeSingleMember'
    // ,passport.authenticate('jwt', { session: false })
    , eventController.subscribeSingleMember);
router.post('/unsubscribeMembers'
    // ,passport.authenticate('jwt', { session: false })
    , eventController.unsubscribeMembers);

router.get('/get',
    // passport.authenticate('jwt', { session: false }),
    eventController.get);

router.get('/getEventById/:id',
    // passport.authenticate('jwt', { session: false }),
    eventController.getEventById);

router.get('/createEventBookIndexes/:id',
    // passport.authenticate('jwt', { session: false }),
    eventController.createEventBookIndexes);

router.get('/generateEventBookSorting/:id',
    // passport.authenticate('jwt', { session: false }),
    eventController.generateEventBookSorting);

router.post('/getEventsByIds',
    // passport.authenticate('jwt', { session: false }),
    eventController.getEventsByIds);

router.get('/getAll',
    // passport.authenticate('jwt', { session: false }),
    eventController.getAll);

router.get('/getUpcomingEvents',
    // passport.authenticate('jwt', { session: false }),
    eventController.getUpcomingEvents);

router.get('/getEndedEvents',
    passport.authenticate('jwt', { session: false }),
    eventController.getEndedEvents);

router.put('/update',
    // passport.authenticate('jwt', { session: false }),
    eventController.update);

router.delete('/delete/:_id',
    //  passport.authenticate('jwt', { session: false }),
    eventController.delete);

module.exports = router;