const FamilyValue = require('../models/family-value');
const express = require('express');
const router = express.Router();



//route to create FamilyValue
router.post('/create', (req, res) => {
	var familyValue = req.body;
	FamilyValue.addFamilyValue(familyValue, (err, familyValue) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, msg: 'Data created successfully',  data:familyValue});
        }
		
	});
});

//route to read FamilyValue
router.get('/getAll', (req, res) => {
	FamilyValue.getFamilyValue((err, familyValue) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:familyValue});
        }
		
	});
});

//route to find a familyValue by id
router.get('/get/:family_value_id',(req,res)=>{
	
	FamilyValue.getFamilyValueById(req.params.family_value_id,(err,familyValue)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(familyValue===null){
				res.status(200).json({success:true, msg:"no familyValue found by this id"});
				}else{
					res.status(200).json({success:true, familyValue:familyValue});
				}
            }
	});
});

//route to find a familyValue by title
router.get('/FamilyValueByTitle/:family_value_title',(req,res)=>{
	
	FamilyValue.getFamilyValueByTitle(req.params.family_value_title,(err,familyValue)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(familyValue===null){
			res.status(200).json({success:true, msg:"no familyValue found by such title"});
			}else{
				res.status(200).json({success:true, familyValue:familyValue});
			}
            	
            }
	});
});

			
		

//route to update FamilyValue
router.put('/update/:family_value_id', (req, res) => {
	var id = req.params.family_value_id;
	var familyValue = req.body;
	FamilyValue.updateFamilyValue(id, familyValue, {}, (err, familyValue) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data updated successfuly', data :familyValue});
        }
	});
});

//route to delete FamilyValue
router.delete('/delete/:family_value_id', (req, res) => {
	var id = req.params.family_value_id;
	FamilyValue.removeFamilyValue(id, (err, familyValue) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data deleted successfully', data:familyValue});
        }
	});
});



module.exports = router;


