// var express = require('express');
// var _router = express.Router();
// var multer = require('multer');
// var path = require('path');
// const Area = require('../models/area');
// const multipart = require('connect-multiparty');
// const multipartMiddleware = multipart({ uploadDir: './uploads' });

// _router.post('/import', multipartMiddleware, (req, res) => {
//     res.json({
//         success: true,
//         msg: 'File uploaded successfully',
//         data: (req.files.file.path.split('/'))[1]
//     });
// });

// var store = multer.diskStorage({
//     destination: function (req, file, cb) {
//         // cb(null, './../devmusical/assets');
//         // cb(null, './../devmusical/src/assets');
//         cb(null, './');
//         // cb(null, './../devmusical_universal/dist/browser/assets');
//         // cb(null, '/home/devmusical12/public_html/assets');
//     },
//     filename: function (req, file, cb) {
//         cb(null, Date.now() + '_' + file.originalname);
//     }
// });

// var upload = multer({ storage: store }).single('file');

// _router.post('/upload', function (req, res, next) {
//     // console.log(req.file);
//     upload(req, res, function (err) {
//         if (err) {
//             return res.status(501).json({ error: err });
//         }
//         //do all database record saving activity
//         return res.json({ msg: 'Uploaded Successfully', file: req.file });
//         // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
//     });
// });

// _router.get('/download/:filename', function (req, res, next) {
//     // console.log(path.join(__dirname, '/../uploads'));
//     // res.json({});
//     filepath = path.join(__dirname, '/../uploads') + '/' + req.params.filename;
//     res.sendFile(filepath);
// });

// _router.post('/uploadCsv', function (req, res, next) {
//     console.log('first');
//     upload(req, res, function (err) {
//         console.log("req:", req.headers);
//         if (err) {
//             return res.status(501).json({ error: err });
//         }
//         console.log(req.file.originalname, req.file.uploadname);
//         //do all database record saving activity-----
//         csv.fromPath(req.file.path, { headers: true })
//             .on("data", function (data) {
//                 //Removes spaces from property value in-case it does have
//                 for (var key in data) {
//                     data[key] = data[key].trim();
//                 }

//                 var area = new Area({
//                     country: data['country'],
//                     state: data['state'],
//                     district: data['district'],
//                     city: data['city'],
//                 });

//                 area.save().then(resp => {
//                     console.log('data saving resp: ' + resp);
//                 }).catch(err => {
//                     console.log('error in saving data to db' + err);
//                 })
//             })
//             .on("error", function (error) {
//                 console.log("There is an error in processing: " + error);
//             })
//             .on("end", function () {
//                 fs.unlinkSync(req.file.path);
//                 console.log("done");
//             });

//         // -------------------------------------------
//         return res.json({ originalname: req.file.originalname, uploadname: req.file.filename });
//     });
//     console.log('4th');
// });

// module.exports = _router;
var express = require("express");
var _router = express.Router();
var multer = require("multer");
var path = require("path");
var fs = require("fs");
const Area = require("../models/area");
const multipart = require("connect-multiparty");
const passport = require('passport')

const Models = require('./../apiv2/models/common');
const helper = require('./../Helpers/handler');
var xlsx = require("node-xlsx");

const multipartMiddleware = multipart({ uploadDir: "./uploads" });
const multipartMemberMiddleware = multipart({
  uploadDir: "./uploads/images/member/images"
});

_router.post("/import", multipartMiddleware, (req, res) => {
  res.json({
    success: true,
    msg: "File uploaded successfully",
    data: req.files.file.path.split("/")[1]
  });
});

var store = multer.diskStorage({
  destination: function (req, file, cb) {
    // cb(null, './../devmusical/assets');
    // cb(null, './../devmusical/src/assets');
    cb(null, "./uploads");
    // cb(null, './../devmusical_universal/dist/browser/assets');
    // cb(null, '/home/devmusical12/public_html/assets');
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + "_" + file.originalname);
  }
});

var upload = multer({ storage: store }).single("file");

var store2 = multer.diskStorage({
  destination: function (req, file, cb) {
    // cb(null, './../devmusical/assets');
    // cb(null, './../devmusical/src/assets');
    // cb(null, "./uploads/images/member/images");
    cb(null, "./uploads");
    // cb(null, './../devmusical_universal/dist/browser/assets');
    // cb(null, '/home/devmusical12/public_html/assets');
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + "_" + file.originalname);
  }
});

var upload2 = multer({ storage: store2 }).single("file");

var store3 = multer.diskStorage({
  destination: async function (req, file, cb) {
    const folder_name = file.originalname.split("_")[1];
    const faceCount = (file.originalname.split("_")[2]).split('.')[0];
    console.log(faceCount);
    if (faceCount == 1) {
      console.log('run python');
      // TODO: Run Python Program
      const { spawn } = require('child_process');
      const pyProg = spawn('python3', ['./testing.py']);

      pyProg.stdout.on('data', function (data) {

        console.log(data.toString());
      });
    }
    const isExist = fs.existsSync('./faces/' + folder_name);
    if (!isExist) {
      await fs.mkdir('./faces/' + folder_name, (err) => {
        console.log(err);
      });
    }
    cb(null, './faces/' + folder_name);
    // cb(null, './../devmusical/assets');
    // cb(null, './../devmusical/src/assets');
    // cb(null, "./uploads/images/member/images");
    // cb(null, './../devmusical_universal/dist/browser/assets');
    // cb(null, '/home/devmusical12/public_html/assets');
  },
  filename: function (req, file, cb) {
    cb(null, file.originalname);
  }
});

var upload3 = multer({ storage: store3 }).single("file");

var store4 = multer.diskStorage({
  destination: async function (req, file, cb) {
    const folder_name = file.originalname.split("_")[1];
    const isExist = fs.existsSync('./check');
    if (!isExist) {
      await fs.mkdir('./check', (err) => {
        console.log(err);
      });
    }
    cb(null, './check');
    // cb(null, './../devmusical/assets');
    // cb(null, './../devmusical/src/assets');
    // cb(null, "./uploads/images/member/images");
    // cb(null, './../devmusical_universal/dist/browser/assets');
    // cb(null, '/home/devmusical12/public_html/assets');
  },
  filename: function (req, file, cb) {
    cb(null, file.originalname);
  }
});

var upload4 = multer({ storage: store4 }).single("file");

_router.post("/toCheckFace", (req, res) => {
  setTimeout(() => {
    deleteOlderImages('./check/');
  }, 25000);
  upload4(req, res, function (err) {
    if (err) {
      return res.status(501).json({ error: err });
    }
    //do all database record saving activity
    res.json({
      success: true,
      msg: "File uploaded successfully",
      data: req.file.filename
      // data: (req.files.file.path.split('/'))[1]
    });
    // return res.json({ msg: "Uploaded Successfully", file: req.file });
    // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
  });
});

_router.post("/addFace", (req, res) => {
  upload3(req, res, function (err) {
    if (err) {
      return res.status(501).json({ error: err });
    }
    //do all database record saving activity
    res.json({
      success: true,
      msg: "File uploaded successfully",
      data: req.file.filename
      // data: (req.files.file.path.split('/'))[1]
    });
    // return res.json({ msg: "Uploaded Successfully", file: req.file });
    // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
  });
});

_router.post("/getFaces", async (req, res) => {
  const folder_name = req.body.username;
  const isExist = fs.existsSync('./faces/' + folder_name);
  if (!isExist) {
    await fs.mkdir('./faces/' + folder_name, (err) => {
      console.log(err);
    });
  }
  const files = fs.readdirSync('./faces/' + folder_name);
  return res.json({
    success: true,
    msg: "Data Fetched",
    data: files
  });
});

_router.get("/getFace/:filename", (req, res) => {
  // console.log(path.join(__dirname, '/../uploads'));
  // res.json({});
  filepath = path.join('./faces/' + folder_name + "/" + req.params.filename);
  defaultfilepath = path.join('./faces/' + folder_name + "/no-image.png");
  if (fs.existsSync(filepath)) {
    res.sendFile(filepath);
  } else {
    res.sendFile(defaultfilepath);
  }
});

_router.get("/getAttendance/:username", (req, res) => {
  // console.log(path.join(__dirname, '/../uploads'));
  // res.json({});
  filepath = path.join('./attendances/' + req.params.username + '.jpg.txt');
  if (fs.existsSync(filepath)) {
    fs.readFile('./attendances/' + req.params.username + '.jpg.txt', (err, data) => {
      if (err) {
        res.json({ success: false, msg: "attendance read error" });
      } else {
        let fdata = data.toString();
        console.log(fdata);
        fdata = fdata.split("\t")[1];
        fdata = fdata.split("\n");
        console.log(fdata);
        if (fdata.filter(o => o == req.params.username).length == 1) {

          fs.stat(filepath, function (err, stat) {
            if (err) return console.log(err);
            var livesUntil = new Date();
            livesUntil.setSeconds(livesUntil.getSeconds() - 20);
            if (stat.ctime < livesUntil) {
              res.json({ success: false, msg: "face expired" });
            } else {
              res.json({ success: true });
            }
          });
        } else {
          res.json({ success: false, msg: "someone else found" });
        }
      }
    })
  } else {
    res.json({ success: false, msg: "attendance not exist" });
  }
});

_router.post("/importSsMember", (req, res) => {
  upload2(req, res, function (err) {
    if (err) {
      return res.status(501).json({ error: err });
    }
    //do all database record saving activity
    res.json({
      success: true,
      msg: "File uploaded successfully",
      data: req.file.filename
      // data: (req.files.file.path.split('/'))[1]
    });
    // return res.json({ msg: "Uploaded Successfully", file: req.file });
    // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
  });
});

_router.post("/upload", function (req, res, next) {
  // console.log(req.file);
  upload(req, res, function (err) {
    if (err) {
      return res.status(501).json({ error: err });
    }
    //do all database record saving activity
    return res.json({ msg: "Uploaded Successfully", file: req.file });
    // return res.json({originalname:req.file.originalname, uploadname:req.file.filename});
  });
});

_router.get("/download/:filename", function (req, res, next) {
  // console.log(path.join(__dirname, '/../uploads'));
  // res.json({});
  filepath = path.join(__dirname, "/../uploads") + "/" + req.params.filename;
  defaultfilepath = path.join(__dirname, "/../public/uploads") + "/no-image.png";
  if (fs.existsSync(filepath)) {
    res.sendFile(filepath);
  } else {
    res.sendFile(defaultfilepath);
  }
});

_router.get("/downloadloc/:folder/:filename", (req, res) => {
  filepath = path.join(__dirname, "/../uploads") + "/" + req.params.folder + "/" + req.params.filename
  defaultfilepath = path.join(__dirname, "/../public/uploads") + "/dummy.txt";
  if (fs.existsSync(filepath)) {
      res.sendFile(filepath)
  } else {
      res.sendFile(defaultfilepath)
  }
});

_router.get("/downloadLog/:folder/:filename", function (req, res, next) {
  // console.log(path.join(__dirname, '/../uploads'));
  // res.json({});
  filepath = path.join(__dirname, "../attendanceLogs") + "/" + req.params.folder + "/" + req.params.filename;
  defaultfilepath = path.join(__dirname, "/../public/uploads") + "/no-image.png";
  if (fs.existsSync(filepath)) {
    res.sendFile(filepath);
  } else {
    res.sendFile(defaultfilepath);
  }
});

_router.get("/download/ssmember/:filename", function (req, res, next) {
  // console.log(path.join(__dirname, '/../uploads'));
  // res.json({});
  filepath =
    path.join(__dirname, "/../uploads/images/member/images") +
    "/" +
    req.params.filename;
  defaultfilepath = path.join(__dirname, "/../public/uploads") + "/no-image.png";
  if (fs.existsSync(filepath)) {
    res.sendFile(filepath);
  } else {
    res.sendFile(defaultfilepath);
  }
});

_router.post("/uploadCsv", function (req, res, next) {
  console.log("first");
  upload(req, res, function (err) {
    console.log("req:", req.headers);
    if (err) {
      return res.status(501).json({ error: err });
    }
    console.log(req.file.originalname, req.file.uploadname);
    //do all database record saving activity-----
    csv
      .fromPath(req.file.path, { headers: true })
      .on("data", function (data) {
        //Removes spaces from property value in-case it does have
        for (var key in data) {
          data[key] = data[key].trim();
        }

        var area = new Area({
          country: data["country"],
          state: data["state"],
          district: data["district"],
          city: data["city"]
        });

        area
          .save()
          .then(resp => {
            console.log("data saving resp: " + resp);
          })
          .catch(err => {
            console.log("error in saving data to db" + err);
          });
      })
      .on("error", function (error) {
        console.log("There is an error in processing: " + error);
      })
      .on("end", function () {
        fs.unlinkSync(req.file.path);
        console.log("done");
      });

    // -------------------------------------------
    return res.json({
      originalname: req.file.originalname,
      uploadname: req.file.filename
    });
  });
  console.log("4th");
});


var storeFileData = multer.diskStorage({
  destination: function (req, file, cb) {
    cb(null, "./data");
  },
  filename: function (req, file, cb) {
    cb(null, Date.now() + "_" + file.originalname);
  },
});

var uploadFileData = multer({ storage: storeFileData }).single("file");


_router.post("/uploadFileData", function (req, res, next) {
  uploadFileData(req, res, function (err) {
    if (err) {
      return res.status(501).json({ error: err });
    }
    //do all database record saving activity
    return res.json({ msg: "Uploaded Successfully", file: req.file });
  });
});

_router.get("/downloadFileData/:filename", function (req, res, next) {
  filepath = path.join(__dirname, "/../data") + "/" + req.params.filename;
  res.sendFile(filepath);
});

_router.get("/listFileData", function (req, res, next) {
  filepath = path.join(__dirname, "/../data") + "/";
  fs.readdir(filepath, (err, files) => {
    if (err) {
      return res.json({
        success: false,
        msg: err.message,
        data: err,
      });
    }
    return res.json({
      success: true,
      msg: "Listed Successfully",
      data: files,
    });
  });
});

_router.get("/deleteFileData/:filename", function (req, res, next) {
  filepath = path.join(__dirname, "/../data") + "/" + req.params.filename;
  fs.unlink(filepath, () => {
    res.json({
      success: true,
      msg: "Deleted Successfully",
      data: [],
    });
  });
});

_router.get(
  "/processFileData/:term/:filename/",
  passport.authenticate("jwt", { session: false }),
  (req, res, next) => {
    const SDfilename = req.params.filename;
    const term = req.params.term;
    const user = req.user;

    filepath = path.join(__dirname, "/../data") + "/" + req.params.filename;
    const sheets = xlsx.parse(filepath); // parses a file
    let fileData = [];
    let processedFileData = [];
    for (const sheet of sheets) {
      fileData = [...fileData, ...sheet.data];
    }
    // console.log(fileData);
    fileData.reverse();
    const headers = fileData.pop();
    fileData.reverse();
    const docs = [];
    for (let i = 0; i < fileData.length; i++) {
      const elem = fileData[i];
      let newDoc = {};
      for (let j = 0; j < headers.length; j++) {
        const key = headers[j];

        if (key == "options") {
          newDoc[key] = JSON.parse(elem[j]);
        } else {
          newDoc[key] = elem[j];
        }
      }
      docs.push(newDoc);
    }

    const Table = getModel(term)[0];

    if (!docs) {
      return helper.errHandler(res, { message: "Can't insert blank entry" });
    }
    if (!docs.length) {
      return helper.errHandler(res, { message: "Can't insert blank entry" });
    }

    if (Table) {
      if (term == "questionbank") {
        for (const doc of docs) {
          doc.created_at = Date.now();
          doc.created_by = req.user._id;
          if (!doc.institute_code) {
            doc.institute_code = req.user.institute_code;
          }

          let options = [];
          let options_hindi = [];

          for (let index = 1; index <= 4; index++) {
            options.push(doc['option' + index]);
            options_hindi.push(doc['option_hindi' + index]);
          }

          doc.options = options;
          doc.options_hindi = options_hindi;
        }
      } else {
        for (const doc of docs) {
          doc.created_at = Date.now();
          doc.created_by = req.user._id;
          if (!doc.institute_code) {
            doc.institute_code = req.user.institute_code;
          }
        }
      }

      Table.TableModel.insertMany(docs, (err, docs) => {
        if (err) {
          helper.errHandler(res, err);
        } else {
          res.json({
            success: true,
            msg: 'Data Inserted',
            data: {
              docsCount: docs.length
            }
          });
        }
      })
    } else {
      helper.errHandler(res, { message: 'Table Not Found' });
    }
  }
);

module.exports = _router;

function deleteOlderImages(dirPath) {
  fs.readdir(dirPath, function (err, files) {
    if (err) return console.log(err);
    files.forEach(function (file) {
      var filePath = dirPath + file;
      fs.stat(filePath, function (err, stat) {
        if (err) return console.log(err);
        var livesUntil = new Date();
        livesUntil.setSeconds(livesUntil.getSeconds() - 20);
        if (stat.ctime < livesUntil) {
          fs.unlink(filePath, function (err) {
            if (err) return console.log(err);
          });
        }
      });
    });
  });
}

// Handlers
function getModel(term) {
  const Model = Models.filter(o => o.TableName.toLowerCase() == term);
  return Model;
}
