const express = require('express');
const router = express.Router();
const config = require('../config/database');
const Lead = require('../models/lead');
const FollowupLog = require('../models/followuplog');
const FollowupType = require('../models/follow-up-type');
const Remainder = require('../models/remainder');
const passport = require('passport');
const User = require('../models/user');
const _ = require('lodash');
const csv = require("fast-csv");
const fs = require("fs");
const formidable = require('formidable');
const Area = require('../models/area');
const Helpers = require('../Helpers/Helpers');
const request = require('request');
const Mail = require('./../models/mail');
const Activity = require('./../models/activity');
const BookPlan = require("./../models/book-subscription-plan");
const NewMember = require("./../models/new_member");
const Transaction = require('../models/transaction');
const EventController = require('./../controllers/eventController');

router.post('/callUser', (req, res) => {
  const uid = req.body.uid;
  const mobile = req.body.mobile;
  const http = require('http');

  let data = '';
  console.log(data);

  http.get(`http://103.39.135.50:4575/CrmDial?exeUserName=${uid}@shadibyahwale.com&phoneNumber=${mobile}`, (resp) => {

    // A chunk of data has been recieved.
    resp.on('data', (chunk) => {
      data += chunk;
    });

    // The whole response has been received. Print out the result.
    resp.on('end', () => {
      console.log(data);
      res.json({ response: data, uid: uid, mobile: mobile });
      // console.log(JSON.parse(data).explanation);
    });

  }).on("error", (err) => {
    console.log("Error: " + err.message);
  });
});

router.post(
  '/update-new-lead',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body._id, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'error occured', err: err });
      } else {
        let isCityUpdated = false;
        if (lead) {

          if (lead.city !== req.body.city) {
            isCityUpdated = true;
          }

          lead.lastUpdate = {};
          lead.lastUpdate = JSON.parse(JSON.stringify(lead));
          lead.name = req.body.name;
          lead.email = req.body.email;
          lead.gender = req.body.gender;
          lead.mobile = req.body.mobile;
          lead.wanumber = req.body.wanumber;
          lead.city = req.body.city;
          lead.pcity = req.body.pcity;
          lead.source = req.body.source;
          lead.purpose = req.body.purpose;
          lead.package = req.body.package;
          lead.coupenSeries = req.body.coupenSeries;
          lead.coupenNumber = req.body.coupenNumber;
          lead.coupenDiscount = req.body.coupenDiscount;
          lead.followup = req.body.followup;
          lead.occupation = req.body.occupation;
          lead.rpay = req.body.rpay;
          lead.package = req.body.package;
          lead.allotedTo = req.body.allotedTo;
          lead.updatedBy = req.body.updatedBy;
          lead.mappedBy = req.body.mappedBy;
          lead.vip = req.body.vip;
          lead.remark = req.body.remark;
          lead.updatedAt = Date.now();
          lead.unit = req.body.unit;
          lead.rate = req.body.rate;
          lead.discount = req.body.discount;
          lead.quantity = req.body.quantity;
          lead.additionalCharges = req.body.additionalCharges;
          lead.grossCharges = req.body.grossCharges;
          lead.totalCharges = req.body.totalCharges;
          lead.billing = req.body.billing;
          lead.shipping = req.body.shipping;
          lead.leadCompanyName = req.body.leadCompanyName;
          lead.billingName = req.body.billingName;

          const query = ((req.body.city).split(','))[0];
          let fcities = [];
          // res.json({ success: true, cities: [{ city: 'Bhopal' }] });
          Area.getCountryByName(query, (err, cities) => {
            if (err) {
              res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
            } else {
              if (cities) {
                fcities.push(cities);
              }
              // console.log(uniqCities);
              Area.getStateByName(query, (err, cities) => {
                if (err) {
                  res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                } else {
                  if (cities) {
                    fcities.push(cities);
                  }
                  // console.log(uniqCities);
                  Area.getDistrictByName(query, (err, cities) => {
                    if (err) {
                      res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                    } else {
                      if (cities) {
                        fcities.push(cities);
                      }
                      // console.log(uniqCities);
                      Area.getCityByName(query, (err, cities) => {
                        if (err) {
                          res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                        } else {
                          if (cities) {
                            fcities.push(cities);
                          }
                          console.log(fcities);
                          if (isCityUpdated) {
                            if (fcities.length) {
                              Lead.addNewLead(lead, (err, lead) => {
                                if (err) {
                                  res.status(200).json({
                                    success: false,
                                    msg: 'Failed to edit lead',
                                    err: JSON.stringify(err)
                                  });
                                  return;
                                } else {

                                  const newActivity = new Activity({
                                    activityType: 'Lead Update',
                                    activityData: {
                                      lead: lead,
                                    },
                                    User: req.user,
                                    UserId: req.user._id,
                                    LeadId: req.body._id,
                                    msg: `${lead.mobile} info is updated by ${req.user.username}`,
                                  });
                                  Activity.addActivity(newActivity, (err, data) => {
                                    if (err) throw err;
                                  });
                                  res.status(200).json({
                                    success: true,
                                    msg: 'Lead edit successful.',
                                    lead: lead
                                  });
                                }
                              });
                            } else {
                              res.status(200).json({ success: false, msg: 'Please enter valid city' });
                            }
                          } else {
                            Lead.addNewLead(lead, (err, lead) => {
                              if (err) {
                                res.status(200).json({
                                  success: false,
                                  msg: 'Failed to edit lead',
                                  err: JSON.stringify(err)
                                });
                                return;
                              } else {

                                const newActivity = new Activity({
                                  activityType: 'Lead Update',
                                  activityData: {
                                    lead: lead,
                                  },
                                  User: req.user,
                                  UserId: req.user._id,
                                  LeadId: req.body._id,
                                  msg: `${lead.mobile} info is updated by ${req.user.username}`,
                                });
                                Activity.addActivity(newActivity, (err, data) => {
                                  if (err) throw err;
                                });
                                res.status(200).json({
                                  success: true,
                                  msg: 'Lead edit successful.',
                                  lead: lead
                                });
                              }
                            });
                          }
                        }
                      });
                    }
                  });
                }
              });
            }
          });
        } else {
          res.status(200).json({ success: false, msg: 'Lead not found' });
        }
      }
    });
  }
);

router.post(
  '/edit-new-lead',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body.username, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'error occured', err: err });
      } else {
        if (lead) {
          if (req.body.name)
            lead.name = req.body.name;
          if (req.body.DOB)
            lead.DOB = req.body.DOB;
          if (req.body.email)
            lead.email = req.body.email;
          if (req.body.mobile)
            lead.mobile = req.body.mobile;
          if (req.body.city)
            lead.city = req.body.city;
          if (req.body.state)
            lead.state = req.body.state;
          if (req.body.gender)
            lead.gender = req.body.gender;
          if (req.body.remark != lead.remark)
            lead.remark = req.body.remark;
          if (req.body.name)
            lead.updatedBy = req.body.updatedBy;
          lead.unit = req.body.unit;
          lead.rate = req.body.rate;
          lead.discount = req.body.discount;
          lead.quantity = req.body.quantity;
          lead.additionalCharges = req.body.additionalCharges;
          lead.grossCharges = req.body.grossCharges;
          lead.totalCharges = req.body.totalCharges;
          lead.billing = req.body.billing;
          lead.shipping = req.body.shipping;
          lead.leadCompanyName = req.body.leadCompanyName;
          lead.billingName = req.body.billingName;
          lead.updatedAt = Date.now();
          Lead.addNewLead(lead, (err, lead) => {
            if (err) {
              res.status(200).json({
                success: false,
                msg: 'Failed to edit lead',
                err: JSON.stringify(err)
              });
              return;
            } else {
              res.status(200).json({
                success: true,
                msg: 'Lead edit successful.',
                lead: lead
              });
            }
          });
        } else {
          res.status(200).json({ success: false, msg: 'Lead not found' });
        }
      }
    });
  }
);

router.post('/check-validLead', passport.authenticate('jwt', { session: false }), (req, res) => {
  let c = req.body.city;
  // console.log("City:" + c);
  // // console.log(c);

  Area.getCityByName(c, (err, area) => {
    if (err) {
      res.json({ success: false, msg: 'error in checking', err: JSON.stringify(err) });
    } else {
      if (area) {
        // console.log('--------');
        // console.log(area);
        res.json({ success: true, msg: 'ok, it is valid user' });
      } else {
        res.json({ success: false, msg: 'Not valid city' });
      }
    }
  });
});

router.post(
  '/upload-bulk-load',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let error = false;
    // let newUsers = [];
    // let invalidAreas = [];

    // for(let i=0;i<newUsers.length;i++){
    //   Area.getCityByName(newAreas[i].city, (err, area) => {
    //     if(err){
    //       res.json({ success: false, msg: 'Error in uploading areas', err: JSON.stringify(err) });
    //     } else {
    //       if(area){

    //       } else {

    //       }
    //     }
    //   });
    // }

    Lead.insertArrayofLeads(req.body.newUsers, (err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Error occured', err: err });
      } else {

        const newActivity = new Activity({
          activityType: 'Lead Bulk upload',
          activityData: {
            leadsCount: req.body.newUsers.length,
          },
          User: req.user,
          UserId: req.user._id,
          msg: `${req.body.newUsers.length} Leads Uploaded By ${req.user.username}`,
        });
        Activity.addActivity(newActivity, (err, data) => {
          if (err) throw err;
        });

        res
          .status(200)
          .json({ success: true, msg: 'upload successful', leads: leads });
      }
    });
  }
);

router.post(
  '/createNewLead',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newLead = new Lead({
      name: req.body.name,
      city: req.body.city,
      pcity: req.body.pcity,
      email: req.body.email,
      gender: req.body.gender,
      mobile: req.body.mobile,
      wanumber: req.body.wanumber,
      source: req.body.source,
      purpose: req.body.purpose,
      createdBy: req.body.user,
      coupenSeries: req.body.coupenSeries,
      coupenNumber: req.body.coupenNumber,
      coupenDiscount: req.body.coupenDiscount,
      remark: req.body.remark,
      createdAt: Date.now(),
      unit: req.body.unit,
      rate: req.body.rate,
      discount: req.body.discount,
      quantity: req.body.quantity,
      additionalCharges: req.body.additionalCharges,
      grossCharges: req.body.grossCharges,
      totalCharges: req.body.totalCharges,
      billing: req.body.billing,
      shipping: req.body.shipping,
      leadCompanyName: req.body.leadCompanyName,
      billingName: req.body.billingName,
    });

    // User.getCounsellors((err, counsellors) => {
    //   if (err) {
    //     res
    //       .status(200)
    //       .json({ success: false, msg: 'error occured', err: err });
    //   } else {
    //     for (let i = 0; i < counsellors.length; i++) {
    //       if (_.includes(counsellors[i].cities, newLead.city)) {
    //         counsellors[i].leads.push(newLead);
    //         newLead.counsellor = JSON.stringify(counsellors[i]);
    //         break;
    //       }
    //     }
    //   }
    // });

    let query = '';
    if (req.body.city) {
      query = ((req.body.city).split(','))[0];
    }
    let fcities = [];
    // res.json({ success: true, cities: [{ city: 'Bhopal' }] });
    Area.getCountryByName(query, (err, cities) => {
      if (err) {
        res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
      } else {
        if (cities) {
          fcities.push(cities);
        }
        // console.log(uniqCities);
        Area.getStateByName(query, (err, cities) => {
          if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
          } else {
            if (cities) {
              fcities.push(cities);
            }
            // console.log(uniqCities);
            Area.getDistrictByName(query, (err, cities) => {
              if (err) {
                res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
              } else {
                if (cities) {
                  fcities.push(cities);
                }
                // console.log(uniqCities);
                Area.getCityByName(query, (err, cities) => {
                  if (err) {
                    res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                  } else {
                    if (cities) {
                      fcities.push(cities);
                    }
                    console.log(fcities);
                    if (fcities.length) {
                      Lead.addNewLead(newLead, (err, newLead) => {
                        if (err) {
                          res.status(200).json({
                            success: false,
                            msg: 'Failed to create new lead',
                            err: JSON.stringify(err)
                          });
                        } else {

                          const newActivity = new Activity({
                            activityType: 'New Lead',
                            activityData: {
                              newLead: newLead,
                            },
                            User: req.user,
                            UserId: req.user._id,
                            LeadId: newLead._id,
                            msg: `New Lead Created By ${req.user.username}`,
                          });
                          Activity.addActivity(newActivity, (err, data) => {
                            if (err) throw err;
                          });

                          res
                            .status(201)
                            .json({ success: true, lead: newLead, msg: 'lead created' });
                        }
                      });
                    } else {
                      if (!query) {
                        Lead.addNewLead(newLead, (err, newLead) => {
                          if (err) {
                            res.status(200).json({
                              success: false,
                              msg: 'Failed to create new lead',
                              err: JSON.stringify(err)
                            });
                          } else {

                            const newActivity = new Activity({
                              activityType: 'New Lead',
                              activityData: {
                                newLead: newLead,
                              },
                              User: req.user,
                              UserId: req.user._id,
                              LeadId: newLead._id,
                              msg: `New Lead Created By ${req.user.username}`,
                            });
                            Activity.addActivity(newActivity, (err, data) => {
                              if (err) throw err;
                            });

                            res
                              .status(201)
                              .json({ success: true, lead: newLead, msg: 'lead created' });
                          }
                        });
                      } else {
                        res.status(200).json({ success: false, msg: 'Please enter valid city' });
                      }
                    }
                  }
                });
              }
            });
          }
        });
      }
    });
  }
);

router.post(
  '/createNewLeadSS',
  // passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newLead = new Lead({
      name: req.body.name,
      city: req.body.city,
      pcity: req.body.pcity,
      email: req.body.email,
      gender: req.body.gender,
      mobile: req.body.mobile,
      rpay: req.body.rpay,
      wanumber: req.body.wanumber,
      source: req.body.source,
      purpose: req.body.purpose,
      createdBy: req.body.createdBy,
      coupenSeries: req.body.coupenSeries,
      coupenNumber: req.body.coupenNumber,
      coupenDiscount: req.body.coupenDiscount,
      remark: req.body.remark,
      createdAt: Date.now(),
      unit: req.body.unit,
      rate: req.body.rate,
      discount: req.body.discount,
      quantity: req.body.quantity,
      additionalCharges: req.body.additionalCharges,
      grossCharges: req.body.grossCharges,
      totalCharges: req.body.totalCharges,
      billing: req.body.billing,
      shipping: req.body.shipping,
      leadCompanyName: req.body.leadCompanyName,
      billingName: req.body.billingName,
    });

    // User.getCounsellors((err, counsellors) => {
    //   if (err) {
    //     res
    //       .status(200)
    //       .json({ success: false, msg: 'error occured', err: err });
    //   } else {
    //     for (let i = 0; i < counsellors.length; i++) {
    //       if (_.includes(counsellors[i].cities, newLead.city)) {
    //         counsellors[i].leads.push(newLead);
    //         newLead.counsellor = JSON.stringify(counsellors[i]);
    //         break;
    //       }
    //     }
    //   }
    // });

    let query = '';
    if (req.body.city) {
      query = ((req.body.city).split(','))[0];
    }
    let fcities = [];
    // res.json({ success: true, cities: [{ city: 'Bhopal' }] });
    Area.getCountryByName(query, (err, cities) => {
      if (err) {
        res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
      } else {
        if (cities) {
          fcities.push(cities);
        }
        // console.log(uniqCities);
        Area.getStateByName(query, (err, cities) => {
          if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
          } else {
            if (cities) {
              fcities.push(cities);
            }
            // console.log(uniqCities);
            Area.getDistrictByName(query, (err, cities) => {
              if (err) {
                res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
              } else {
                if (cities) {
                  fcities.push(cities);
                }
                // console.log(uniqCities);
                Area.getCityByName(query, (err, cities) => {
                  if (err) {
                    res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                  } else {
                    if (cities) {
                      fcities.push(cities);
                    }
                    console.log(fcities);
                    if (fcities.length) {
                      Lead.addNewLead(newLead, (err, newLead) => {
                        if (err) {
                          res.status(200).json({
                            success: false,
                            msg: 'Failed to create new lead',
                            err: JSON.stringify(err)
                          });
                        } else {
                          res
                            .status(201)
                            .json({ success: true, lead: newLead, msg: 'lead created' });
                        }
                      });
                    } else {
                      if (!query) {
                        Lead.addNewLead(newLead, (err, newLead) => {
                          if (err) {
                            res.status(200).json({
                              success: false,
                              msg: 'Failed to create new lead',
                              err: JSON.stringify(err)
                            });
                          } else {
                            res
                              .status(201)
                              .json({ success: true, lead: newLead, msg: 'lead created' });
                          }
                        });
                      } else {
                        res.status(200).json({ success: false, msg: 'Please enter valid city' });
                      }
                    }
                  }
                });
              }
            });
          }
        });
      }
    });
  }
);

router.get(
  '/getAllLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeads((err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'All leads are fetched', leads: leads });
      }
    });
  }
);

router.get(
  '/getAllLeadsDuplicate',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getDuplicateLeadByMobile((err, doc) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        res.json({
          success: true,
          msg: 'All duplicate leads are fetched',
          duplicate: doc
        });
      }
    });
  });

router.get(
  '/getAllLeadsDuplicates',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeads((err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        const duplicate = getDuplicates(leads, leads);
        const notduplicate = [];
        for (const lead of leads) {
          console.log('nd: ' + lead._id);
          let found = false;
          for (const dup of duplicate) {
            if (dup._id === lead._id) {
              found = true;
            }
          }
          if (!found) {
            notduplicate.duplicate = false;
            notduplicate.push(lead);
          }
        }
        res
          .status(200)
          .json({
            success: true,
            msg: 'All duplicate leads are fetched',
            leads: leads,
            duplicate: duplicate,
            notduplicate: notduplicate
          });
      }
    });
  }
);

//Check Duplicate function
function getDuplicates(leadstosearch, fromleads) {
  const duplicate = [];
  const notduplicate = [];
  for (const slead of fromleads) {
    console.log('dc: ' + slead._id);
    let count = 0;
    for (const plead of leadstosearch) {
      if (slead.mobile === plead.mobile) {
        count++;
      }
    }
    if (count >= 2) {
      let found = false;
      for (const dup of duplicate) {
        if (dup._id === slead._id) {
          found = true;
        }
      }
      if (!found) {
        duplicate.duplicate = true;
        duplicate.push(slead);
      }
    }
  }
  return duplicate;
}

router.get(
  '/getAllotedLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getAllotedLeads((err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'All leads are fetched', leads: leads });
      }
    });
  }
);

router.get(
  '/getUnallotedLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    console.log(req.user.username);
    Lead.getUnallotedLeads(
      [{ allotedTo: "none" }],
      (err, leads) => {
        if (err) {
          res
            .status(200)
            .json({ success: false, msg: 'Failed to fetch all leads', err: err });
        } else {
          res
            .status(200)
            .json({ success: true, msg: 'All leads are fetched', leads: leads });
        }
      });
  }
);



router.get(
  "/getUnallotedLeads/:limit/:page",
  passport.authenticate("jwt", { session: false }),
  (req, res) => {
    const limit = parseInt(req.params.limit);
    const page = parseInt(req.params.page);
    const skip = page * limit - limit;
    Lead.getLimitedUnallotedLeads(
      [{ allotedTo: "none" }],
      limit,
      skip,
      (err, leads) => {
        // leads = leads.filter((o) => o.createdBy == req.user.username);
        if (err) {
          res.status(200).json({
            success: false,
            msg: "Failed to fetch all leads",
            err: err,
          });
        } else {
          res.status(200).json({
            success: true,
            msg: "All leads are fetched",
            leads: leads,
          });
        }
      }
    );
  }
);

router.get(
  '/getAllLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getAllLeadsCount((err, leadCount) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to count unalloted leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'Unalloted leads are counted', leadCount: leadCount });
      }
    });
  }
);

router.get(
  '/getAllotedLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getAllotedLeadsCount((err, leadCount) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to count unalloted leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'Unalloted leads are counted', leadCount: leadCount });
      }
    });
  }
);

router.get(
  '/getUnallotedLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getUnallotedLeadsCount(
      [{ allotedTo: "none" }]
      , (err, leadCount) => {
        if (err) {
          res
            .status(200)
            .json({ success: false, msg: 'Failed to count unalloted leads', err: err });
        } else {
          res
            .status(200)
            .json({ success: true, msg: 'Unalloted leads are counted', leadCount: leadCount });
        }
      });
  }
);

router.post(
  '/getLeadById',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body.userId, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch lead', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'lead fetched', lead: lead });
      }
    });
  }
);

router.post(
  '/check-mobile',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    // console.log(req.body.mobile);
    Lead.getLeadByMobile(req.body.mobile, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch lead', err: err });
      } else {
        if (lead) {
          res
            .status(200)
            .json({ success: true, duplicate: true, msg: 'lead fetched', lead: lead });
        } else {
          res
            .status(200)
            .json({ success: true, duplicate: false, msg: 'lead fetched', lead: lead });
        }
      }
    });
  }
);

router.post(
  '/check-mobiles',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    // console.log(req.body.mobile);
    Lead.getLeadByMobiles(req.body.mobile, (err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch lead', err: err });
      } else {
        if (leads) {
          res
            .status(200)
            .json({ success: true, duplicate: true, msg: 'lead fetched', leads: leads });
        } else {
          res
            .status(200)
            .json({ success: false, duplicate: false, msg: 'No lead found with this number', leads: leads });
        }
      }
    });
  }
);

router.post(
  '/checkLeadMobileDuplicate',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadByMobile(req.body.mobile, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch lead', err: err });
      } else {
        if (lead) {
          res
            .status(200)
            .json({ success: true, duplicate: true, lead: lead });
        } else {
          res
            .status(200)
            .json({ success: true, duplicate: false, lead: lead });
        }
      }
    });
  }
);

router.post(
  '/addFollowUp',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let followup = req.body.followupdata;
    let _id = req.body.userId;
    // // // console.log(followup);
    // // // console.log(req.body);
    // // // console.log(_id);
    Lead.getLeadById(_id, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to add Followup', err: err });
      } else {
        if (lead.followup) {
          lead.followup.push(followup);
        } else {
          lead.followup = [];
          lead.followup.push(followup);
        }
        // // // console.log(lead);
        lead.followupAt = Date.now();
        lead.updatedAt = Date.now();
        Lead.addNewLead(lead, (err, updatedlead) => {
          if (err) {
            res.status(200).json({
              success: false,
              msg: 'Failed to add followup',
              err: err
            });
          } else {
            // console.log("Updated LEAD___________");
            // console.log(updatedlead);
            // // // console.log(updatedlead);
            let NewLog = new FollowupLog({
              followupof: req.body.followupof,
              followupby: req.body.followupby,
              followuptype: req.body.followuptype,
              remark: req.body.remark
            });
            // // // console.log(NewLog);
            // Followuplog
            FollowupLog.addLog(NewLog, (err, log) => {
              if (err) {
                res.status(200).json({
                  success: false,
                  msg: 'Failed to add newlog',
                  err: err
                });
              } else {
                // console.log("LOGLOGLOGLOGLOG")
                // console.log(log);
                // add remainder
                if (req.body.followupdata.dueDate != 'undefined') {
                  let newRemainder = new Remainder({
                    alarmDate: req.body.followupdata.dueDate,
                    alarmForLead: req.body.followupof,
                    alarmSetBy: req.body.followupby
                  });
                  Remainder.updateMany({ "alarmForLead._id": req.body.followupof._id }, { $set: { read: true } }, (err, updates) => {
                    Remainder.addRemainder(newRemainder, (err, remainder) => {
                      if (err) {
                        res.status(200).json({
                          success: false,
                          msg: 'error occured',
                          err: err
                        });
                      } else {
                        // // // console.log(remainder);
                        const newActivity = new Activity({
                          activityType: 'Followup',
                          activityData: {
                            lead: lead,
                            log: NewLog,
                            remainder: newRemainder
                          },
                          User: req.user,
                          UserId: req.user._id,
                          LeadId: _id,
                          msg: `Follow Up of ${lead.mobile} by ${req.user.username}`,
                        });
                        Activity.addActivity(newActivity, (err, data) => {
                          if (err) throw err;
                        });
                        res.status(200).json({
                          success: true,
                          msg: 'Followup added successfully',
                          lead: updatedlead
                        });
                      }
                    });
                  });
                  // console.log(newRemainder);
                }
              }
            });


          }
        });
      }
    });
  }
);

router.post(
  '/sendAddress',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body.userId, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'failed to found lead', err: err });
      } else {
        if (lead) {
          lead.sendAddress.push(req.body.sendAddress);
          Lead.addNewLead(lead, (err, lead) => {
            if (err) {
              res.status(200).json({
                success: false,
                msg: 'failed to add address in array',
                err: err
              });
            } else {

              // const otp = req.body.otp;
              const mobile = req.body.mobile;
              const msg = 'ThankYou for contacting shadibyahwale, Our Address : ' + req.body.sendAddress;

              var url = `http://sms.hspsms.com/sendSMS?username=Worldclass&message={ MESSAGE }&sendername=SDISMN&smstype=TRANS&numbers={ NUMBER }&apikey=712b3dcd-d552-4bec-a2f9-ae31807fbd6e`

              var arr = url.split("{ NUMBER }");
              var arr2 = arr[1].split("{ MESSAGE }")[0] + `${msg}`;
              arr = arr[0] + `${mobile}`;
              const newUrl = arr + arr2;
              request(newUrl, function (error, response, body) {
                // console.log(response);
                console.log(error);
                if (error) {
                  return res.json({ success: false, data: "error occured" });
                } else {

                  const newActivity = new Activity({
                    activityType: 'Address Sent Via SMS',
                    activityData: {
                      Address: req.body.sendAddress,
                      mobile: mobile,
                      msg: msg,
                      url: newUrl,
                    },
                    User: req.user,
                    UserId: req.user._id,
                    LeadId: req.body.userId,
                    msg: `Office Address Sent To ${mobile} By ${req.user.username}`,
                  });
                  Activity.addActivity(newActivity, (err, data) => {
                    if (err) throw err;
                  });

                  return res.json({ success: true, data: response });
                }
              });
            }
          });
        } else {
          res
            .status(200)
            .json({ success: false, msg: 'failed to found lead', err: err });
        }
      }
    });
  }
);

router.post(
  '/mailAddress',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body.userId, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'failed to found lead', err: err });
      } else {
        if (lead) {
          lead.sendAddress.push(req.body.sendAddress);
          Lead.addNewLead(lead, (err, lead) => {
            if (err) {
              res.status(200).json({
                success: false,
                msg: 'failed to add mail in array',
                err: err
              });
            } else {

              // const otp = req.body.otp;
              // const mobile = req.body.mobile;
              // const msg = 'ThankYou for contacting shadibyahwale, Our Address : ' + req.body.sendAddress;

              // var url = `http://sms.hspsms.com/sendSMS?username=Worldclass&message={ MESSAGE }&sendername=SDISMN&smstype=TRANS&numbers={ NUMBER }&apikey=712b3dcd-d552-4bec-a2f9-ae31807fbd6e`

              // var arr = url.split("{ NUMBER }");
              // var arr2 = arr[1].split("{ MESSAGE }")[0] + `${msg}`;
              // arr = arr[0] + `${mobile}`;
              // const newUrl = arr + arr2;
              // request(newUrl, function (error, response, body) {
              //   // console.log(response);
              //   console.log(error);
              //   if (error) {
              //     return res.json({ success: false, data: "error occured" });
              //   } else {
              //     return res.json({ success: true, data: response });
              //   }
              // });
              Mail.sendMail(lead.email, req.body.msg, (err, info) => {
                if (err) {
                  res.json({ success: false, msg: `Can't send mail`, err: err })
                } else {

                  const newActivity = new Activity({
                    activityType: 'Address Sent Via Mail',
                    activityData: {
                      Address: req.body.sendAddress,
                      email: lead.email,
                      msg: req.body.msg
                    },
                    User: req.user,
                    UserId: req.user._id,
                    LeadId: req.body.userId,
                    msg: `Office Address Sent To ${email} By ${req.user.username}`,
                  });
                  Activity.addActivity(newActivity, (err, data) => {
                    if (err) throw err;
                  });

                  res.json({ success: true, msg: `mail sent` })
                }
              })
            }
          });
        } else {
          res
            .status(200)
            .json({ success: false, msg: 'failed to found lead', err: err });
        }
      }
    });
  }
);

router.post(
  '/sendMsg',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadById(req.body.userId, (err, lead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'failed to found lead', err: err });
      } else {
        if (lead) {
          lead.messages.push(req.body.msg);
          Lead.addNewLead(lead, (err, lead) => {
            if (err) {
              res.status(200).json({
                success: false,
                msg: 'failed to add address in array',
                err: err
              });
            } else {

              // const otp = req.body.otp;
              const mobile = req.body.mobile;
              const msg = req.body.msg;

              var url = `http://sms.hspsms.com/sendSMS?username=Worldclass&message={ MESSAGE }&sendername=SDISMN&smstype=TRANS&numbers={ NUMBER }&apikey=712b3dcd-d552-4bec-a2f9-ae31807fbd6e`

              var arr = url.split("{ NUMBER }");
              var arr2 = arr[1].split("{ MESSAGE }")[0] + `${msg}`;
              arr = arr[0] + `${mobile}`;
              const newUrl = arr + arr2;
              request(newUrl, function (error, response, body) {
                // console.log(response);
                console.log(error);
                if (error) {
                  return res.json({ success: false, data: "error occured" });
                } else {

                  const newActivity = new Activity({
                    activityType: 'Address Sent Via SMS',
                    activityData: {
                      mobile: mobile,
                      msg: req.body.msg,
                      url: newUrl,
                    },
                    User: req.user,
                    UserId: req.user._id,
                    LeadId: req.body.userId,
                    msg: `SMS Sent To ${mobile} By ${req.user.username}`,
                  });
                  Activity.addActivity(newActivity, (err, data) => {
                    if (err) throw err;
                  });

                  return res.json({ success: true, data: response });
                }
              });
            }
          });
        } else {
          res
            .status(200)
            .json({ success: false, msg: 'failed to found lead', err: err });
        }
      }
    });
  }
);

// getting members
router.get(
  '/getMembers',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    membersList = [];
    Lead.getLeads((err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'error occured', err: err });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID'
            ) {
              membersList.push(leads[i]);
            }
          }
        }
        // // console.log(membersList);
        res.status(200).json({
          success: true,
          msg: 'Member Lists are fetched',
          members: membersList
        });
      }
    });
  }
);

// getting leads by category
router.get(
  '/getNewLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeads((err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {

        let oldLeadsArray = [];
        for (let i = 0; i < newleads.length; i++) {
          if (newleads[i].followup) {
            if (newleads[i].followup.length) {
              if (
                newleads[i].followup[newleads[i].followup.length - 1].status ==
                'MAP'
              ) {
                oldLeadsArray.push(newleads[i]);
              }
            } else {
              oldLeadsArray.push(newleads[i]);
            }
          } else {
            oldLeadsArray.push(newleads[i]);
          }
        }

        res.status(200).json({
          success: true,
          msg: 'new leads fetched',
          newleads: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getAllLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'All leads are fetched', leads: leads });
      }
    });
  }
);

router.post(
  '/getAllLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'All leads are fetched', leads: leads });
      }
    });
  }
);

router.get(
  '/getNewLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeadsByUser(req.params.username, (err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {

        let oldLeadsArray = [];
        for (let i = 0; i < newleads.length; i++) {
          if (newleads[i].followup) {
            if (newleads[i].followup.length) {
              if (
                newleads[i].followup[newleads[i].followup.length - 1].status ==
                'MAP'
              ) {
                oldLeadsArray.push(newleads[i]);
              }
            } else {
              oldLeadsArray.push(newleads[i]);
            }
          } else {
            oldLeadsArray.push(newleads[i]);
          }
        }
        res.status(200).json({
          success: true,
          msg: 'new leads fetched',
          newleads: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getNewLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeadsByUserByUsernames(req.body.usernames, (err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {

        let oldLeadsArray = [];
        for (let i = 0; i < newleads.length; i++) {
          if (newleads[i].followup) {
            if (newleads[i].followup.length) {
              if (
                newleads[i].followup[newleads[i].followup.length - 1].status ==
                'MAP'
              ) {
                oldLeadsArray.push(newleads[i]);
              }
            } else {
              oldLeadsArray.push(newleads[i]);
            }
          } else {
            oldLeadsArray.push(newleads[i]);
          }
        }
        res.status(200).json({
          success: true,
          msg: 'new leads fetched',
          newleads: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getNPC',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNpcLeadsByUser((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch NPC leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'NPC'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'NPC leads fetched',
          NPC: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getNPC/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUser(req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch NPC leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'NPC'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'NPC leads fetched',
          NPC: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getNPCByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNpcLeadsByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch NPC leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'NPC'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'NPC leads fetched',
          NPC: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getInterested',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getInterestedLeadsByUser((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Interested leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Interested leads fetched',
          interested: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getInterested/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUser(req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Interested leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Interested leads fetched',
          interested: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getInterestedByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getInterestedLeadsByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Interested leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Interested leads fetched',
          interested: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getProspects',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getProspectLeadsByUser((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Prospect leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Prospect leads fetched',
          prospects: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getProspects/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUser(req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Prospect leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Prospect leads fetched',
          prospects: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getProspectsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getProspectLeadsByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Prospect leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Prospect leads fetched',
          prospects: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getVip',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getVipByUser((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch VIP leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].vip) {
            oldLeadsArray.push(oldleads[i]);
          }
        }

        res.status(200).json({
          success: true,
          msg: 'VIP leads fetched',
          vips: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getVipByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getVipByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch VIP leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].vip) {
            oldLeadsArray.push(oldleads[i]);
          }
        }

        res.status(200).json({
          success: true,
          msg: 'VIP leads fetched',
          vips: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getPoa',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getVipByUser((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch PO APPROVAL leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].poapproval) {
            oldLeadsArray.push(oldleads[i]);
          }
        }

        res.status(200).json({
          success: true,
          msg: 'PO Approval leads fetched',
          data: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getPoaByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getPoaByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch PO Approval leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].poapproval) {
            oldLeadsArray.push(oldleads[i]);
          }
        }

        res.status(200).json({
          success: true,
          msg: 'PO Approval leads fetched',
          data: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getOldLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeads((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'old leads fetched',
          oldleads: oldLeadsArray
        });
      }
    });
  }
);
router.get(
  '/getOldLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUser(req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'old leads fetched',
          oldleads: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getOldLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'old leads fetched',
          oldleads: oldLeadsArray
        });
      }
    });
  }
);

router.get(
  '/getCallbackLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    callbackLeads = [];
    // console.log('callback');
    Lead.getCallbackLeadsByUser((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads are fetched',
          leads: callbackLeads
        });
      }
    });
  }
);

router.get(
  '/getCallbackLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    callbackLeads = [];
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads are fetched',
          leads: callbackLeads
        });
      }
    });
  }
);

router.post(
  '/getCallbackLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    callbackLeads = [];
    Lead.getCallbackLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads are fetched',
          leads: callbackLeads
        });
      }
    });
  }
);

router.get(
  '/getApprovedLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    approvedLeads = [];
    Lead.getApprovedLeadsByUser((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads are fetched',
          leads: approvedLeads
        });
      }
    });
  }
);

router.get(
  '/getApprovedLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    approvedLeads = [];
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads are fetched',
          leads: approvedLeads
        });
      }
    });
  }
);

router.post(
  '/getApprovedLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    approvedLeads = [];
    Lead.getApprovedLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads are fetched',
          leads: approvedLeads
        });
      }
    });
  }
);

router.get(
  '/getClosedLeads',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    closedLeads = [];
    Lead.getClosedLeadsByUser((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch closed leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
            ) {
              closedLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'closed leads are fetched',
          leads: closedLeads
        });
      }
    });
  }
);

router.get(
  '/getClosedLeads/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    closedLeads = [];
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch closed leads',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
            ) {
              closedLeads.push(leads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'closed leads are fetched',
          leads: closedLeads
        });
      }
    });
  }
);

router.post(
  '/getClosedLeadsByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    closedLeads = [];
    Lead.getClosedLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch closed leads',
          err: err
        });
      } else {
        // for (let i = 0; i < leads.length; i++) {
        //   if (leads[i].followup[leads[i].followup.length - 1]) {
        //     if (
        //       leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
        //     ) {
        //       closedLeads.push(leads[i]);
        //     }
        //   }
        // }
        res.status(200).json({
          success: true,
          msg: 'closed leads are fetched',
          leads: leads
        });
      }
    });
  }
);

// end getting leads

// counting routes
router.get(
  '/getLeadsStatusCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newleadcount = 0;
    let oldleadcount = 0;
    let callbackcount = 0;
    let closedcount = 0;
    let npccount = 0;
    let approvedcount = 0;
    let interstedcount = 0;
    let prospectcount = 0;
    let vipcount = 0;
    let paidLeadsCount = 0;
    let verifyLeadsCount = 0;
    let dispatchLeadsCount = 0;
    let billingLeadsCount = 0;
    let outstandingLeadsCount = 0;
    let returnLeadsCount = 0;
    let staticPoApprovalcount = 0;
    let staticServeDispatchcount = 0;
    let staticBillingcount = 0;
    let staticOutstandingcount = 0;
    let staticPaymentRecdcount = 0;
    let staticPoCancellationcount = 0;
    let staticReturncount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch leads count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].vip) {
            vipcount++;
          }
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'MAP'
            ) {
              newleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              npccount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              interstedcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              prospectcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CLOSED'
            ) {
              closedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedcount++;
              staticPaymentRecdcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PURCHASE ORDER'
            ) {
              staticPoApprovalcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              staticServeDispatchcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              staticBillingcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status == leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              staticOutstandingcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PO CANCELLATION'
            ) {
              staticPoCancellationcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'RETURN INWARD'
            ) {
              staticReturncount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVAL / VERIFY'
            ) {
              verifyLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVE / DISPATCH'
            ) {
              dispatchLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING'
            ) {
              billingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'OUTSTANDING'
            ) {
              outstandingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'RETURN INWARD'
            ) {
              returnLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PUR-PO'
            ) {
              paidLeadsCount++;
            }
          } else {
            newleadcount++;
          }
        }
        res.status(200).json({
          success: true,
          msg: 'leads counts fetched ',
          callbackcount: callbackcount,
          interstedcount: interstedcount,
          npccount: npccount,
          prospectcount: prospectcount,
          closedcount: closedcount,
          approvedcount: approvedcount,
          oldleadcount: oldleadcount,
          newleadcount: newleadcount,
          vipleadcount: vipcount,
          paidLeadsCount: paidLeadsCount,
          verifyLeadsCount: verifyLeadsCount,
          dispatchLeadsCount: dispatchLeadsCount,
          billingLeadsCount: billingLeadsCount,
          outstandingLeadsCount: outstandingLeadsCount,
          returnLeadsCount: returnLeadsCount,
          staticPoApprovalcount: staticPoApprovalcount,
          staticServeDispatchcount: staticServeDispatchcount,
          staticBillingcount: staticBillingcount,
          staticOutstandingcount: staticOutstandingcount,
          staticPaymentRecdcount: staticPaymentRecdcount,
          staticPoCancellationcount: staticPoCancellationcount,
          staticReturncount: staticReturncount,
        });
      }
    });
  }
);

router.post(
  '/getLeadsStatusCount/',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newleadcount = 0;
    let oldleadcount = 0;
    let callbackcount = 0;
    let closedcount = 0;
    let npccount = 0;
    let approvedcount = 0;
    let interstedcount = 0;
    let prospectcount = 0;
    let vipcount = 0;
    let paidLeadsCount = 0;
    let verifyLeadsCount = 0;
    let dispatchLeadsCount = 0;
    let billingLeadsCount = 0;
    let outstandingLeadsCount = 0;
    let returnLeadsCount = 0;
    Lead.getLeadsByUser(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch leads count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].vip) {
            vipcount++;
          }
          if (leads[i].followup[leads[i].followup.length - 1]) {
            // oldleadcount++;
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'MAP'
            ) {
              newleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              npccount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              interstedcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              prospectcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CLOSED'
            ) {
              closedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVAL / VERIFY'
            ) {
              verifyLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVE / DISPATCH'
            ) {
              dispatchLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING'
            ) {
              billingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'OUTSTANDING'
            ) {
              outstandingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'RETURN INWARD'
            ) {
              returnLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PUR-PO'
            ) {
              paidLeadsCount++;
            }
          } else {
            newleadcount++;
          }
        }
        res.status(200).json({
          success: true,
          msg: 'leads counts fetched ',
          callbackcount: callbackcount,
          interstedcount: interstedcount,
          npccount: npccount,
          prospectcount: prospectcount,
          closedcount: closedcount,
          approvedcount: approvedcount,
          oldleadcount: oldleadcount,
          newleadcount: newleadcount,
          vipleadcount: vipcount,
          paidLeadsCount: paidLeadsCount,
          verifyLeadsCount: verifyLeadsCount,
          dispatchLeadsCount: dispatchLeadsCount,
          billingLeadsCount: billingLeadsCount,
          outstandingLeadsCount: outstandingLeadsCount,
          returnLeadsCount: returnLeadsCount,
        });
      }
    });
  }
);
router.get(
  '/getLeadsStatusCountByLabels',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newleadcount = 0;
    let vipcount = 0;
    let staticPoApprovalcount = 0;
    let staticServeDispatchcount = 0;
    let staticBillingcount = 0;
    let staticOutstandingcount = 0;
    let staticPaymentRecdcount = 0;
    let staticPoCancellationcount = 0;
    let staticReturncount = 0;
    FollowupType.find((err, docs) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch leads count',
          err: err
        });
      } else {

        for (const doc of docs) {
          doc.count = 0;
        }
        Lead.getLeads((err, leads) => {
          if (err) {
            res.status(200).json({
              success: false,
              msg: 'Failed to fetch leads count',
              err: err
            });
          } else {
            for (let i = 0; i < leads.length; i++) {
              if (leads[i].vip) {
                vipcount++;
              }
              if (leads[i].followup[leads[i].followup.length - 1]) {
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'MAP'
                ) {
                  newleadcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAYMENT RECD' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'OUTSTANDING'
                ) {
                  staticPaymentRecdcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PURCHASE ORDER'
                ) {
                  staticPoApprovalcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING'
                ) {
                  staticServeDispatchcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING'
                ) {
                  staticBillingcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status == leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING'
                ) {
                  staticOutstandingcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO CANCELLATION'
                ) {
                  staticPoCancellationcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'RETURN INWARD'
                ) {
                  staticReturncount++;
                }
                for (const doc of docs) {
                  let OldStatuses = doc.oldNames ? doc.oldNames.split(',') : [];
                  let Statuses = [doc.followUpType, ...OldStatuses];
                  let found = false;
                  for (const status of Statuses) {
                    if (
                      leads[i].followup[leads[i].followup.length - 1].status ==
                      status
                    ) {
                      found = true;
                    }
                  }
                  if (found) {
                    doc.count++;
                  }
                }
              } else {
                newleadcount++;
              }
            }
            // console.log(docs);
            res.status(200).json({
              success: true,
              msg: 'leads counts fetched ',
              newleadcount: newleadcount,
              vipleadcount: vipcount,
              staticPoApprovalcount: staticPoApprovalcount,
              staticServeDispatchcount: staticServeDispatchcount,
              staticBillingcount: staticBillingcount,
              staticOutstandingcount: staticOutstandingcount,
              staticPaymentRecdcount: staticPaymentRecdcount,
              staticPoCancellationcount: staticPoCancellationcount,
              staticReturncount: staticReturncount,
              followups: docs
            });
          }
        });
      }
    });
  }
);

router.post(
  '/getLeadsStatusCountByLabels/',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newleadcount = 0;
    let vipcount = 0;
    let staticPoApprovalcount = 0;
    let staticServeDispatchcount = 0;
    let staticBillingcount = 0;
    let staticOutstandingcount = 0;
    let staticPaymentRecdcount = 0;
    let staticPoCancellationcount = 0;
    let staticReturncount = 0;
    FollowupType.find((err, docs) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch leads count',
          err: err
        });
      } else {

        for (const doc of docs) {
          doc.count = 0;
        }
        Lead.getLeadsByUser(req.body.usernames, (err, leads) => {
          if (err) {
            res.status(200).json({
              success: false,
              msg: 'Failed to fetch leads count',
              err: err
            });
          } else {
            for (let i = 0; i < leads.length; i++) {
              if (leads[i].vip) {
                vipcount++;
              }
              if (leads[i].followup[leads[i].followup.length - 1]) {
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'MAP'
                ) {
                  newleadcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAYMENT RECD'
                ) {
                  staticPaymentRecdcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PURCHASE ORDER'
                ) {
                  staticPoApprovalcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAYMENT RECD'
                ) {
                  staticServeDispatchcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAYMENT RECD'
                ) {
                  staticBillingcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status == leads[i].followup[leads[i].followup.length - 1].status ==
                  'SERVICE' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'BILLING' || leads[i].followup[leads[i].followup.length - 1].status ==
                  'PAYMENT RECD'
                ) {
                  staticOutstandingcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'PO CANCELLATION'
                ) {
                  staticPoCancellationcount++;
                }
                if (
                  leads[i].followup[leads[i].followup.length - 1].status ==
                  'RETURN INWARD'
                ) {
                  staticReturncount++;
                }
                for (const doc of docs) {
                  let OldStatuses = doc.oldNames ? doc.oldNames.split(',') : [];
                  let Statuses = [doc.followUpType, ...OldStatuses];
                  let found = false;
                  for (const status of Statuses) {
                    if (
                      leads[i].followup[leads[i].followup.length - 1].status ==
                      status
                    ) {
                      found = true;
                    }
                  }
                  if (found) {
                    doc.count++;
                  }
                }
              } else {
                newleadcount++;
              }
            }
            // console.log(docs);
            res.status(200).json({
              success: true,
              msg: 'leads counts fetched ',
              newleadcount: newleadcount,
              vipleadcount: vipcount,
              staticPoApprovalcount: staticPoApprovalcount,
              staticServeDispatchcount: staticServeDispatchcount,
              staticBillingcount: staticBillingcount,
              staticOutstandingcount: staticOutstandingcount,
              staticPaymentRecdcount: staticPaymentRecdcount,
              staticPoCancellationcount: staticPoCancellationcount,
              staticReturncount: staticReturncount,
              followups: docs
            });
          }
        });
      }
    });
  });

router.post(
  '/getLeadsStatusCountByDate/',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newleadcount = 0;
    let oldleadcount = 0;
    let callbackcount = 0;
    let closedcount = 0;
    let npccount = 0;
    let approvedcount = 0;
    let interstedcount = 0;
    let prospectcount = 0;
    let vipcount = 0;
    let paidLeadsCount = 0;
    let verifyLeadsCount = 0;
    let dispatchLeadsCount = 0;
    let billingLeadsCount = 0;
    let outstandingLeadsCount = 0;
    let returnLeadsCount = 0;

    const data = {
      fromDate: req.body.fromDate,
      toDate: req.body.toDate,
      users: req.body.usernames
    };

    Lead.getLeadsReport(data, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch leads count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].vip) {
            vipcount++;
          }
          if (leads[i].followup[leads[i].followup.length - 1]) {
            oldleadcount++;
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'MAP'
            ) {
              newleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              npccount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              interstedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT / QUOTE'
            ) {
              prospectcount++;
              oldleadcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CLOSED'
            ) {
              closedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAYMENT RECD'
            ) {
              approvedcount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVAL / VERIFY'
            ) {
              verifyLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'SERVE / DISPATCH'
            ) {
              dispatchLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'BILLING'
            ) {
              billingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'OUTSTANDING'
            ) {
              outstandingLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'RETURN INWARD'
            ) {
              returnLeadsCount++;
            }
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PUR-PO'
            ) {
              paidLeadsCount++;
            }
          } else {
            newleadcount++;
          }
        }
        res.status(200).json({
          success: true,
          msg: 'leads counts fetched ',
          callbackcount: callbackcount,
          interstedcount: interstedcount,
          npccount: npccount,
          prospectcount: prospectcount,
          closedcount: closedcount,
          approvedcount: approvedcount,
          oldleadcount: oldleadcount,
          newleadcount: newleadcount,
          vipleadcount: vipcount,
          paidLeadsCount: paidLeadsCount,
          verifyLeadsCount: verifyLeadsCount,
          dispatchLeadsCount: dispatchLeadsCount,
          billingLeadsCount: billingLeadsCount,
          outstandingLeadsCount: outstandingLeadsCount,
          returnLeadsCount: returnLeadsCount,
        });
      }
    });
  }
);

router.get(
  '/getCallbackLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);

router.get(
  '/getCallbackLeadsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);

router.post(
  '/getCallbackLeadsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'CALLBACK'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'callback leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);

router.get(
  '/getNPCCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch NPC count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'NPC leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);

router.get(
  '/getNPCCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch NPC count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'NPC leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);

router.post(
  '/getNPCCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let callbackcount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch NPC count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'NPC'
            ) {
              callbackcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'NPC leads counts fetched ',
          count: callbackcount
        });
      }
    });
  }
);


router.get(
  '/getInterestedCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let intcount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Interested count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              intcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Interested leads counts fetched ',
          count: intcount
        });
      }
    });
  }
);

router.get(
  '/getInterestedCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let intcount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Interested count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              intcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Interested leads counts fetched ',
          count: intcount
        });
      }
    });
  }
);
router.post(
  '/getInterestedCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let intcount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Interested count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'INTERESTED'
            ) {
              intcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Interested leads counts fetched ',
          count: intcount
        });
      }
    });
  }
);


router.get(
  '/getProspectsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let pcount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Prospect count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT'
            ) {
              pcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Prospect leads counts fetched ',
          count: pcount
        });
      }
    });
  }
);
router.get(
  '/getProspectsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let pcount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Prospect count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT'
            ) {
              pcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Prospect leads counts fetched ',
          count: pcount
        });
      }
    });
  }
);

router.post(
  '/getProspectsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let pcount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch Prospect count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'PROSPECT'
            ) {
              pcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'Prospect leads counts fetched ',
          count: pcount
        });
      }
    });
  }
);

router.get(
  '/getClosedLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let closedleadcount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
            ) {
              closedleadcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'closed leads counts fetched ',
          count: closedleadcount
        });
      }
    });
  }
);
router.get(
  '/getClosedLeadsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let closedleadcount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
            ) {
              closedleadcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'closed leads counts fetched ',
          count: closedleadcount
        });
      }
    });
  }
);
router.post(
  '/getClosedLeadsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let closedleadcount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch callback count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status == 'CLOSED'
            ) {
              closedleadcount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'closed leads counts fetched ',
          count: closedleadcount
        });
      }
    });
  }
);

router.get(
  '/getApprovedLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let approvedLeadsCount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID'
            ) {
              approvedLeadsCount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads counts fetched ',
          count: approvedLeadsCount
        });
      }
    });
  }
);

router.get(
  '/getApprovedLeadsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    approvedLeadsCount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID'
            ) {
              approvedLeadsCount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads counts fetched ',
          count: approvedLeadsCount
        });
      }
    });
  }
);

router.post(
  '/getApprovedLeadsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    approvedLeadsCount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch paid count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              'APPROVED' || leads[i].followup[leads[i].followup.length - 1].status ==
              'PAID'
            ) {
              approvedLeadsCount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'paid leads counts fetched ',
          count: approvedLeadsCount
        });
      }
    });
  }
);

router.get(
  '/getNewLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeads((err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'new leads count fetched',
          count: newleads.length
        });
      }
    });
  }
);
router.get(
  '/getNewLeadsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeadsByUser(req.params.username, (err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'new leads count fetched',
          count: newleads.length
        });
      }
    });
  }
);

router.post(
  '/getNewLeadsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getNewLeadsByUserByUsernames(req.body.usernames, (err, newleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch new leads', err: err });
      } else {
        res.status(200).json({
          success: true,
          msg: 'new leads count fetched',
          count: newleads.length
        });
      }
    });
  }
);

router.post(
  '/deleteLeadById',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.deleteLeadById(req.body.id, (err, deletedLead) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to delete lead', err: err });
      } else {

        const newActivity = new Activity({
          activityType: 'Lead Deleted',
          activityData: {
            lead: deletedLead
          },
          User: req.user,
          UserId: req.user._id,
          LeadId: req.body.id,
          msg: `Lead: ${deletedLead.mobile} Deleted By ${req.user.username}`,
        });
        Activity.addActivity(newActivity, (err, data) => {
          if (err) throw err;
        });

        res.status(200).json({
          success: true,
          msg: 'lead deleted'
        });
      }
    });
  }
);

router.get(
  '/getOldLeadsCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeads((err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'old leads count fetched',
          count: oldLeadsArray.length
        });
      }
    });
  }
);

router.get(
  '/getOldLeadsCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUser(req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'old leads count fetched',
          count: oldLeadsArray.length
        });
      }
    });
  }
);

router.post(
  '/getOldLeadsCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getOldLeadsByUserByUsernames(req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch old leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'APPROVED' || oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'PAID' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'CLOSED' ||
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              'MAP'
            ) {
            } else {
              oldLeadsArray.push(oldleads[i]);
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'old leads count fetched',
          count: oldLeadsArray.length
        });
      }
    });
  }
);

router.post(
  '/getLeadsReport',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {

    const data = {
      fromDate: req.body.from,
      toDate: req.body.to,
      users: req.body.users
    };

    // console.log(data);

    Lead.getLeadsReport(data, (err, allLeads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all leads', err: err });
      } else {
        if (allLeads.length) {
          res.json({ success: true, msg: `${allLeads.length} leads fetched`, leads: allLeads });
        } else {
          res.json({ success: false, msg: 'No Leads Found' });
        }
      }
    });
  }
);

router.post(
  '/getLeadUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {

    Lead.getLeadUsernames((err, allUsernames) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch all usernames', data: err });
      } else {
        if (allUsernames.length) {
          res.json({ success: true, msg: `${allUsernames.length} leads username fetched`, data: allUsernames });
        } else {
          res.json({ success: false, msg: 'No Usernames Found', data: [] });
        }
      }
    });
  }
);


router.post(
  '/updateTransactionData',
  // passport.authenticate('jwt', { session: false }),
  (req, res) => {
    const transactionDataString = req.body.transactionDataString;
    const orderId = req.body.orderId;
    const memberId = req.body.memberId;
    const subscriptionId = req.body.subscriptionId;
    const orderStatus = req.body.orderStatus;

    console.log(transactionDataString);
    console.log(orderId);
    console.log(memberId);
    console.log(subscriptionId);
    console.log(orderStatus);

    let doSubscription = false;
    if (memberId != 0) {
      doSubscription = true;
    }

    if (orderStatus == 'Success') {
      const transactionData = JSON.parse(transactionDataString);
      // const failureMsg = info.failure_message;
      Lead.findById(orderId, (err, doc) => {
        if (err) {
          res.json({
            success: false,
            msg: err.messagae,
            data: err
          });
        } else {
          if (doc) {
            const newRemark = 'Order ID: ' + orderId + ' | Paid:' + doc.remark.slice(7);
            const newTransactionData = JSON.stringify(transactionData);
            Lead.findByIdAndUpdate(orderId, { $set: { remark: newRemark, transactionData: newTransactionData } }, (err, ulead) => {
              if (err) {
                res.json({
                  success: false,
                  msg: err.messagae,
                  data: err
                });
              } else {
                if (doSubscription) {
                  NewMember.findOne({ member_id: memberId }, (err, mem) => {
                    if (err) {
                      console.log(err),
                        console.log('Warning: Transaction Updated But Member Not Subscribed');
                      res.json({
                        success: false,
                        msg: 'Transaction Updated But Member Not Subscribed',
                        data: err
                      });
                    } else {
                      BookPlan.findById(subscriptionId, (err, bPlan) => {
                        if (err) {
                          res.json({
                            success: false,
                            msg: 'Transaction Updated But Member Not Subscribed',
                            data: err
                          });
                        } else {
                          console.log('bPlan');
                          console.log(bPlan);
                          var newSubscribedBooks = [];
                          if (mem.subscribed_books && mem.subscribed_books.length) {
                            newSubscribedBooks = mem.subscribed_books;
                          }
                          if (mem.subscribed_books == 2) {
                            newSubscribedBooks = []
                          }
                          newSubscribedBooks.push(bPlan);
                          console.log(newSubscribedBooks);
                          NewMember.findByIdAndUpdate(mem._id, { $set: { subscribed_books: newSubscribedBooks } }, (err, umem) => {
                            if (err) {
                              res.json({
                                success: false,
                                msg: 'Transaction Updated But Member Not Subscribed',
                                data: err
                              });
                            } else {
                              let transactionToAdd = {
                                payee: mem.member_id + "@" + mem._id,
                                receiver: 0,
                                from: "member",
                                to: "company",
                                action: "debit",
                                amount: bPlan.plan_price,
                                prevBal: parseInt(mem.wallet) + parseInt(bPlan.plan_price),
                                Remark: mem.member_name + '@' + mem.member_mobile + ' ' + 'A: Member Subscription',
                                Refrence: bPlan.name + "@" + bPlan._id,
                                Date: Date.now(),
                                created_at: Date.now(),
                                created_by: 'organic'
                              };
                              let transactionToAddCredit = {
                                payee: 0,
                                receiver: mem.member_id + "@" + mem._id,
                                from: "CCAvenue",
                                to: "member",
                                action: "credit",
                                amount: bPlan.plan_price,
                                prevBal: mem.wallet,
                                Remark: mem.member_name + '@' + mem.member_mobile + ' ' + 'A: Member Wallet Recharge',
                                Refrence: bPlan.name + "@" + bPlan._id,
                                Date: Date.now(),
                                created_at: Date.now(),
                                created_by: 'organic'
                              };
                              Transaction.newTransaction(transactionToAddCredit, (err, nTrans) => {
                                Transaction.newTransaction(transactionToAdd, (err, nTrans) => {
                                  if (err) {
                                    res.json({
                                      success: false,
                                      msg: 'Transaction Not Done',
                                      data: err
                                    });
                                  } else {
                                    res.json({
                                      success: true,
                                      msg: 'Transaction Updated',
                                      data: {}
                                    })
                                  }
                                })
                              });
                            }
                          })
                        }
                      })
                    }
                  });
                } else {
                  res.json({
                    success: true,
                    msg: 'Transaction Updated',
                    data: {}
                  })
                }
              }
            });
          } else {
            res.json({
              success: false,
              msg: 'lead not found',
              data: doc
            });
          }
        }
      });
    } else {
      const transactionData = JSON.parse(transactionDataString);
      const failureMsg = transactionData[4];
      Lead.findById(orderId, (err, doc) => {
        if (err) {
          res.json({
            success: false,
            msg: err.messagae,
            data: err
          });
        } else {
          if (doc) {
            const newRemark = failureMsg + ' | ' + orderStatus + ' | Order ID: ' + orderId + ' | ' + doc.remark;
            const newTransactionData = JSON.stringify(transactionData);
            Lead.findByIdAndUpdate(orderId, { $set: { remark: newRemark, transactionData: newTransactionData } }, (err, ulead) => {
              if (err) {
                res.json({
                  success: false,
                  msg: err.messagae,
                  data: err
                });
              } else {
                res.json({
                  success: true,
                  msg: 'Transaction Updated',
                  data: {}
                })
              }
            });
          } else {
            res.json({
              success: false,
              msg: 'lead not found',
              data: doc
            });
          }
        }
      });
    }
  }
);


router.post(
  '/updateTransactionDataWithEvent',
  // passport.authenticate('jwt', { session: false }),
  (req, res) => {
    const transactionDataString = req.body.transactionDataString;
    const orderId = req.body.orderId;
    const memberId = req.body.memberId;
    const eventId = req.body.eventId;
    const subscriptionId = req.body.subscriptionId;
    const orderStatus = req.body.orderStatus;

    console.log(transactionDataString);
    console.log(orderId);
    console.log(memberId);
    console.log(subscriptionId);
    console.log(orderStatus);

    let doSubscription = false;
    if (memberId != 0) {
      doSubscription = true;
    }

    if (orderStatus == 'Success') {
      const transactionData = JSON.parse(transactionDataString);
      // const failureMsg = info.failure_message;
      Lead.findById(orderId, (err, doc) => {
        if (err) {
          res.json({
            success: false,
            msg: err.messagae,
            data: err
          });
        } else {
          if (doc) {
            const newRemark = 'Order ID: ' + orderId + ' | Paid:' + doc.remark.slice(7);
            const newTransactionData = JSON.stringify(transactionData);
            Lead.findByIdAndUpdate(orderId, { $set: { remark: newRemark, transactionData: newTransactionData } }, (err, ulead) => {
              if (err) {
                res.json({
                  success: false,
                  msg: err.messagae,
                  data: err
                });
              } else {
                if (doSubscription) {
                  EventController.subscribeMembersForWeb(req, res, [memberId], eventId, subscriptionId);
                } else {
                  res.json({
                    success: true,
                    msg: 'Transaction Updated',
                    data: {}
                  })
                }
              }
            });
          } else {
            res.json({
              success: false,
              msg: 'lead not found',
              data: doc
            });
          }
        }
      });
    } else {
      const transactionData = JSON.parse(transactionDataString);
      const failureMsg = transactionData[4];
      Lead.findById(orderId, (err, doc) => {
        if (err) {
          res.json({
            success: false,
            msg: err.messagae,
            data: err
          });
        } else {
          if (doc) {
            const newRemark = failureMsg + ' | ' + orderStatus + ' | Order ID: ' + orderId + ' | ' + doc.remark;
            const newTransactionData = JSON.stringify(transactionData);
            Lead.findByIdAndUpdate(orderId, { $set: { remark: newRemark, transactionData: newTransactionData } }, (err, ulead) => {
              if (err) {
                res.json({
                  success: false,
                  msg: err.messagae,
                  data: err
                });
              } else {
                res.json({
                  success: true,
                  msg: 'Transaction Updated',
                  data: {}
                })
              }
            });
          } else {
            res.json({
              success: false,
              msg: 'lead not found',
              data: doc
            });
          }
        }
      });
    }
  }
);


router.post('/import', (req, res) => {
  // console.log('import');
  new formidable.IncomingForm().parse(req)
    .on('field', (name, field) => {
      // console.log('Field', name, field)
    })
    .on('file', (name, file) => {
      // console.log('Uploaded file', name, file)
    })
    .on('aborted', () => {
      console.error('Request aborted by the user')
    })
    .on('error', (err) => {
      console.error('Error', err)
      throw err
    })
    .on('end', () => {
      res.end()
    })
});

router.get('/serverDate', (req, res) => {
  res.json(
    {
      success: true,
      date: Date.now()
    }
  );
});

// Extra Changes


router.post(
  '/getLeadsStatusCount',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let statuscount = 0;
    Lead.getLeads((err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch status count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              req.body.status
            ) {
              statuscount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'status leads counts fetched ',
          count: statuscount
        });
      }
    });
  }
);

router.post(
  '/getLeadsStatusCount/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let statuscount = 0;
    Lead.getLeadsByUser(req.params.username, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch status count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              req.body.status
            ) {
              statuscount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'status leads counts fetched ',
          count: statuscount
        });
      }
    });
  }
);

router.post(
  '/getLeadsStatusCountByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let statuscount = 0;
    Lead.getLeadsByUserByUsernames(req.body.usernames, (err, leads) => {
      if (err) {
        res.status(200).json({
          success: false,
          msg: 'Failed to fetch status count',
          err: err
        });
      } else {
        for (let i = 0; i < leads.length; i++) {
          if (leads[i].followup[leads[i].followup.length - 1]) {
            if (
              leads[i].followup[leads[i].followup.length - 1].status ==
              req.body.status
            ) {
              statuscount++;
            }
          }
        }
        res.status(200).json({
          success: true,
          msg: 'status leads counts fetched ',
          count: statuscount
        });
      }
    });
  }
);

router.post(
  '/getStatus',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadsStatus(req.body.status, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch status leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              req.body.status
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Status leads fetched',
          data: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getStatus/:username',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadsStatusByUser(req.body.status, req.params.username, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch status leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              req.body.status
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Status leads fetched',
          data: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getStatusByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Lead.getLeadsStatusByUserByUsernames(req.body.status, req.body.usernames, (err, oldleads) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch Status leads', err: err });
      } else {
        let oldLeadsArray = [];
        for (let i = 0; i < oldleads.length; i++) {
          if (oldleads[i].followup.length) {
            if (
              oldleads[i].followup[oldleads[i].followup.length - 1].status ==
              req.body.status
            ) {
              oldLeadsArray.push(oldleads[i]);
            } else {
            }
          }
        }

        res.status(200).json({
          success: true,
          msg: 'Status leads fetched',
          data: oldLeadsArray
        });
      }
    });
  }
);

router.post(
  '/getLabel',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    FollowupType.findOne({ label: req.body.label }, (err, doc) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch status leads', err: err });
      } else {
        let OldStatuses = doc ? (doc.oldNames ? doc.oldNames.split(',') : []) : [];
        let Statuses = doc ? ([doc.followUpType, ...OldStatuses]) : [];
        if (req.body.label == 'poapproval') {
          Statuses = ['PURCHASE ORDER'];
        }
        if (req.body.label == 'services' || req.body.label == 'billings' || req.body.label == 'outstanding') {
          Statuses = ['PO APPROVED', 'SERVICE', 'BILLING', 'PAYMENT RECD'];
        }
        if (req.body.label == 'paid') {
          Statuses = ['APPROVED', 'PAID', 'PAYMENT RECD', 'BILLING', 'OUTSTANDING'];
        }
        if (req.body.label == 'pocancellation') {
          Statuses = ['PO CANCELLATION'];
        }
        if (req.body.label == 'return') {
          Statuses = ['RETURN INWARD'];
        }
        // Lead.getLeadsStatuses(Statuses, (err, oldleads) => {
        Lead.getLeadsByLastFollowUpStatus(Statuses, (err, oldleads) => {
          if (err) {
            res
              .status(200)
              .json({ success: false, msg: 'Failed to fetch status leads', err: err });
          } else {
            // let oldLeadsArray = [];
            // for (let i = 0; i < oldleads.length; i++) {
            //   if (oldleads[i].followup.length) {
            //     let found = false;
            //     for (const status of Statuses) {
            //       if (
            //         oldleads[i].followup[oldleads[i].followup.length - 1].status ==
            //         status
            //       ) {
            //         found = true;
            //       }
            //     }
            //     if (found) {
            //       oldLeadsArray.push(oldleads[i]);
            //     }
            //   }
            // }
            // for (const ol of oldleads) {
            //   if (ol.transactions.length) {
            //     console.log('transactions');
            //     console.log(ol.transactions);
            //   }
            // }
            res.status(200).json({
              success: true,
              msg: 'Status leads fetched',
              // data: oldLeadsArray
              data: oldleads
            });

            allotLeadNumber((err, doc) => {
              if (err) {
                console.log('Error In Lead Counts');
              } else {
                console.log('Updated Lead Counts');
              }
            });
          }
        });
      }
    });
  }
);

router.post(
  '/getLabelByUsernames',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    FollowupType.findOne({ label: req.body.label }, (err, doc) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Failed to fetch status leads', err: err });
      } else {
        let OldStatuses = doc ? (doc.oldNames ? doc.oldNames.split(',') : []) : [];
        let Statuses = doc ? ([doc.followUpType, ...OldStatuses]) : [];
        if (req.body.label == 'poapproval') {
          Statuses = ['PURCHASE ORDER'];
        }
        if (req.body.label == 'services' || req.body.label == 'billings' || req.body.label == 'outstanding') {
          Statuses = ['PO APPROVED', 'SERVICE', 'BILLING', 'PAYMENT RECD'];
        }
        if (req.body.label == 'paid') {
          Statuses = ['APPROVED', 'PAID', 'PAYMENT RECD'];
        }
        if (req.body.label == 'pocancellation') {
          Statuses = ['PO CANCELLATION'];
        }
        if (req.body.label == 'return') {
          Statuses = ['RETURN INWARD'];
        }
        Lead.getLeadsByLastFollowUpStatusByUsernames(Statuses, req.body.usernames, (err, oldleads) => {
          if (err) {
            res
              .status(200)
              .json({ success: false, msg: 'Failed to fetch Status leads', err: err });
          } else {
            // let oldLeadsArray = [];
            // for (let i = 0; i < oldleads.length; i++) {
            //   if (oldleads[i].followup.length) {
            //     let found = false;
            //     for (const status of Statuses) {
            //       if (
            //         oldleads[i].followup[oldleads[i].followup.length - 1].status ==
            //         status
            //       ) {
            //         found = true;
            //       }
            //     }
            //     if (found) {
            //       oldLeadsArray.push(oldleads[i]);
            //     }
            //   }
            // }

            res.status(200).json({
              success: true,
              msg: 'Status leads fetched',
              data: oldleads
            });
          }
        });
      }
    });
  }
);

router.get('/allotLeadNumber', (req, res) => {
  allotLeadNumber((err, docs) => {
    return res.json({ err, docs });
  });
});


module.exports = router;

function allotLeadNumber(callback) {
  Lead.find({ leadNumber: { $exists: true } }, { leadNumber: 1 }).sort({ leadNumber: -1 }).limit(1)
    .then(docs => {
      const lastInsertedNumber = docs[0] ? docs[0].leadNumber : 0;
      Lead.find({ leadNumber: { $exists: false } }).then(docs => {
        callback(null, docs.length)
        for (let i = 0; i < docs.length; i++) {
          const element = docs[i];
          element.leadNumber = lastInsertedNumber + (i + 1);
          Lead.updateOne({ _id: element._id }, { $set: { leadNumber: element.leadNumber } })
            .then(doc => {
              console.log(doc);
            })
            .catch(err => {
              console.log(err);
            });
        }
      }).catch(err => {
        callback(err, null);
      });
    }
    ).catch(err => {
      callback(err, null);
    });
}
