const express = require('express');
const router = express.Router();
const Mail = require('../models/mail');
const Lead = require('../models/lead');
const NewMember = require('../models/new_member');
const nodemailer = require('nodemailer');
const fs = require('fs');

router.post('/sendMail', (req, res, next) => {

    setTimeout(() => {

        // console.log('Send Mail Path 1');
        mailList = req.body.cc;
        mailList.push(req.body.to);

        let filenames = req.body.attachments;
        let newattachments = [];
        for (let i = 0; i < filenames.length; i++) {
            let attach = {
                filename: filenames[i],
                path: `./uploads/${filenames[i]}`
            }
            newattachments.push(attach);
        }

        var transporter = nodemailer.createTransport({
            host: 'mail.shadibyahwale.com',
            port: '465',
            secure: true,
            tls: {
                rejectUnauthorized: false
            },
            service: 'smtp',
            auth: {
                user: 'noreply@shadibyahwale.com',
                pass: 'Indore@12345'
            }
        });

        // console.log('Send Mail Path 2');

        var mailOptions = {
            from: 'noreply@shadibyahwale.com',
            to: mailList,
            subject: req.body.sub,
            // html: req.body.message,
            html: '<p>' + (req.body.message.split("\n").join("<br />")) + '</p>',
            attachments: newattachments
        };

        // console.log(mailOptions);


        transporter.sendMail(mailOptions, function (error, info) {
            if (error) {
                // console.log(error);
                // console.log('Send Mail Path 3');
                deleteFiles(filenames);
                res.status(500).json({ success: false, msg: 'Some internal server error', err: error });
            } else {
                console.log('Send Mail Path 4');
                deleteFiles(filenames);
                res.status(200).json({ success: true, msg: 'Email sent: ' + info.response });
            }
        });
    }, 5500);
});

function deleteFiles(filenames) {
    // console.log('Send Mail Path 5');
    for (let i = 0; i < filenames.length; i++) {
        if (`./uploads/${filenames[i]}`) {
            fs.unlinkSync(`./uploads/${filenames[i]}`);
        }
    }
}

router.post('/forgotPasswordOTP', (req, res, next) => {
    const otp = req.body.otp;
    const email = req.body.email;

    Lead.getLeadsByEmail(email, (err, user) => {
        if (err) {
            res.status(500).json({ success: false, msg: "some internal server error", err: err });
        } else {
            if (!user) {
                res.status(200).json({ success: false, msg: 'No User Found With This Email' });
            } else {
                Mail.forgotPasswordOTP(email, otp, (error, info) => {
                    if (error) {
                        // console.log(error);
                        res.status(500).json({ success: false, msg: "some internal server error", err: error });
                    } else {
                        // console.log('Email sent: ' + info.response);
                        res.status(200).json({ success: true, user: user._id, msg: 'Email sent: ' + info.response });
                    }
                });
            }
        }
    });
});

router.post('/sendTestMail', (req, res, next) => {
    let emailsToAdd = req.body.emails;
    const eventId = req.body.eventId;
    const eventName = req.body.eventName;


    NewMember.getMemInEvent(eventId, (err, data) => {
        if (err) {
            res.json({ success: false, data: err, msg: err.message });
        } else {
            let emails = [];
            for (const mem of data) {
                emails.push(mem.member_email);
            }
            emails = emails.filter(o => o != "");
            emails = emails.filter(o => o != "NA");
            emailsToAdd = emailsToAdd.split(',');
            // emails = [...emails, ...emailsToAdd];
            emails = [...emailsToAdd];
            const emailsString = emails.join(',');

            const msg = `
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head> 
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> 
<!--[if !mso]><!--> 
<meta http-equiv="X-UA-Compatible" content="IE=edge" /> 
<!--<![endif]--> 
<meta name="viewport" content="width=device-width, initial-scale=1.0" /> 
<!--[if mso]><!-- --> 
<link href="https://fonts.googleapis.com/css?family=Roboto:400,500,700" rel="stylesheet" type="text/css" /> 
<!--<![endif]--> 
<title>Shaadisammelan.com Event Notification</title> 
<style type="text/css">
html {
width: 100%;
}

::-moz-selection {
background: #f8f8f8;
color: #ffffff;
}

::selection {
background: #f8f8f8;
color: #ffffff;
}

.body {
background-color: #f8f8f8;
margin: 0 auto !important;
padding: 0 !important;
}

.ReadMsgBody {
width: 100%;
background-color: #f8f8f8;
}

.ExternalClass {
width: 100%;
background-color: #ffffff;
}

p {
margin: inherit !important;
padding: inherit !important;
font-size: inherit !important;
}

a {
color: #ff7055;
text-decoration: none;
font-style: normal;
}

a:hover {
color: #636569;
font-style: normal;
}

.header_links a {
color: #666666 !important;
text-decoration: none !important;
}

.header_links a:hover {
color: #ff7055 !important;
text-decoration: none !important;
}

.contact a {
color: #ff7055 !important;
text-decoration: none !important;
}

.contact a:hover {
color: #636569 !important;
text-decoration: none !important;
}

.contactwhite a {
color: #ffffff !important;
text-decoration: none !important;
}

.address a {
color: #636569 !important;
text-decoration: none !important;
}

.phone a {
color: #ff7055 !important;
text-decoration: none !important;
}

.link_white a {
color: #ffffff !important;
text-decoration: none !important;
}
	.linkdark a {
		color: #3c3c3c !important;
		text-decoration: none !important;
	}

.bg_rollover:hover {
background-color: #FBFBFB !important;
}

.bg_rollover_orange:hover {
background-color: #3c3c3c !important;
}

/* Gmail Targeting*/

u+#body a {
color: inherit;
text-decoration: none;
font-size: inherit;
font-family: inherit;
font-weight: inherit;
line-height: inherit;
}

p,
div {
margin: 0 !important;
}

table {
border-collapse: collapse;
}

a[x-apple-data-detectors] {
color: inherit !important;
text-decoration: none !important;
font-size: inherit !important;
font-family: inherit !important;
font-weight: inherit !important;
line-height: inherit !important;
}

/*	Samsung*/

#MessageViewBody a {
color: inherit;
text-decoration: none;
font-size: inherit;
font-family: inherit;
font-weight: inherit;
line-height: inherit;
}

#MessageViewBody,
#MessageWebViewDiv {
min-width: 100vw;
margin: 0 !important;
zoom: 1 !important;
}

@media only screen and (max-width: 640px) {
table table {
width: 100% !important;
}

.full_width {
width: 100% !important;
}

.div_scale {
width: 440px !important;
margin: 0 auto !important;
}

.table_scale {
width: 440px !important;
margin: 0 auto !important;
}

.td_scale {
width: 440px !important;
margin: 0 auto !important;
}

.img_scale {
width: 100% !important;
height: auto !important;
}

.img_card {
width: 80% !important;
margin: 0 !important;
height: auto !important;
padding-bottom: 0px !important;
}

.img_logo {
width: 20% !important;
margin: 0 !important;
height: auto !important;
}

.divider {
width: 440px !important;
height: 2px !important;
}

.spacer {
display: none !important;
}

.spacer {
display: none !important;
}

	.header {
		font-size: 30px !important;
line-height: 32px !important;
	}
	
	.subheader {
			font-size: 26px !important;
line-height: 28px !important;
	}
.left {
text-align: left !important;
}

.left_header {
font-size: 24px !important;
line-height: 28px !important;
padding-top: 0px !important;
padding-bottom: 0px !important;
}

.left_headersub {
font-size: 38px !important;
line-height: 50px !important;
padding-top: 0px !important;
padding-bottom: 10px !important;
}

.left_logo {
width: 100% !important;
}

.centers {
text-align: center !important;
}

.footer {
padding-left: 60px !important;
padding-right: 40px !important;
}

.full {
width: 100% !important;

}

.divider {
width: 100px !important;
height: 1px !important;
}

.button {
width: 50% !important;
margin: 0 auto !important;
}

.centers_card {
padding-top: 0px !important;
padding-left: 10px !important;
padding-right: 10px !important;
text-align: center !important;
}

.centers_cardb {
padding-top: 10px !important;
padding-bottom: 15px !important;
padding-left: 10px !important;
padding-right: 10px !important;
text-align: center !important;
}
}

@media only screen and (max-width: 479px) {
table table {
width: 100% !important;
margin: 0 !important;
}

.full_width {
width: 100% !important;
margin: 0 !important;
}

.div_scale {
width: 350px !important;
margin: 0 auto !important;
}

.table_scale {
width: 100% !important;
margin: 0 !important;
}

.td_scale {
width: 350px !important;
margin: 0 auto !important;
}

.img_scale {
width: 100% !important;
height: auto !important;
}

.img_card {
width: 100% !important;
margin: 0 !important;
height: auto !important;
}

.img_logo {
width: 30% !important;
margin: 0 !important;
height: auto !important;
}

.imgsm {
width: 80% !important;
height: auto !important;

}

.spacer {
display: none !important;
}

.center {
text-align: left !important;
}

.left_header {
font-size: 20px !important;

}
	.header {
		font-size: 26px !important;
line-height: 28px !important;
	}
		.subheader {
			font-size: 22px !important;
line-height: 24px !important;
	}
	
.left_headersub {
font-size: 36px !important;
line-height: 40px !important;

}

.left_logo {
width: 100% !important;
font-size: 14px !important;
}

.centers {
text-align: center !important;
}

.footer {
padding-left: 30px !important;
padding-right: 5px !important;
}

.footerlinks {
padding-left: 10px !important;
padding-right: 10px !important;
}

.centers_card {
padding-top: 0px !important;
padding-left: 10px !important;
padding-right: 10px !important;
text-align: center !important;
}

.centers_cardb {
padding-top: 10px !important;
padding-bottom: 15px !important;
padding-left: 10px !important;
padding-right: 10px !important;
text-align: center !important;
}

.full {
width: 100% !important;
margin: 0 !important;
}

.divider {
width: 100px !important;
height: 1px !important;
}

.button {
width: 60% !important;
margin: 0 auto !important;
}

}

</style> 
<!--[if mso]>
<style type="text/css">
body, table, td {font-family: Arial, Helvetica, sans-serif !important;}
</style>
<![endif]--> 
<!--[if gte mso 9]><xml>
<o:OfficeDocumentSettings>
<o:AllowPNG/>
<o:PixelsPerInch>96</o:PixelsPerInch>
</o:OfficeDocumentSettings>
</xml><![endif]--> 
</head> 
<body id="body" class="body" bgcolor="#f8f8f8" style="margin: 0 ?px;"> 
<div style="display: none; max-height: 0px; overflow: hidden;">
 Shaadisammelan Event Notification
</div> 
<!-- Insert &zwnj;&nbsp; hack after hidden preview text --> 
<div style="display: none; max-height: 0px; overflow: hidden;">
 &nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌ 
</div> 
<!-- Insert &zwnj;&nbsp; hack after hidden preview text --> 
<div style="display: none; max-height: 0px; overflow: hidden;">
 &nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌ 
</div> 
<!-- Insert &zwnj;&nbsp; hack after hidden preview text --> 
<div style="display: none; max-height: 0px; overflow: hidden;">
 &nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌&nbsp;‌ 
</div> 
<!-- START OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<table class="table_scale" width="100%" align="center" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="100%"> 
<table align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<!--Start of Logo and Call Now--> 
<table align="center" class="table_scale" width="600" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0" style="margin: 0px;"> 
<tbody>
<tr> 
<td width="100%"> 
<table align="center" width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="600" valign="bottom"> 
<!-- START OF LEFT COLUMN--> 
<table class="full" align="left" width="600" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<!-- START OF TEXT--> 
<tbody>
<tr> 
<td width="600" align="left" valign="bottom" class="left_logo" style="background-image: url('http://go.campaignmonitor.com/rs/500-BIA-880/images/Header_Spacer1200x150.png'); width: 600px; background-repeat: no-repeat; background-position: top center; background-size: cover; margin: 0; padding-top: 30px; padding-bottom: 30px; padding-left: 5px; font-size:18px; color:#3c3c3c; font-family: Helvetica, Arial, sans-serif;  "> <span> <a href=
"https://shaadisammelan.com/login" target="_blank" style="color:#3c3c3c;"
> <img class="img_logo" src="http://shaadisammelan.com/assets/img/logo/shaadisammelan-logo.png" width="114" alt="Shaadisammelan Logo" border="0" style="display: inline-block;" /> </a> </span> </td> 
</tr> 
<!-- END OF TEXT--> 
</tbody>
</table> 
<!-- END OF LEFT COLUMN--> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> 
<!-- END OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<!-- START OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<table class="table_scale" width="100%" align="center" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="100%"> 
<table align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="table_scale" width="600" bgcolor="#ffffff" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="600"> 
<table class="full" align="left" width="600" role="presentation" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<!-- START OF IMAGE--> 
<tbody>
<tr> 
<td class="centers" align="center" style="padding-bottom: 10px; margin: 0; font-size:13px; color:#555559; font-family: Helvetica, Arial, sans-serif; line-height: 23px;"> <a href=
"https://shaadisammelan.com/login" target="_blank"
> <img src="https://shaadisammelan.com/assets/book/bookOnTable.jpeg" width="300" alt="" class="img_scale" style="display: block; font-family: Gotham, 'Helvetica Neue', Helvetica, Arial, 'sans-serif'; font-size: 40px; line-height: 50px; margin:0; text-align: center;" border="0" /> </a> </td> 
</tr> 
<!-- END OF IMAGE--> 
<!-- START OF TEXT--> 
<tr> 
<td class="header" align="center" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 30px; color:#3c3c3c; padding-left: 30px; padding-right: 30px; padding-top: 20px; padding-bottom: 5px; font-weight: 500; line-height: 36px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-main-header">
Your E-Patrika Generated:
</div> </td> 
</tr> 
<tr> 
<td class="subheader" align="center" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 26px; color:#3c3c3c; padding-left: 30px; padding-right: 30px; padding-top: 0px; padding-bottom: 20px; font-weight: 400; line-height: 34px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-main-header2">
Congratulations, sadhisammelan ${eventName} has been successfully uploaded.
</div> </td> 
</tr>
<tr> 
<td class="left" align="left" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 16px; font-weight: normal; color: #3c3c3c; line-height: 20px; padding-top: 0px; padding-bottom: 15px; padding-left: 25px; padding-right: 25px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-main-copy">
Congratulations, sadhisammelan ${eventName} has been successfully uploaded.</br>
You can log in a registered user & check your details as well as view 1000 of profiles .</br>
Happy meeting!!!!! Kindly login to your account at Shaadisammelan.com to check your dashboard with newly added profiles.
</div> </td> 
</tr> 
<!-- START BUTTON--> 
<tr> 
<td align="center" valign="top" style="padding-top: 15px; padding-left: 15px; padding-right: 15px; padding-bottom: 50px;"> 
<table class="button" border="0" align="center" cellpadding="0" cellspacing="0" bgcolor="#ffffff" style="margin: 0;"> 
<tbody>
<tr> 
<td align="center" valign="middle" bgcolor="#ff7055" style="background-color:#ff7055;  border-radius:25px; padding: 10px 45px; font-size: 16px; line-height: 20px; font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-weight: 400; color:#ffffff; margin: 0 !important; letter-spacing: .5px; "> 
<div class="mktoText" id="mkto-main-cta">
<span class="link_white"><a href="https://shaadisammelan.com/login" target="_blank" style="color: #ffffff; text-decoration: none;"
>Login Now</a></span>
</div> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
<!-- END BUTTON--> 
<!-- END OF TEXT--> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> 
<!-- END OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<!-- START OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<table class="table_scale" width="100%" align="center" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="100%"> 
<table align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="table_scale" width="600" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="600"> 
<table class="full" align="left" width="600" role="presentation" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<tbody>
<tr> 
<td class="centers" align="center" bgcolor="#f8f8f8" width="600" style=" margin: 0; "> <img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Header_Spacer1200x150.png" width="600" alt="" class="img_scale" style="display: block; font-family: Gotham, 'Helvetica Neue', Helvetica, Arial, 'sans-serif'; font-size: 40px; line-height: 50px; margin:0; text-align: center;" border="0" /> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> 
<!-- END OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<!-- START OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<table class="table_scale" width="100%" align="center" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="100%"> 
<table align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="table_scale" width="600" bgcolor="#ffffff" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="full" width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="600"> 
<table class="full" align="left" width="600" bgcolor="#ffffff" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<!-- START OF TEXT--> 
</table>
<table class="full" align="left" width="600" role="presentation" bgcolor="#ffffff" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<tbody>
<tr> 
<td class="eventheader" align="left" width="600" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 20px; line-height: 25px; font-weight: 400; color: #3c3c3c;  padding-top: 30px; padding-bottom: 10px; padding-right: 30px; padding-left: 30px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-event-header19">
Dear User , we at shadisammelan proudly annouce the successful uploading of our E-Patrika ${eventName}:
</div> </td> 
</tr> 
<tr> 
<td class="eventheader" align="left" valign="middle" width="600" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 18px; line-height: 20px; font-weight: 400; color: #3c3c3c;  padding-top: 10px; padding-bottom: 10px; padding-right: 30px; padding-left: 30px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-event-header20">
<img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Circle.jpg" width="10" alt="" /> &nbsp; 
<span class="contact"><a href=
"https://shaadisammelan.com" target="_blank" style="text-decoration: none; color: #ff7055;"
>
Here you can contact 1000 of profiles , groom & brides , As GOD has made a person for everyone , may you find one here on this platform .
</a></span>
</div> </td> 
</tr> 
<tr> 
<td class="eventheader" align="left" width="600" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 18px; line-height: 20px; font-weight: 400; color: #3c3c3c;  padding-top: 10px; padding-bottom: 10px; padding-right: 30px; padding-left: 30px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-event-header23">
<img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Circle.jpg" width="10" alt="" /> &nbsp; 
<span class="contact"><a href=
"https://shaadisammelan.com" target="_blank" style="text-decoration: none; color: #ff7055;"
>
This platform gives you the facility to edit your profile as & when there is change in your bio data .
</a></span>
</div> </td> 
</tr> 
<tr> 
<td class="eventheader" align="left" width="600" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 18px; line-height: 20px; font-weight: 400; color: #3c3c3c;  padding-top: 10px; padding-bottom: 30px; padding-right: 30px; padding-left: 30px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-event-header24">
<img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Circle.jpg" width="10" alt="" /> &nbsp; 
<span class="contact"><a href=
"https://shaadisammelan.com" target="_blank" style="text-decoration: none; color: #ff7055;"
>
In case if you dont find a suitable match in this edition , do not loose heart , a new one is coming in June again , on a nominal fee of Rs. 200 you can reprint your biodata with picture & increase the reach.
</a></span>
</div> </td> 
</tr> 
<tr> 
<td class="eventheader" align="left" width="600" style="font-family: Roboto, Helvetica, Arial, 'sans-serif'; font-size: 18px; line-height: 20px; font-weight: 400; color: #3c3c3c;  padding-top: 10px; padding-bottom: 30px; padding-right: 30px; padding-left: 30px; letter-spacing:.5px;"> 
<div class="mktoText" id="mkto-event-header24">
<img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Circle.jpg" width="10" alt="" /> &nbsp; 
<span class="contact"><a href=
"https://shaadisammelan.com" target="_blank" style="text-decoration: none; color: #ff7055;"
>
In some cases it takes longer to get a right match , So there is always a second chance.
</a></span>
</div> </td> 
</tr> 
</tbody>
</table> 
<!-- END OF TEXT--> 
<!-- START OF TEXT--> 
<table class="full" align="left" width="600" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<tbody>
<tr> 
<td class="centers" align="center" bgcolor="#f8f8f8" width="600" style=" margin: 0; "> <img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Space_3.png" width="600" height="" alt="" class="img_scale" style="display: block; font-family: Gotham, 'Helvetica Neue', Helvetica, Arial, 'sans-serif'; font-size: 40px; line-height: 50px; margin:0; text-align: center;" border="0" /> </td> 
</tr> 
</tbody>
</table> </td>
</tr>
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table>    
<!-- END OF 1/1 (FULL WIDTH) COLUMN BLOCK--> 
<!-- START OF FOOTER BLOCK--> 
<table class="table_scale" width="100%" align="center" bgcolor="#f8f8f8" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="100%"> 
<table bgcolor="#ff7055" align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<!-- START OF ADDRESS BLOCK--> 
<table class="full_width" width="600" bgcolor="#ff7055" align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%" class="centers" align="center" style="padding-top: 15px; padding-bottom: 10px;"> 
<a href=
"https://www.facebook.com/Shaadisammelancom-105349231045331" style="text-decoration: none;" target="_blank"
><img src="http://go.campaignmonitor.com/rs/500-BIA-880/images/Emma_FB.png" alt="Facebook" width="30" style="display: inline-block;" border="0" /></a>&nbsp;&nbsp;&nbsp;&nbsp; </td> 
</tr> 
</tbody>
</table> 
<table width="600" class="full" align="center" bgcolor="#2b2b2b9" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td valign="top" width="600"> 
<table class="full" align="center" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="table_scale" width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td class="full_width" width="100%"> 
<table class="table_scale" width="600" bgcolor="#2b2b2b9" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table class="table_scale" width="600" bgcolor="#2b2b2b9" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="100%"> 
<table width="600" cellpadding="0" cellspacing="0" border="0"> 
<tbody>
<tr> 
<td width="600"> 
<table class="full" align="center" role="presentation" width="600" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<!-- START OF TEXT--> 
<tbody>
<tr> 
<td class="centers" align="center" style="padding-top: 50px; padding-left: 20px; padding-right: 20px;  margin: 0;  font-size:12px ; color:#ffffff; font-family: Roboto, Helvetica, Arial, 'sans-serif';line-height: 15px;mso-line-height-rule: exactly;"> 
<div class="mktoText" id="mkto-footer-copy">
<span> Shaadisammelan is part of the Group family of brands. <br /> </span>
</div> </td> 
</tr> 
<tr> 
<td width="100%" class="footer" align="center" style=" padding-bottom: 10px; padding-left: 25px; padding-right: 45px;"> <a href=
"https://shadibyahwale.com" style="text-decoration: none;" target="_blank"
><img src="https://shaadisammelan.com/assets/img/Logo.svg" alt="ShadiByahWale Logo" width="115" style="display: inline-block;" border="0" /></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <a href=
"https://factfinders.in/pmi" style="text-decoration: none;" target="_blank"
><img src="https://factfinders.in/pmi/images/factfinder.png" alt="FactFinders Logo" width="115" style="display: inline-block;" border="0" /></a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </td> 
</tr> 
<!-- END OF TEXT--> 
</tbody>
</table> 
<table class="full" align="center" width="600" role="presentation" cellpadding="0" cellspacing="0" border="0" style="border-collapse:collapse; mso-table-lspace:0pt; mso-table-rspace:0pt;"> 
<!-- START OF TEXT--> 
<tbody>
<tr> 
<td class="centers" align="center" style="padding: 10px 15px;"><img class="img_scale" src="http://go.campaignmonitor.com/rs/500-BIA-880/images/White_Spacer.png" width="375" alt="" /></td> 
</tr> 
<tr> 
<td class="footerlinks" align="center" style="margin: 0; font-size:10px ; color:#ffffff; font-family: Roboto, Helvetica, Arial, 'sans-serif'; line-height: 20px;  padding-top: 10px; padding-bottom: 30px;  mso-line-height-rule: exactly;"> 
<div class="mktoText" id="mkto-footer-preferences">
<span class="contactwhite"><a href=
"https://shaadisammelan.com/register" target="_blank" style="color: #ffffff; text-decoration: none;"
>Register</a></span>&nbsp;&nbsp; | 
<span class="contactwhite"><a href=
"https://shaadisammelan.com/login" target="_blank" style="color: #ffffff; text-decoration: none;"
>&nbsp;&nbsp;Login&nbsp;&nbsp;</a></span>|&nbsp;&nbsp; 
<span class="contactwhite"><a href=
"https://shaadisammelan.com/contacts" target="_blank" style="color: #ffffff; text-decoration: none;"
>Contact&nbsp;Us</a></span>&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp; 
<span class="contactwhite"><a href="https://shaadisammelan.com/" target="_blank" style="color: #ffffff; text-decoration: none;">E-Patrika&nbsp;Online</a></span>
</div> </td> 
</tr> 
<tr> 
<td class="centers" align="center" style="margin: 0; font-size:12px ; color:#ffffff; font-family: Roboto, Helvetica, Arial, 'sans-serif'; line-height: 18px; padding-left: 20px; padding-right: 20px;  padding-bottom: 40px;  mso-line-height-rule: exactly;"> 
<div class="mktoText" id="mkto-footer-address">
<img src="http://shaadisammelan.com/assets/img/logo/shaadisammelan-logo.png" alt="shaadisammelan" width="100px">
<br>
</div> </td> 
</tr> 
<!-- END OF TEXT--> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> </td> 
</tr> 
</tbody>
</table> 
<!-- END OF FOOTER BLOCK-->  


<!--This is a comment -->
</body>
</html>
    `;

            Mail.sendMailSSEvent(emails, msg, (error, info) => {
                if (error) {
                    console.log(error);
                    res.status(500).json({ success: false, msg: "some internal server error", data: error });
                } else {
                    console.log('Email sent: ' + info.response);
                    res.json({ success: true, msg: 'Email sent: ' + info.response, data: info });
                }
            });
        }
    });
});

module.exports = router;
