const Rashi = require('../models/rashi');
const express = require('express');
const router = express.Router();



//route to create Rashi
router.post('/createRashi', (req, res) => {
	var rashi = req.body;
	Rashi.addRashi(rashi, (err, rashi) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, rashi:rashi, msg: 'Rashi created successfully'});
        }
		
	});
});

//route to read Rashi
router.get('/readRashi', (req, res) => {
	Rashi.getRashi((err, rashi) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, rashi:rashi});
        }
		
	});
});

//route to find a rashi by id
router.get('/RashiById/:rashi_id',(req,res)=>{
	
	Rashi.getRashiById(req.params.rashi_id,(err,rashi)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(rashi===null){
				res.status(200).json({success:true, msg:"no rashi found by this id"});
				}else{
					res.status(200).json({success:true, rashi:rashi});
				}
            }
	});
});

//route to find a rashi by name
router.get('/RashiByName/:rashi_name',(req,res)=>{
	
	Rashi.getRashiByName(req.params.rashi_name,(err,rashi)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(rashi===null){
			res.status(200).json({success:true, msg:"no rashi found by such name"});
			}else{
				res.status(200).json({success:true, rashi:rashi});
			}
            	
            }
	});
});

			
		

//route to update Rashi
router.put('/updateRashi/:rashi_id', (req, res) => {
	var id = req.params.rashi_id;
    var erashi = req.body;
    Rashi.getRashiById(id, (err, rashi) => {

        if(err){
            res.status(500).json({success:false, msg:err});
            
        }else{
            if(rashi){
                Rashi.updateRashi(id, erashi, {}, (err, uprashi) => {
                    if(err){
                        res.status(500).json({success:false, msg:err});
                        
                    }else{
                        res.status(200).json({success:true, rashi:uprashi, msg: 'Rashi updated successfully'});
                    }
                });
            } else {
                res.status(200).json({success:false, msg: 'No details found by this id'});
            }
        }
    });
});

//route to delete Rashi
router.delete('/deleteRashi/:rashi_id', (req, res) => {
	var id = req.params.rashi_id;
	Rashi.removeRashi(id, (err, rashi) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, rashi:rashi, msg: 'Rashi Deleted successfully'});
        }
	});
});



module.exports = router;


