const express = require("express");
const router = express.Router();
const religionMasterController = require("./../controllers/religion-master-controller");

router.post("/create", religionMasterController.add);
router.get("/get", religionMasterController.get);
router.get("/getReligions", religionMasterController.getAllReligions);
router.get("/getCastes/:religion", religionMasterController.getAllCastes);
router.get("/getDistinctCastes", religionMasterController.getAllDistinctCastes);
router.get("/getDistinctSubCastes", religionMasterController.getAllDistinctSubCastes);
router.get("/getDistinctGotras", religionMasterController.getAllDistinctGotras);
router.get("/getSubCastes/:caste/:religion", religionMasterController.getAllSubCastes);
router.get("/getGotras/:subCaste/:religion/:caste", religionMasterController.getAllGotras);
router.post("/createReligion", religionMasterController.createReligion);
router.post("/createCaste", religionMasterController.createCaste);
router.post("/createSubCaste", religionMasterController.createSubCaste);
router.post("/createGotra", religionMasterController.createGotra);
router.put("/updateReligion", religionMasterController.updateReligion);
router.put("/updateCaste", religionMasterController.updateCaste);
router.put("/updateSubCaste", religionMasterController.updateSubCaste);
router.put("/updateGotra", religionMasterController.updateGotra);
router.delete("/deleteReligion/:religion",religionMasterController.deleteReligion);
router.delete("/deleteCaste/:caste/:religion",religionMasterController.deleteCaste);
router.delete("/deleteSubCaste/:subCaste/:religion/:caste",religionMasterController.deleteSubCaste);
router.delete("/deleteGotra/:gotra/:religion/:caste/:subCaste",religionMasterController.deleteGotra);
router.get("/getAll", religionMasterController.getAll);
router.put("/update", religionMasterController.update);
router.delete("/delete/:_id", religionMasterController.delete);

module.exports = router;

