const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const User = require('../models/user');
const Request = require('../models/request');

router.post('/send-request', passport.authenticate('jwt', { session: false }), (req, res) => {
  let request = new Request({
    from: req.body.from,
    officeId: req.body.officeId,
    requestAmt: req.body.requestAmt
  });

  Request.addRequest(request, (err, respRequest) => {
    if (err) {
      res
        .status(200)
        .json({ success: false, msg: 'Error in sending request', err: err });
    } else {
      if (respRequest) {
        res
          .status(200)
          .json({ success: true, msg: 'Request send successfully..' });
      } else {
        res.status(200).json({ success: false, msg: 'Request not sent..' });
      }
    }
  });
});

router.get('/get-all-requests', passport.authenticate('jwt', { session: false }), (req, res) => {
  Request.getAllRequests((err, requests) => {
    if (err) {
      res
        .status(200)
        .json({ success: false, msg: 'Error in fetching request', err: err });
    } else {
      res
        .status(200)
        .json({ success: true, msg: 'Requests are found', requests: requests });
    }
  });
});

module.exports = router;
