const express = require('express');
const router = express.Router();
const passport = require('passport');
const Activity = require('../models/ssactivity');

router.post(
    '/getActivity/:id',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const id = req.params.id;
        const usernames = req.body.usernames;
        Activity.getActivityById(id, usernames, (err, activity) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                if (activity) {
                    res
                        .status(200)
                        .json({ success: true, msg: 'activity are found', data: activity });
                } else {
                    res
                        .status(200)
                        .json({ success: false, msg: 'activity not found', data: activity });
                }
            }
        });
    }
);

router.post(
    '/getActivities/:skip',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const skip = (req.params.skip * 100) - 100;
        const usernames = req.body.usernames;
        const data = req.body.data;
        Activity.getAllActivities(skip, usernames, data, (err, activities) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                if (activities.length) {
                    res
                        .status(200)
                        .json({ success: true, msg: 'activities are found', data: activities });
                } else {
                    res
                        .status(200)
                        .json({ success: false, msg: 'activities not found', data: activities });
                }
            }
        });
    }
);

router.post(
    '/searchActivities/:keyword/:skip',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const searchKeyword = new RegExp(req.params.keyword, 'gi');
        const skip = (req.params.skip * 20) - 20;
        const usernames = req.body.usernames;
        const data = req.body.data;
        Activity.searchInActivities(searchKeyword, skip, usernames, data, (err, activities) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                if (activities.length) {
                    res
                        .status(200)
                        .json({ success: true, msg: 'activities are found', data: activities });
                } else {
                    res
                        .status(200)
                        .json({ success: false, msg: 'activities not found', data: activities });
                }
            }
        });
    }
);

router.post(
    '/searchActivitiesByUser/:keyword/:skip',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const searchKeyword = new RegExp(req.params.keyword, 'gi');
        const skip = (req.params.skip * 20) - 20;
        const usernames = req.body.usernames;
        const data = req.body.data;
        Activity.searchInActivitiesByUser(searchKeyword, skip, usernames, data, (err, activities) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                if (activities.length) {
                    res
                        .status(200)
                        .json({ success: true, msg: 'activities are found', data: activities });
                } else {
                    res
                        .status(200)
                        .json({ success: false, msg: 'activities not found', data: activities });
                }
            }
        });
    }
);

router.post(
    '/searchActivitiesByMemberID/:keyword/:skip',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const searchKeyword = new RegExp(req.params.keyword, 'gi');
        const skip = (req.params.skip * 20) - 20;
        const usernames = req.body.usernames;
        const data = req.body.data;
        Activity.searchInActivitiesByMemberID(searchKeyword, skip, usernames, data, (err, activities) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Something went wrong', err: err });
            } else {
                if (activities.length) {
                    res
                        .status(200)
                        .json({ success: true, msg: 'activities are found', data: activities });
                } else {
                    res
                        .status(200)
                        .json({ success: false, msg: 'activities not found', data: activities });
                }
            }
        });
    }
);

module.exports = router;